'*****************************************
'*      Reality's End Presents....       *
'*****************************************
'*          K  I  L  L  I  N  '          *
'*****************************************
'*Copyright (C) Jaret Cantu 1999-2001    *
'*E-Mail:                                *
'* mintman@realitysend.com               *
'*Web Site:                              *
'* http://www.realitysend.com            *
'*****************************************
'*  See the main module for details.     *
'*****************************************
'********************** Press F5 to Play *
'*****************************************

COMMON SHARED file$
'Type used for the Player, Enemies, Items, and Watchmen
TYPE CHARACTER
   role AS STRING * 12
   align AS STRING * 1 ' "g" = good, "e" = evil, "l" = leader, "i" = item
   health AS INTEGER
   curhealth AS INTEGER
   special AS INTEGER
   curspecial AS INTEGER
   strength AS INTEGER
   speed AS SINGLE
   x AS INTEGER
   y AS INTEGER
   dir AS STRING * 1 ' "l" = left, "r" = right, "u" = up
   col AS INTEGER
   char AS STRING * 1
   leap AS INTEGER
   foot AS INTEGER
   weapcol AS INTEGER
   weapl AS STRING * 1
   weapr AS STRING * 1
   weapu AS STRING * 1
   weapwave AS STRING * 1 ' music of one note only when character attacks
   specialattack AS INTEGER
   attackwait AS SINGLE
   status AS STRING * 1 ' " " = no status, "j" = jumping, "x" = attacking, "d" = descending, "s" = special
   oldstatus AS STRING * 1 ' same as status
   items AS SINGLE ' This takes the postion of the "ones" into account
END TYPE
DECLARE SUB makecharacter (char AS CHARACTER, role AS STRING, align AS STRING, health AS INTEGER, strength AS INTEGER, special AS INTEGER, speed AS SINGLE, x AS INTEGER, y AS INTEGER, col AS INTEGER, chr AS STRING, dir AS STRING, leap AS INTEGER, weapcol AS INTEGER, weapl AS STRING, weapr AS STRING, weapu AS STRING, weapwave AS STRING)
DECLARE SUB makeplayer (char AS CHARACTER, role AS STRING, x AS INTEGER, y AS INTEGER)
DECLARE SUB makeenemy (char AS CHARACTER, role AS STRING, x AS INTEGER, y AS INTEGER)
DECLARE SUB makeitem (item AS CHARACTER, role AS STRING, id AS SINGLE, x AS INTEGER, y AS INTEGER)
DECLARE SUB attack (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB damage (char AS CHARACTER, target AS CHARACTER)
DECLARE SUB endattack (char AS CHARACTER)
DECLARE SUB jump (char AS CHARACTER)
DECLARE SUB descend (char AS CHARACTER)
DECLARE SUB left (char AS CHARACTER)
DECLARE SUB right (char AS CHARACTER)
DECLARE SUB ram (char AS CHARACTER, target AS CHARACTER)
DECLARE SUB flight (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB fireball (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB waterfall (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB quake (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB main.control (char() AS CHARACTER, target() AS CHARACTER, bgindex AS INTEGER)
DECLARE SUB blob.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB scynscatha.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB mole.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB heart.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB sprite.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB spiker.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB knight.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB ghost.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB mage.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB scorpion.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB aracane.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB druid.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB phantom.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB fire.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB wind.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB water.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB earth.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB watchman.control (enemy() AS CHARACTER, player AS CHARACTER, bg AS INTEGER)
DECLARE SUB getitem (item AS CHARACTER, char AS CHARACTER)
DECLARE SUB waiter ()
DECLARE SUB stopfor (waitin AS DOUBLE)
DECLARE SUB bind (char AS CHARACTER)
DECLARE SUB message (quote AS STRING, col AS INTEGER)
DECLARE SUB slowPRINT (quote AS STRING)
DECLARE SUB construct (l AS INTEGER, t AS INTEGER, r AS INTEGER, b AS INTEGER, col AS INTEGER)
DECLARE SUB background (scene AS INTEGER, char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB fadeeffect ()
DECLARE FUNCTION yesno$ (col%)
DECLARE SUB calibrate ()
DECLARE SUB controls ()
DECLARE SUB load (char AS CHARACTER, scene%)
DECLARE SUB save (char AS CHARACTER, scene%)
'declare major variables
DIM player(1 TO 1) AS CHARACTER '1 to 1 for purposes of enemies using attacks
DIM enemy(1 TO 2) AS CHARACTER
makeplayer player(1), "Seth", 11, 10 ' 7 and 14 are the debugging value
bgindex% = -4 '-4 is default: this is for debugging purposes only; do not use it to skip ahead in the level for your character will be too weak
DIM SHARED dirup AS INTEGER
DIM SHARED dirright AS INTEGER
DIM SHARED dirdown AS INTEGER
DIM SHARED dirleft AS INTEGER
OPEN "killin/joystick.kil" FOR INPUT AS #1
INPUT #1, dirup, dirright, dirdown, dirleft
CLOSE #1
'begin the game
SCREEN 13
'check for file$ chained variable
IF file$ = "" OR file$ = "0" THEN RUN "killin/killina.bas"
load player(1), bgindex%
background bgindex%, player(1), enemy()
COLOR player(1).col
LOCATE player(1).y, player(1).x
PRINT player(1).char
'begin the game
IF player(1).role = "Seth        " THEN
   DO
      main.control player(), enemy(), bgindex%
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0 OR player(1).role <> "Seth        "
END IF
IF player(1).role = "Water       " THEN
   DO
      water.control player(1), enemy()
      main.control player(), enemy(), bgindex%
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0
END IF
IF player(1).role = "Earth       " THEN
   DO
      earth.control player(1), enemy()
      main.control player(), enemy(), bgindex%
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0
END IF
IF player(1).role = "Wind        " THEN
   DO
      wind.control player(1), enemy()
      main.control player(), enemy(), bgindex%
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0
END IF
IF player(1).role = "Fire        " THEN
   DO
      fire.control player(1), enemy()
      main.control player(), enemy(), bgindex%
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0
END IF
IF player(1).role <> "Seth        " OR player(1).role <> "Fire        " OR player(1).role <> "Wind        " OR player(1).role <> "Earth       " OR player(1).role <> "Water       " THEN
   DO
      main.control player(), enemy(), bgindex%
      IF STRIG(1) AND STRIG(5) THEN
      IF player(1).role = "Blob        " THEN blob.control player(1), enemy()
      IF player(1).role = "Spiker      " THEN spiker.control player(1), enemy()
      IF player(1).role = "Knight      " THEN knight.control player(1), enemy()
      IF player(1).role = "Ghost       " THEN ghost.control player(1), enemy()
      IF player(1).role = "Sprite      " THEN sprite.control player(1), enemy()
      IF player(1).role = "Aracane     " THEN aracane.control player(1), enemy()
      IF player(1).role = "Mage        " THEN mage.control player(1), enemy()
      IF player(1).role = "Scynscatha  " THEN scynscatha.control player(1), enemy()
      IF player(1).role = "Mole        " THEN mole.control player(1), enemy()
      IF player(1).role = "JackOfHearts" THEN heart.control player(1), enemy()
      IF player(1).role = "Scorpion    " THEN scorpion.control player(1), enemy()
      IF player(1).role = "Druid       " THEN druid.control player(1), enemy()
      IF player(1).role = "Phantom     " THEN phantom.control player(1), enemy()
      END IF
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0
END IF
fadeeffect
COLOR 15 'set "Press any key to continue" to readable color
END

SUB aracane.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF target(1).y < char.y THEN
            jump char
            IF SCREEN(char.y + 1, char.x) <> 219 OR SCREEN(char.y, char.x + 1) <> 219 OR SCREEN(char.y - 1, char.x) <> 219 OR SCREEN(char.y, char.x - 1) <> 219 THEN char.status = "j"
            ram char, target(1)
         ELSEIF target(1).y > char.y THEN
            descend char
            IF SCREEN(char.y + 1, char.x) <> 219 OR SCREEN(char.y, char.x + 1) <> 219 OR SCREEN(char.y - 1, char.x) <> 219 OR SCREEN(char.y, char.x - 1) <> 219 THEN char.status = "d"
            ram char, target(1)
         ELSEIF target(1).x < char.x THEN
            left char
            IF SCREEN(char.y + 1, char.x) = 219 OR SCREEN(char.y, char.x + 1) = 219 OR SCREEN(char.y - 1, char.x) = 219 OR SCREEN(char.y, char.x - 1) = 219 THEN char.status = "d"
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            IF SCREEN(char.y + 1, char.x) = 219 OR SCREEN(char.y, char.x + 1) = 219 OR SCREEN(char.y - 1, char.x) = 219 OR SCREEN(char.y, char.x - 1) = 219 THEN char.status = "d"
            ram char, target(1)
         END IF
      ELSEIF char.status = "j" THEN
         jump char
         IF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
         IF SCREEN(char.y + 1, char.x) = 219 OR SCREEN(char.y, char.x + 1) = 219 OR SCREEN(char.y - 1, char.x) = 219 OR SCREEN(char.y, char.x - 1) = 219 THEN char.status = " "
         ram char, target(1)
      ELSEIF char.status = "d" THEN
         descend char
         IF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
         IF SCREEN(char.y + 1, char.x) = 219 OR SCREEN(char.y, char.x + 1) = 219 OR SCREEN(char.y - 1, char.x) = 219 OR SCREEN(char.y, char.x - 1) = 219 THEN char.status = " "
         ram char, target(1)
      END IF
   END IF
END SUB

SUB attack (char AS CHARACTER, target() AS CHARACTER)
   ' This controls the standard melee attack for both players
   ' and leaders.
   char.oldstatus = char.status
   IF char.dir = "l" THEN
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x - 1 AND target(enemy).y = char.y AND target(enemy).status <> "s" THEN
            left target(enemy)
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y, char.x - 1) = 219 THEN EXIT SUB
      COLOR char.weapcol
      LOCATE char.y, char.x - 1
      PRINT char.weapl
   ELSEIF char.dir = "r" THEN
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x + 1 AND target(enemy).y = char.y AND target(enemy).status <> "s" THEN
            right target(enemy)
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y, char.x + 1) = 219 THEN EXIT SUB
      COLOR char.weapcol
      LOCATE char.y, char.x + 1
      PRINT char.weapr
   ELSEIF char.dir = "u" THEN
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x AND target(enemy).y = char.y - 1 AND target(enemy).status <> "s" THEN
            jump target(enemy)
            target(enemy).status = "d"
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y - 1, char.x) = 219 THEN EXIT SUB
      COLOR char.weapcol
      LOCATE char.y - 1, char.x
      PRINT char.weapu
   END IF
   PLAY "mbmst300o2l64" + char.weapwave
   char.attackwait = TIMER + .2
   char.status = "x"
END SUB

SUB background (scene AS INTEGER, char AS CHARACTER, target() AS CHARACTER)
   'This exists only to reduce the size of background()
   CLS 0
   char.x = ABS(char.x - 40) + 1 'this will put the character on the correct side of the screen
   COLOR 15
   'This creates the default box at the top of every scene.
   '               1         2         3         4
   '      1234567890123456789012345678901234567890
   PRINT "ͻ" '1
   PRINT "K I L L I N '                         " '2
   PRINT "Ķ" '3
   PRINT "                                      " '4
   PRINT " Health:     Special:                 " '5
   PRINT "Ķ" '6
   PRINT "                                      " '7
   PRINT "ͼ" '8
   LOCATE 4, 2
   PRINT char.role
   LOCATE 5, 11
   PRINT USING "##"; char.curhealth
   LOCATE 5, 24
   PRINT USING "##"; char.curspecial
   makecharacter target(1), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   makecharacter target(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   ' begin backgrounds
   SELECT CASE scene
   CASE 55
      construct 1, 20, 35, 23, 2
      construct 36, 20, 40, 23, 91
      construct 20, 11, 21, 11, 6
      construct 20, 14, 21, 14, 6
      construct 20, 17, 21, 17, 6
      construct 24, 11, 25, 11, 6
      construct 24, 14, 25, 14, 6
      construct 24, 17, 25, 17, 6
      construct 28, 11, 29, 11, 6
      construct 28, 14, 29, 14, 6
      construct 28, 17, 29, 17, 6
      construct 32, 11, 33, 11, 6
      construct 32, 14, 33, 14, 6
      construct 32, 17, 33, 17, 6
      construct 36, 11, 37, 11, 6
      construct 36, 14, 37, 14, 6
      construct 36, 17, 37, 17, 6
      makeenemy target(1), "Knight", 15, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Knight", 37, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
      DO WHILE char.x < 5
         right char
         stopfor .1
      LOOP
      construct 1, 10, 2, 19, 2
   CASE 56
      COLOR 91
      FOR count = 1 TO 40
         FOR count2 = 20 - count \ 9 TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      makeenemy target(1), "Knight", 20, 17
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 35, 14
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 57
      construct 1, 16, 13, 23, 91
      construct 14, 14, 26, 23, 91
      construct 27, 16, 40, 17, 91
      construct 27, 22, 40, 23, 91
      makeenemy target(1), "Ghost", 35, char.y
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 5, 1) <> "1" THEN
         makeitem target(2), "Potion", .001, 27, 21
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 58
      construct 1, 16, 5, 17, 91
      construct 36, 16, 40, 17, 91
      FOR count = 1 TO 20
         FOR count2 = 22 - count \ 5 TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      FOR count = 21 TO 40
         FOR count2 = 18 + (count - 17) \ 5 TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      makeenemy target(1), "Spiker", 5, 15
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 36, 15
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 59
      construct 1, 16, 8, 17, 91
      construct 1, 22, 8, 23, 91
      COLOR 91
      FOR count = 9 TO 40
         FOR count2 = 16 + count \ 6 TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      makeenemy target(1), "Ghost", 3, 20
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 38, 21
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 60
      construct 1, 22, 10, 23, 91
      FOR count = 11 TO 29
         FOR count2 = 22 - (count - 10) \ 2 TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      FOR count = 30 TO 40
         FOR count2 = 13 + (count - 29) \ 2 TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      makeenemy target(1), "Ghost", 29, 12
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 23, 15
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 61
      COLOR 91
      FOR count = 1 TO 10
         FOR count2 = 18 - INT((count - 1) / 1.5) TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      FOR count = 11 TO 25
         FOR count2 = 12 + INT((count - 9) / 1.5) TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      FOR count = 26 TO 33
         FOR count2 = 22 - (count - 25) TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      FOR count = 34 TO 40
         FOR count2 = 14 + (count - 33) TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      LOCATE 20, 40
      PRINT ""
      makeenemy target(1), "Ghost", 10, 11
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 33, 13
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 62
      construct 1, 20, 40, 23, 91
      construct 15, 12, 25, 13, 115
      construct 10, 16, 17, 17, 115
      construct 23, 16, 30, 17, 115
      makeenemy target(1), "Sprite", 19, 19
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 6, 1) <> "1" THEN
         makeitem target(2), "Ether", .0001, 20, 11
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 63
      construct 16, 20, 22, 23, 91
      construct 23, 14, 24, 23, 91
      construct 28, 16, 40, 17, 115
      construct 31, 14, 40, 15, 115
      construct 19, 12, 24, 13, 91
      construct 24, 20, 40, 23, 91
      FOR count = 1 TO 15
         FOR count2 = 21 - count \ 3 TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      makeenemy target(1), "Spiker", 16, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 20, 11
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 64
      construct 1, 14, 31, 17, 115
      construct 1, 20, 40, 23, 91
      construct 37, 14, 40, 19, 91
      construct 35, 12, 40, 13, 91
      makeenemy target(1), "Spiker", 30, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 20, char.y
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 65
      construct 1, 12, 2, 23, 91
      construct 3, 20, 38, 23, 91
      construct 39, 10, 40, 23, 91
      makeenemy target(1), "Scynscatha", 30, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      PLAY "mbmst300o2l16gfgfgfedgfgfgedec.."
      DO
         right char
         descend char
         stopfor .1
      LOOP WHILE char.foot < 19
      message "How will you fare", target(1).col
      WHILE PLAY(0) > 5: WEND
      message "against my little pet?", target(1).col
      FOR count = 25 TO 16 STEP -1
         COLOR count
         LOCATE target(1).y, target(1).x
         PRINT target(1).char
         stopfor .1
      NEXT
      makeenemy target(1), "Scorpion", 30, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      construct 1, 10, 2, 11, 91
      WHILE PLAY(0) > 0: WEND
   CASE 66
      construct 1, 20, 35, 23, 91
      construct 36, 20, 40, 23, 2
      construct 36, 10, 40, 12, 2
      construct 39, 13, 40, 14, 6
      construct 39, 18, 40, 19, 6
      makeenemy target(1), "Ghost", 20, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 30, 15
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
      saveit = 0
      DO WHILE char.x < 5
         saveit = 1
         right char
         stopfor .1
      LOOP
      construct 1, 10, 2, 19, 91
      IF saveit THEN save char, scene
   CASE 67
      construct 1, 20, 40, 23, 2
      construct 1, 10, 40, 12, 2
      construct 1, 13, 2, 14, 6
      construct 1, 18, 2, 19, 6
      construct 11, 13, 12, 13, 6
      construct 11, 17, 12, 19, 6
      construct 22, 13, 23, 14, 6
      construct 22, 18, 23, 19, 6
      construct 36, 13, 37, 15, 6
      construct 36, 19, 37, 19, 6
      makeenemy target(1), "Aracane", 22, 17
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 18, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 68
      construct 1, 20, 40, 23, 2
      construct 1, 10, 40, 12, 2
      construct 5, 13, 6, 15, 6
      construct 5, 19, 6, 19, 6
      construct 15, 13, 16, 13, 6
      construct 15, 17, 18, 17, 6
      construct 15, 18, 16, 19, 6
      construct 25, 13, 26, 15, 6
      construct 25, 19, 26, 19, 6
      construct 35, 13, 36, 14, 6
      construct 35, 18, 36, 19, 6
      makeenemy target(1), "Aracane", 23, 17
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 17, 19
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 69
      construct 1, 20, 40, 23, 2
      construct 1, 10, 16, 12, 2
      construct 17, 12, 18, 12, 2
      construct 21, 10, 40, 12, 2
      construct 6, 13, 7, 14, 6
      construct 6, 18, 7, 19, 6
      construct 15, 13, 15, 16, 120
      construct 15, 17, 16, 17, 120
      construct 21, 13, 21, 14, 120
      construct 20, 15, 21, 15, 120
      construct 33, 13, 34, 14, 6
      construct 33, 18, 34, 19, 6
      makeenemy target(1), "Aracane", 18, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 7, 1) <> "1" THEN
         makeitem target(2), "Potion", .00001, 17, 11
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 70
      construct 1, 20, 20, 23, 2
      construct 1, 10, 21, 12, 2
      construct 7, 13, 8, 14, 6
      construct 7, 18, 8, 19, 6
      construct 14, 16, 15, 19, 6
      construct 19, 23, 40, 23, 6
      construct 20, 22, 40, 22, 6
      construct 21, 21, 40, 21, 6
      construct 21, 19, 21, 20, 6
      construct 22, 16, 23, 20, 6
      construct 22, 10, 23, 13, 6
      makeenemy target(1), "Aracane", 30, 20
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Aracane", 16, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 71
      construct 1, 21, 40, 23, 6
      construct 7, 16, 7, 16, 6
      construct 33, 16, 33, 16, 6
      construct 19, 12, 21, 12, 6
      construct 15, 15, 25, 15, 6
      construct 14, 15, 14, 17, 6
      construct 26, 15, 26, 17, 6
      makeenemy target(1), "Knight", 20, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Aracane", 20, 20
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 72
      construct 1, 21, 40, 23, 6
      construct 28, 14, 40, 17, 6
      construct 24, 16, 24, 16, 6
      construct 19, 16, 19, 16, 6
      construct 14, 13, 14, 13, 6
      makeenemy target(1), "Spiker", 21, 20
      makeenemy target(2), "Aracane", 14, 12
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 73
      construct 1, 21, 40, 23, 6
      construct 1, 14, 40, 17, 6
      IF MID$(STR$(char.items), 8, 1) <> "1" THEN
         makeitem target(1), "Ether", .000001, 21, 20
         COLOR target(1).col
         LOCATE target(1).y, target(1).x
         PRINT target(1).char
         makeitem target(2), "WingBoots", .000001, 20, 13
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 74
      construct 1, 14, 4, 17, 6
      construct 20, 20, 40, 23, 2
      construct 20, 10, 40, 12, 2
      construct 32, 13, 33, 14, 6
      construct 32, 18, 33, 19, 6
      construct 1, 23, 22, 23, 6
      construct 1, 22, 21, 22, 6
      construct 1, 21, 20, 21, 6
      construct 18, 16, 19, 20, 6
      construct 18, 10, 19, 13, 6
      makeenemy target(1), "Ghost", 9, 16
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Aracane", 24, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 75
      construct 1, 20, 40, 23, 2
      construct 1, 10, 40, 12, 2
      construct 11, 13, 12, 16, 6
      construct 18, 13, 19, 15, 6
      construct 18, 19, 19, 19, 6
      construct 25, 13, 26, 14, 6
      construct 25, 18, 26, 19, 6
      construct 32, 13, 33, 13, 6
      construct 32, 17, 33, 19, 6
      construct 39, 16, 40, 19, 6
      makeenemy target(1), "Spiker", 20, 19
      makeenemy target(2), "Aracane", 32, 16
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 76
      char.items = 0
      construct 1, 20, 40, 23, 2
      construct 1, 10, 40, 12, 2
      construct 1, 16, 2, 19, 6
      construct 10, 13, 11, 14, 6
      construct 10, 18, 11, 19, 6
      construct 20, 13, 21, 14, 6
      construct 20, 18, 21, 19, 6
      construct 30, 13, 31, 14, 6
      construct 30, 18, 31, 19, 6
      construct 39, 13, 40, 19, 6
      makeenemy target(1), "Druid", 30, 17
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      PLAY "mbmst300o2l16bbp32aap32ggo2cbcbe."
      DO
         right char
         descend char
         stopfor .1
      LOOP WHILE char.y < 19
      message "You have defeated the first general", target(1).col
      WHILE PLAY(0) > 5: WEND
      message "but you will not defeat me!", target(1).col
      construct 1, 13, 2, 15, 6
      WHILE PLAY(0) > 0: WEND
   CASE 77
      construct 1, 20, 40, 23, 2
      construct 1, 10, 35, 12, 2
      construct 10, 13, 11, 15, 6
      construct 10, 19, 11, 19, 6
      construct 20, 13, 21, 13, 6
      construct 20, 17, 21, 19, 6
      construct 30, 13, 31, 15, 6
      construct 30, 19, 31, 19, 6
      makeenemy target(1), "Aracane", 20, 16
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 29, 15
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
      saveit = 0
      DO WHILE char.x < 5
         saveit = 1
         right char
         stopfor .1
      LOOP
      construct 1, 13, 2, 19, 6
      IF saveit THEN save char, scene
   CASE 78
      COLOR 2
      FOR count = 1 TO 40
         FOR count2 = 23 TO 20 - (count - 1) \ 5 STEP -1
            LOCATE count2, count
            IF count < 20 OR count2 < 20 OR count2 > 22 THEN PRINT ""
         NEXT count2
      NEXT count
      makeenemy target(1), "Knight", 37, 12
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 3, 1) <> "1" THEN
         makeitem target(2), "Potion", .1, 21, 22
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 79
      construct 1, 23, 40, 23, 2
      FOR count = 1 TO 40
         FOR count2 = 13 + (count - 1) \ 8 TO 19
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      makeenemy target(1), "Blob", 25, 15
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Knight", 20, 22
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 80
      construct 1, 17, 10, 19, 2
      construct 1, 23, 15, 23, 2
      construct 16, 19, 40, 23, 2
      construct 39, 10, 40, 12, 8
      construct 37, 13, 40, 13, 8
      makeenemy target(1), "Ghost", 5, 21
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Knight", 38, 12
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 81
      construct 1, 19, 20, 23, 2
      construct 1, 10, 2, 12, 8
      construct 1, 13, 4, 13, 8
      construct 21, 22, 40, 23, 2
      construct 20, 14, 20, 18, 8
      construct 21, 17, 22, 17, 8
      makeenemy target(1), "Sprite", 30, 21
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Knight", 3, 12
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 82
      construct 1, 22, 24, 23, 2
      construct 25, 17, 40, 23, 2
      construct 25, 13, 25, 16, 8
      construct 22, 19, 22, 19, 8
      construct 19, 15, 19, 15, 8
      makeenemy target(1), "Aracane", 15, 21
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 25, 12
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 83
      construct 1, 17, 3, 23, 2
      construct 4, 23, 37, 23, 2
      construct 4, 19, 4, 19, 8
      construct 38, 13, 40, 23, 2
      construct 11, 17, 18, 17, 8
      construct 25, 15, 32, 15, 8
      makeenemy target(1), "Knight", 15, 22
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 28, 14
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 84
      construct 1, 13, 2, 23, 2
      FOR count = 3 TO 20
         FOR count2 = 13 + count \ 3 TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      construct 21, 13, 40, 23, 2
      makeenemy target(1), "Spiker", 20, 18
      makeenemy target(2), "Ghost", 34, 12
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 85
      construct 1, 13, 1, 18, 2
      FOR count = 2 TO 7
         FOR count2 = 11 + count TO 18
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      construct 40, 13, 40, 18, 2
      FOR count = 33 TO 39
         FOR count2 = 18 TO 52 - count STEP -1
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      construct 1, 19, 40, 23, 2
      IF MID$(STR$(char.items), 4, 1) <> "1" THEN
         makeenemy target(1), "Knight", 25, 18
         COLOR target(1).col
         LOCATE target(1).y, target(1).x
         PRINT target(1).char
         target(1).align = "l"
         message "Looking for something?", target(1).col
         makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      END IF
   CASE 86
      construct 1, 13, 3, 23, 2
      construct 4, 21, 37, 23, 2
      construct 38, 13, 40, 23, 2
      construct 8, 14, 13, 14, 8
      construct 18, 16, 23, 16, 8
      construct 28, 14, 33, 14, 8
      makeenemy target(1), "Spiker", 21, 15
      makeenemy target(2), "Ghost", 20, 20
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 87
      construct 1, 13, 2, 23, 2
      construct 3, 20, 38, 23, 2
      construct 39, 10, 40, 23, 2
      makeenemy target(1), "Scynscatha4", 30, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      PLAY "mbmst300o2l16gfgfgfedgfgfgedec.."
      DO
         right char
         descend char
         stopfor .1
      LOOP WHILE char.foot < 19
      message "This is getting tiring.", target(1).col
      construct 1, 10, 2, 12, 2
      WHILE PLAY(0) > 5: WEND
      message "Why won't you die already?", target(1).col
      WHILE PLAY(0) > 0: WEND
   CASE 88
      construct 1, 20, 26, 23, 2
      construct 27, 20, 40, 23, 16
      construct 39, 12, 40, 13, 16
      construct 37, 10, 37, 15, 16
      construct 38, 15, 40, 15, 16
      saveit = 0
      DO WHILE char.x < 5
         saveit = 1
         right char
         stopfor .1
      LOOP
      construct 1, 10, 2, 19, 2
      IF saveit THEN save char, scene
      IF char.x < 10 THEN
      DIM seth AS CHARACTER
      makeplayer seth, "Seth", char.x, char.y
      bind char
      char.x = char.x - 1
      char.y = char.y - 1
      char.char = CHR$(15)
      COLOR seth.col
      LOCATE seth.y, seth.x
      PRINT seth.char
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      message ".... What is going on? I don't", seth.col
      waiter
      message "see anything? There is just a void.", seth.col
      waiter
      message "It is the daemon's work. So greatly", char.col
      waiter
      message "has your world been distorted that", char.col
      waiter
      message "much of it no longer exists entirely", char.col
      waiter
      message "in your dimension.", char.col
      waiter
      message "But how will we reach the castle?", seth.col
      waiter
      message "The land is still here; you just", char.col
      waiter
      message "cannot see it.", char.col
      waiter
      message "Onward! Scynscatha awaits!", char.col
      char.y = seth.y
      char.x = seth.x
      char.char = seth.char
      bind char
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      END IF
   CASE 89
      construct 1, 20, 40, 23, 16
      construct 1, 12, 40, 13, 16
      construct 1, 15, 22, 15, 16
      construct 27, 18, 40, 19, 16
      makeenemy target(1), "Spiker", 27, 17
      makeenemy target(2), "Blob", 5, 14
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 90
      construct 1, 18, 5, 23, 16
      construct 1, 12, 34, 13, 16
      'construct 27, 18, 40, 19, 16
      construct 6, 22, 40, 23, 16
      FOR count = 1 TO 5 STEP 1
         construct 9 + count * 2, 22 - count, 14 + count * 2, 22 - count, 16
         construct 23 + count * 2, 22 - count, 40, 22 - count, 16
      NEXT
      makeenemy target(1), "Spiker", 19, 16
      makeenemy target(2), "Spiker", 33, 16
   CASE 91
      construct 1, 22, 40, 23, 16
      construct 39, 10, 40, 18, 16
      construct 1, 17, 4, 21, 16
      construct 5, 15, 7, 21, 16
      construct 8, 13, 10, 15, 16
      construct 8, 20, 10, 21, 16
      construct 11, 13, 35, 14, 16
      construct 10, 17, 38, 18, 16
      makeenemy target(1), "Spiker", 36, 16
      makeenemy target(2), "Spiker", 9, 19
   CASE 92
      construct 1, 22, 40, 23, 16
      construct 1, 10, 2, 18, 16
      construct 3, 18, 4, 18, 16
      construct 10, 15, 21, 21, 16
      construct 28, 14, 33, 14, 16
      makeenemy target(1), "Knight", 15, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 30, 21
   CASE 93
      construct 1, 22, 40, 23, 16
      construct 5, 17, 10, 17, 16
      construct 17, 13, 21, 21, 16
      construct 13, 13, 17, 13, 16
      construct 33, 11, 38, 11, 16
      construct 29, 14, 34, 14, 16
      construct 33, 17, 38, 17, 16
      makeenemy target(1), "Knight", 19, 12
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 4, 1) <> "1" THEN
         makeitem target(2), "Potion", .01, 37, 10
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 94
      construct 1, 22, 40, 23, 16
      construct 39, 10, 40, 19, 16
      FOR count = 1 TO 10
         construct count * 3, 22 - count, count * 3 + 6, 22 - count, 16
         IF count > 2 AND count < 8 THEN construct count * 3 + 16, 22 - count, 38, 22 - count, 16
      NEXT
      makeenemy target(1), "Sprite", 25, 21
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 37, 14
   CASE 95
      construct 1, 22, 40, 23, 16
      construct 1, 10, 2, 19, 16
      construct 3, 19, 10, 19, 16
      construct 36, 14, 40, 21, 16
      construct 16, 19, 31, 19, 16
      construct 16, 15, 20, 15, 16
      construct 26, 15, 31, 15, 16
      makeenemy target(1), "Spiker", 16, 18
      makeenemy target(2), "Spiker", 31, 18
   CASE 96
      construct 1, 22, 14, 23, 16
      construct 1, 14, 5, 21, 16
      construct 15, 22, 40, 23, 2
      construct 26, 13, 32, 13, 8
      construct 26, 17, 32, 17, 8
      construct 29, 14, 29, 16, 8
      construct 29, 17, 29, 21, 8
      makeenemy target(1), "Spiker", 26, 12
      makeenemy target(2), "Spiker", 32, 12
   CASE 97
      construct 1, 22, 40, 23, 2
      construct 6, 15, 15, 15, 8
      construct 25, 15, 34, 15, 8
      construct 19, 17, 21, 21, 2
      construct 39, 14, 40, 21, 2
      makeenemy target(1), "Spiker", 18, 21
      IF MID$(STR$(char.items), 5, 1) <> "1" THEN
         makeitem target(2), "Ether", .001, 8, 14
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 98
      construct 1, 14, 2, 23, 2
      construct 3, 20, 38, 23, 2
      construct 39, 10, 40, 23, 2
      makeenemy target(1), "Phantom", 30, 19
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      PLAY "mbmst300o2l32dp32dp32dp32dddd.dp32dp32dp32dddd.l8a.c.g.l4a.."
      DO
         right char
         descend char
         stopfor .1
      LOOP WHILE char.foot < 19
      message ".... someone is here. I can sense it.", char.col
      construct 1, 10, 2, 13, 2
      WHILE PLAY(0) > 6: WEND
      message "It would seem your friend gives you", target(1).col
      WHILE PLAY(0) > 3: WEND
      message "more than just combative abilities.", target(1).col
      WHILE PLAY(0) > 0: WEND
      message "Who are you? Where are you?", char.col
      waiter
      message "I am the instrument of your", target(1).col
      waiter
      message "destruction. The daemons created me", target(1).col
      waiter
      message "soley to slay you. You may have", target(1).col
      waiter
      message "defeated the other two generals,", target(1).col
      waiter
      message "but you will never get to Scyscatha!", target(1).col
   CASE 99
      construct 1, 20, 35, 23, 2
      construct 36, 20, 38, 20, 6
      construct 39, 10, 40, 15, 7
      construct 39, 20, 40, 23, 7
      makeenemy target(1), "Knight", 20, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Mage", 30, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
      saveit = 0
      DO WHILE char.x < 5
         saveit = 1
         right char
         stopfor .1
      LOOP
      construct 1, 10, 2, 19, 2
      IF saveit THEN save char, scene
      IF char.x < 10 THEN
      makeplayer seth, "Seth", char.x, char.y
      bind char
      char.x = char.x - 1
      char.y = char.y - 1
      char.char = CHR$(15)
      COLOR seth.col
      LOCATE seth.y, seth.x
      PRINT seth.char
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      message "Could it be? My castle!", seth.col
      waiter
      message "So this is where Scynscatha", char.col
      waiter
      message "has been hiding.", char.col
      waiter
      message "But why has he used my castle as his", seth.col
      waiter
      message "worldly stronghold?", seth.col
      waiter
      message "The fabric between the two worlds", char.col
      waiter
      message "grows weak in this location, making", char.col
      waiter
      message "travel easier. This has warped the", char.col
      waiter
      message "castle you once knew. Be prepared!", char.col
      char.y = seth.y
      char.x = seth.x
      char.char = seth.char
      bind char
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      message "Scynscatha... it ends here....", char.col
      END IF
   CASE 100
      construct 1, 20, 40, 23, 7
      construct 1, 10, 2, 15, 7
      construct 20, 10, 20, 12, 14
      construct 18, 13, 22, 13, 14
      construct 19, 14, 21, 14, 15
      makeenemy target(1), "Knight", 19, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 33, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 101
      construct 1, 20, 40, 23, 7
      construct 22, 10, 22, 17, 16
      construct 18, 15, 18, 19, 16
      makeenemy target(1), "Aracane", 19, 18
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Aracane", 23, 15
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 102
      construct 1, 20, 40, 23, 7
      construct 15, 16, 25, 16, 7
      construct 18, 12, 22, 12, 7
      construct 18, 10, 18, 11, 16
      makeenemy target(1), "Mage", 24, 15
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 6, 1) <> "1" THEN
         makeitem target(2), "Potion", .0001, 20, 11
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 103
      construct 1, 20, 40, 23, 7
      construct 34, 12, 36, 12, 1
      construct 35, 11, 35, 13, 1
      construct 36, 10, 36, 10, 1
      construct 33, 11, 33, 11, 1
      construct 34, 14, 34, 14, 1
      construct 37, 13, 37, 13, 1
      makeenemy target(1), "Ghost", 9, 18
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 104
      construct 1, 20, 40, 23, 7
      construct 3, 10, 3, 17, 16
      construct 38, 10, 38, 17, 16
      construct 6, 17, 19, 19, 16
      construct 21, 17, 35, 19, 16
      construct 4, 10, 6, 12, 16
      construct 8, 10, 20, 12, 16
      construct 17, 14, 22, 15, 16
      construct 17, 16, 19, 16, 16
      construct 4, 14, 15, 15, 16
      construct 34, 15, 35, 16, 16
      construct 21, 12, 32, 12, 16
      construct 24, 13, 32, 15, 16
      construct 37, 13, 37, 17, 16
      construct 21, 10, 37, 10, 16
      construct 34, 11, 35, 12, 16
      COLOR 8
      FOR count = 1 TO 40
         FOR count2 = 10 TO 19
            RANDOMIZE TIMER
            IF SCREEN(count2, count) = 219 AND INT(RND * 5) = 1 THEN
               LOCATE count2, count
               PRINT ""
            END IF
         NEXT
      NEXT
      makeenemy target(1), "Aracane", 20, 18
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Aracane", 37, 12
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 105
      construct 1, 20, 40, 23, 7
      stepper = 1
      COLOR
      FOR count = 1 TO 5
         construct 35 + count, 20 - stepper, 35 + count, 19, 7
         PRINT ""
         stepper = stepper * 2
         IF stepper > 8 THEN stepper = 8
      NEXT
      makeenemy target(1), "Mage", 15, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Mage", 30, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 106
      construct 1, 21, 40, 23, 7
      construct 1, 12, 2, 20, 7
      construct 3, 15, 5, 15, 7
      construct 34, 12, 36, 12, 1
      construct 35, 11, 35, 13, 1
      construct 36, 10, 36, 10, 1
      construct 33, 11, 33, 11, 1
      construct 34, 14, 34, 14, 1
      construct 37, 13, 37, 13, 1
      IF MID$(STR$(char.items), 7, 1) <> "1" THEN
         makeitem target(1), "Ether", .00001, 3, 20
         COLOR target(1).col
         LOCATE target(1).y, target(1).x
         PRINT target(1).char
      END IF
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 107
      construct 1, 21, 40, 23, 7
      construct 25, 10, 26, 17, 7
      construct 25, 18, 26, 20, 6
      construct 5, 14, 9, 14, 8
      construct 13, 17, 14, 17, 8
      makecharacter target(1), "null", "", 1, 0, 0, 0, 7, 13, 8, "/", "", 0, 0, "", "", "", ""
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 108
      construct 1, 21, 40, 23, 7
      construct 5, 13, 34, 13, 8
      construct 5, 17, 13, 17, 8
      construct 16, 17, 24, 17, 8
      construct 27, 17, 34, 17, 8
      makeenemy target(1), "Mage", 6, 20
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Mage", 33, 16
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 109
      construct 1, 21, 40, 23, 7
      construct 16, 10, 24, 13, 8
      construct 17, 14, 19, 15, 8
      construct 21, 14, 23, 15, 8
      COLOR 74
      LOCATE 12, 20
      PRINT CHR$(21)
      WHILE char.x < 5 AND char.y < 21
         right char
         descend char
         stopfor .1
      WEND
      construct 1, 10, 2, 20, 7
      makeitem target(1), "Potion", 0, 20, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 110
      construct 1, 21, 40, 23, 7
      FOR count = 0 TO 19
         LOCATE 20 - count \ 4, 20 + count
         PRINT STRING$(21 - count, 219)
      NEXT
      COLOR 111
      LOCATE 15, 38
      PRINT ""
      LOCATE 14, 39
      PRINT ""
      makeenemy target(1), "Scynscatha5", 38, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      PLAY "mbmst300o2l16gfgfgfedgfgfgedec.."
      '        12345678901234567890123456789012345678
      message "So, you have made all this way.", target(1).col
      DO
         right char
         descend char
         stopfor .1
      LOOP WHILE char.foot < 21 AND char.x < 5
      WHILE PLAY(0) > 5: WEND
      message "I should be disappointed that you", target(1).col
      waiter
      message "lived but cannot help to enjoy the", target(1).col
      waiter
      message "fact that I shall kill you myself.", target(1).col
      waiter
      message "This ends here, Scynscatha.", char.col
      waiter
      message "Will it? Once, long ago, a prophet", target(1).col
      waiter
      message "told me to beware that another daemon", target(1).col
      waiter
      message "would be the end of me. But look at", target(1).col
      waiter
      message "you now, clinging on to your life and", target(1).col
      waiter
      message "your beliefs with, what now, only four", target(1).col
      waiter
      message "remaining, now so desperate, that you", target(1).col
      waiter
      message "are using mortals as vessels.", target(1).col
      waiter
      message "Daemons... you mean... this is a...", char.col
      waiter
      message "Daemon, just like myself, only these", target(1).col
      waiter
      message "ones opposed our ways.", target(1).col
      waiter
      message "What ways would those be?", char.col
      waiter
      message "To live only to conquer.", target(1).col
      waiter
      message "To make our race the most powerful", target(1).col
      waiter
      message "and destroy those who go against us.", target(1).col
      waiter
      right char
      message "You monster!", char.col
      waiter
      left target(1)
      descend target(1)
      message "Please, you flatter me.", target(1).col
      waiter
      message "Now, let destiny take its course!", target(1).col
      LOCATE 15, 38
      PRINT "  "
      LOCATE 14, 39
      PRINT " "
      FOR col% = 27 TO 16 STEP -1
         IF col% <> 16 THEN
            COLOR col%
         ELSE
            COLOR 0
         END IF
         FOR count = -10 TO 40
            FOR count2 = 10 TO 20
               IF count - 9 + (30 - count2) >= 3 AND count - 9 + (30 - count2) <= 38 THEN
                  IF col% = 16 AND count - 9 + (30 - count2) = target(1).x THEN
                     descend target(1)
                     stopfor .01
                     COLOR 0
                  END IF
                  IF SCREEN(count2, count - 9 + (30 - count2)) <> 32 AND NOT (count2 = char.y AND count - 9 + (30 - count2) = char.x) AND NOT (count2 = target(1).y AND count - 9 + (30 - count2) = target(1).x) THEN
                     LOCATE count2, count - 9 + (30 - count2)
                     PRINT CHR$(SCREEN(count2, count - 9 + (30 - count2)))
                  END IF
               END IF
            NEXT
         NEXT
      NEXT
      descend target(1)
      target(1).foot = 20
      construct 1, 10, 2, 20, 7
      construct 39, 10, 40, 20, 7
      construct 3, 10, 38, 10, 7
      PLAY "mbmst300o2l64" + target(1).weapwave
   END SELECT
END SUB

SUB bind (char AS CHARACTER)
' This holds the special effect of binding and unbinding the character to and
' from the elemental.
   FOR flash% = 1 TO 25
      RANDOMIZE TIMER
      xaxis% = INT(RND * 3) - 1
      yaxis% = INT(RND * 3) - 1
      IF SCREEN(char.y + yaxis%, char.x + xaxis%) <> 219 AND NOT (xaxis% = 0 AND yaxis% = 0) THEN
         COLOR char.col
         LOCATE char.y + yaxis%, char.x + xaxis%
         IF SCREEN(char.y + yaxis%, char.x + xaxis%) <> 15 THEN
            PRINT CHR$(15)
         ELSE
            PRINT " "
         END IF
      END IF
      stopfor .05
      IF flash% MOD 3 = 0 THEN PLAY "mbmst700o2l64" + char.weapwave
   NEXT
   FOR count% = -1 TO 1
      FOR count2% = -1 TO 1
         IF SCREEN(char.y + count%, char.x + count2%) = 15 THEN
            LOCATE char.y + count%, char.x + count2%
            PRINT " "
         END IF
      NEXT
   NEXT
END SUB

SUB blob.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF target(1).y < char.y AND (target(1).x >= char.x - 3 AND target(1).x <= char.x + 3 OR target(1).y < char.y AND SCREEN(char.y, char.x - 1) = 219 OR SCREEN(char.y, char.x + 1) = 219) THEN
            jump char
            char.status = "j"
            ram char, target(1)
         ELSEIF target(1).x < char.x THEN
            left char
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            ram char, target(1)
         END IF
      ELSEIF char.status = "j" THEN
         jump char
         IF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
         ram char, target(1)
      ELSEIF char.status = "d" THEN
         descend char
         IF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
         ram char, target(1)
      END IF
   END IF
END SUB

SUB calibrate
   CLS 0
   WHILE STRIG(1) = -1 OR STRIG(5) = -1: WEND
   COLOR 15
   LOCATE 1, 1
   PRINT "Center joystick and press button (that"
   PRINT "means hold no directions)"
   WHILE STRIG(1) = 0 AND STRIG(5) = 0: WEND
   centery% = STICK(1)
   centerx% = STICK(0)
   WHILE STRIG(1) = -1 OR STRIG(5) = -1: WEND
   PRINT
   PRINT "Position your joystick toward the upper"
   PRINT "left cornor and press a button"
   WHILE STRIG(1) = 0 AND STRIG(5) = 0: WEND
   up% = STICK(1)
   jsleft% = STICK(0)
   WHILE STRIG(1) = -1 OR STRIG(5) = -1: WEND
   PRINT
   PRINT "Position your joystick toward the lower"
   PRINT "right cornor and press a button"
   WHILE STRIG(1) = 0 AND STRIG(5) = 0: WEND
   down% = STICK(1)
   jsright% = STICK(0)
   dirup = (up% + centery%) / 2
   dirdown = (centery% + down%) / 2
   dirleft = (jsleft% + centerx%) / 2
   dirright = (centerx% + jsright%) / 2
   WHILE STRIG(1) = -1 OR STRIG(5) = -1: WEND
   PRINT
   PRINT "Joystick calibrated. You may view your"
   PRINT "configurations by going to View Controls"
   PRINT "at the main menu."
   OPEN "killin/joystick.kil" FOR OUTPUT AS #1
   WRITE #1, dirup, dirright, dirdown, dirleft
   CLOSE #1
   LOCATE 23, 1
   PRINT "Press any key or button to continue"
   WHILE INKEY$ = "" AND STRIG(1) = 0 AND STRIG(5) = 0: WEND
   CLS 0
END SUB

SUB construct (l AS INTEGER, t AS INTEGER, r AS INTEGER, b AS INTEGER, col AS INTEGER)
   ' Creates blocks for the background.
   COLOR col


   FOR count = t TO b
      FOR count2 = l TO r
         LOCATE count, count2
         PRINT ""
      NEXT count2
   NEXT count
END SUB

SUB controls
   'Displays controls and shows when a button is being pressed
   CLS 0
   COLOR 15
   LOCATE 1, 1
   PRINT "[ ] Left", "Move character left"
   PRINT "[ ] Right", "Move character right"
   PRINT "[ ] Up", "Aim weapon up"
   PRINT "[ ] Button 1", "Attack"
   PRINT "[ ] Button 2", "Jump"
   PRINT "[ ] B1 + B2", "Special Attack"
   LOCATE 23, 2
   PRINT "Press Escape to exit test"
   COLOR 4
   WHILE INKEY$ <> CHR$(27)
      IF STICK(1) < dirup THEN
         LOCATE 3, 2
         PRINT "*"
      ELSEIF STICK(1) > dirup THEN
         LOCATE 3, 2
         PRINT " "
      END IF
      IF STICK(0) < dirleft THEN
         LOCATE 1, 2
         PRINT "*"
      ELSEIF STICK(0) > dirleft THEN
         LOCATE 1, 2
         PRINT " "
      END IF
      IF STICK(0) > dirright THEN
         LOCATE 2, 2
         PRINT "*"
      ELSEIF STICK(0) < dirright THEN
         LOCATE 2, 2
         PRINT " "
      END IF
      IF STRIG(1) = -1 THEN
         LOCATE 4, 2
         PRINT "*"
      ELSE
         LOCATE 4, 2
         PRINT " "
      END IF
      IF STRIG(5) = -1 THEN
         LOCATE 5, 2
         PRINT "*"
      ELSE
         LOCATE 5, 2
         PRINT " "
      END IF
      IF STRIG(1) = -1 AND STRIG(5) = -1 THEN
         LOCATE 6, 2
         PRINT "*"
      ELSE
         LOCATE 6, 2
         PRINT " "
      END IF
   WEND
   CLS 0
END SUB

SUB damage (char AS CHARACTER, target AS CHARACTER)
   ' This does damage for normal attacks and special attacks.
   target.curhealth = target.curhealth - char.strength
   COLOR 15
   IF target.align = "g" THEN
      LOCATE 5, 11
      PRINT USING "##"; target.curhealth
   END IF
   IF target.curhealth <= 0 THEN
      LOCATE target.y, target.x
      PRINT " "
      IF target.align = "e" THEN
         PLAY "mbmst300o2l64gf"
         message RTRIM$(target.role) + " was killed.", target.col
         makecharacter target, "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      ELSEIF target.align = "g" THEN
         LOCATE 5, 11
         PRINT " 0"
         message RTRIM$(target.role) + " was killed.", target.col
         makecharacter target, "", "", 0, 0, 0, 0, 0, 0, 0, "", "", 0, 0, "", "", "", ""
      ELSEIF target.align = "i" THEN
         COLOR target.col
         LOCATE target.y, target.x
         PRINT target.char
      END IF
   END IF
END SUB

SUB descend (char AS CHARACTER)
   ' Move the character down and decide whether ground is beneath
   ' the character or not to return the status to normal.
   LOCATE char.y, char.x
   PRINT " "
   char.y = char.y + 1
   IF SCREEN(char.y, char.x) = 219 OR char.y >= 24 THEN
      char.status = " "
      char.y = char.y - 1
      char.foot = char.y
   END IF
   COLOR char.col
   LOCATE char.y, char.x
   PRINT char.char
END SUB

SUB druid.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x + 4 = char.x OR target(1).x - 4 = char.x AND char.curspecial > 0 THEN
            IF SCREEN(char.foot, char.x - 4) <> 219 AND SCREEN(char.foot, char.x + 4) <> 219 THEN
               char.status = "s"
               char.curspecial = char.curspecial - 1
               char.specialattack = char.foot
               IF target(1).x < char.x THEN LOCATE char.foot, char.x - 4
               IF target(1).x > char.x THEN LOCATE char.foot, char.x + 4
               COLOR char.col
               IF char.y MOD 2 = 1 THEN PRINT ""
               IF char.y MOD 2 = 0 THEN PRINT ""
            END IF
         ELSEIF target(1).y < char.y AND target(1).x + 3 >= char.x AND target(1).x - 3 <= char.x THEN
            jump char
            char.status = "j"
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "s" THEN
         IF char.x = target(1).x THEN
            IF char.foot MOD 2 = 1 THEN check = 195
            IF char.foot MOD 2 = 0 THEN check = 180
            grow = char.x - 4
            IF SCREEN(char.foot, char.x - 4) = check THEN grow = char.x - 4
            IF SCREEN(char.foot, char.x + 4) = check THEN grow = char.x + 4
            FOR count = char.specialattack TO char.foot STEP 1
               IF SCREEN(count, grow) <> 219 THEN
                  LOCATE count, grow
                  PRINT " "
               END IF
            NEXT
         ELSEIF char.foot - char.specialattack > 5 THEN
            char.status = ""
            grow = char.x - 4
            IF char.x < target(1).x THEN grow = char.x + 4
            IF char.x > target(1).x THEN grow = char.x - 4
            FOR count = char.specialattack TO char.foot STEP 1
               IF SCREEN(count, grow) <> 219 THEN
                  LOCATE count, grow
                  PRINT " "
               END IF
            NEXT
         ELSE
            PLAY "mbmst300o2l64" + char.weapwave
            grow = char.x - 4
            IF char.x < target(1).x THEN grow = char.x + 4
            IF char.x > target(1).x THEN grow = char.x - 4
            FOR count = char.specialattack TO char.foot STEP 1
               IF SCREEN(count, grow) <> 219 THEN
                  IF count = target(1).y AND grow = target(1).x AND target(1).status <> "s" THEN
                     jump target(1)
                     target(1).status = "j"
                     damage char, target(1)
                  END IF
                  LOCATE count, grow
                  COLOR char.col
                  IF count MOD 2 = 1 THEN PRINT ""
                  IF count MOD 2 = 0 THEN PRINT ""
               END IF
            NEXT
            char.specialattack = char.specialattack - 1
            char.attackwait = char.attackwait - (char.speed * .75)
         END IF
      END IF
   END IF
END SUB

SUB earth.control (char AS CHARACTER, target() AS CHARACTER)
   IF char.status = " " OR char.status = "j" OR char.status = "d" THEN
      IF STRIG(1) = -1 THEN
      IF STRIG(5) = -1 THEN
         IF char.curspecial > 0 THEN
            IF char.status = " " THEN jump char
            char.curspecial = char.curspecial - 1
            char.status = "s"
            char.specialattack = 0
            COLOR 15
            LOCATE 5, 24
            PRINT USING "##"; char.curspecial
            FOR count = char.y TO 23
               IF SCREEN(count, char.x) = 219 THEN
                  char.foot = count - 1
                  EXIT FOR
               END IF
            NEXT
            PLAY "mbmst300o2l64" + char.weapwave
         END IF
      'ELSEIF STICK(1) > dirdown THEN 'for second spell
      END IF
      END IF
   ELSEIF char.status = "s" THEN
      quake char, target()
   END IF
END SUB

SUB endattack (char AS CHARACTER)
   ' This nulls out a current attack and erases the weapon in the background.
   IF TIMER > char.attackwait THEN
      char.status = char.oldstatus
      IF char.dir = "l" THEN
         LOCATE char.y, char.x - 1
      ELSEIF char.dir = "r" THEN
         LOCATE char.y, char.x + 1
      ELSEIF char.dir = "u" THEN
         LOCATE char.y - 1, char.x
      END IF
      PRINT " "
   END IF
END SUB

SUB fadeeffect
   'Fades the screen out to blackness.
   FOR col% = 31 TO 16 STEP -1
      COLOR col%
      FOR count = -14 TO 40
         FOR count2 = 10 TO 23
            IF count - 9 + count2 >= 1 AND count - 9 + count2 <= 40 THEN
               IF SCREEN(count2, count - 9 + count2) <> 32 THEN
                  LOCATE count2, count - 9 + count2
                  PRINT CHR$(SCREEN(count2, count - 9 + count2))
               END IF
            END IF
         NEXT
      NEXT
   NEXT
   EXIT SUB
   ' This next part fades in and out again, but seems useless.
   FOR col% = 17 TO 31
      COLOR col%
      FOR count = -14 TO 40
         FOR count2 = 10 TO 23
            IF count - 9 + count2 >= 1 AND count - 9 + count2 <= 40 THEN
               LOCATE count2, count - 9 + count2
               PRINT ""
            END IF
         NEXT
      NEXT
   NEXT
   FOR col% = 31 TO 17 STEP -1
      COLOR col%
      FOR count = -14 TO 40
         FOR count2 = 10 TO 23
            IF count - 9 + count2 >= 1 AND count - 9 + count2 <= 40 THEN
               LOCATE count2, count - 9 + count2
               PRINT ""
            END IF
         NEXT
      NEXT
   NEXT
   FOR count = -14 TO 40
      FOR count2 = 10 TO 23
         IF count - 9 + count2 >= 1 AND count - 9 + count2 <= 40 THEN
            LOCATE count2, count - 9 + count2
            PRINT " "
         END IF
      NEXT
   NEXT
END SUB

SUB fire.control (char AS CHARACTER, target() AS CHARACTER)
   IF char.status = " " OR char.status = "d" OR char.status = "j" THEN
      IF STRIG(1) = -1 AND STRIG(5) = -1 THEN
         IF STICK(0) > dirright THEN
            char.dir = "r"
         ELSEIF STICK(0) < dirleft THEN
            char.dir = "l"
         ELSEIF STICK(1) < dirup THEN
            char.dir = "u"
         END IF
         IF char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.oldstatus = char.status
            char.status = "s"
            COLOR 15
            LOCATE 5, 24
            PRINT USING "##"; char.curspecial
            PLAY "mbmst300o2l64" + char.weapwave
            IF char.dir = "l" THEN
               char.specialattack = char.x - 1
               IF char.specialattack < char.x - 20 OR char.specialattack < 2 OR SCREEN(char.y, char.specialattack) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.y, char.specialattack
               PRINT ""
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
                     left target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            ELSEIF char.dir = "r" THEN
               char.specialattack = char.x + 1
               IF char.specialattack > char.x + 20 OR char.specialattack > 39 OR SCREEN(char.y, char.specialattack) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.y, char.specialattack
               PRINT ""
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
                     right target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            ELSEIF char.dir = "u" THEN
               char.specialattack = char.y - 1
               IF char.specialattack < char.y - 20 OR char.specialattack < 10 OR SCREEN(char.specialattack, char.x) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.specialattack, char.x
               PRINT "^"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.x = target(enemy).x AND char.specialattack = target(enemy).y THEN
                     jump target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
            fireball char, target()
         END IF
      END IF
   ELSEIF char.status = "s" THEN
      fireball char, target()
   END IF
END SUB

SUB fireball (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      IF char.dir = "r" THEN
         FOR enemy = 1 TO UBOUND(target)
            IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
               right target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
         LOCATE char.y, char.specialattack
         PRINT " "
         char.specialattack = char.specialattack + 1
         IF char.specialattack > char.x + 10 OR char.specialattack < char.x OR char.specialattack > 39 OR SCREEN(char.y, char.specialattack) = 219 THEN
            char.status = char.oldstatus
            EXIT SUB
         END IF
         COLOR 4
         LOCATE char.y, char.specialattack
         PRINT ""
         FOR enemy = 1 TO UBOUND(target)
            IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
               'right target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
      ELSEIF char.dir = "l" THEN
         FOR enemy = 1 TO UBOUND(target)
            IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
               left target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
         LOCATE char.y, char.specialattack
         PRINT " "
         char.specialattack = char.specialattack - 1
         IF char.specialattack < char.x - 10 OR char.specialattack > char.x OR char.specialattack < 2 OR SCREEN(char.y, char.specialattack) = 219 THEN
            char.status = char.oldstatus
            EXIT SUB
         END IF
         COLOR 4
         LOCATE char.y, char.specialattack
         PRINT ""
         FOR enemy = 1 TO UBOUND(target)
            IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
               'left target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
      ELSEIF char.dir = "u" THEN
         FOR enemy = 1 TO UBOUND(target)
            IF char.x = target(enemy).x AND char.specialattack = target(enemy).y THEN
               jump target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
         LOCATE char.specialattack, char.x
         PRINT " "
         char.specialattack = char.specialattack - 1
         COLOR 4
         IF char.specialattack < char.y - 10 OR char.specialattack < 10 OR SCREEN(char.specialattack, char.x) = 219 THEN
            char.status = char.oldstatus
            EXIT SUB
         END IF
         LOCATE char.specialattack, char.x
         PRINT "^"
         FOR enemy = 1 TO UBOUND(target)
            IF char.x = target(enemy).x AND char.specialattack = target(enemy).y THEN
               'jump target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
      END IF
      char.attackwait = TIMER + .1
   END IF
END SUB

SUB flight (char AS CHARACTER, target() AS CHARACTER)
   'This sub controls the Wind character Special attack, forcing him to move
   'every turn and mock-attack. This is useful to get to hard to reach
   'platforms and ledges.
   IF TIMER > char.attackwait THEN
   char.specialattack = char.specialattack + 1
   IF char.dir = "l" THEN
      left char
      char.status = "s"
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x AND target(enemy).y = char.y THEN
            'left target(enemy)
            damage char, target(enemy)
         END IF
         IF target(enemy).x = char.x - 1 AND target(enemy).y = char.y THEN
            left target(enemy)
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y, char.x - 1) = 219 THEN
         char.status = "d"
         char.attackwait = 0
         char.specialattack = 0
         EXIT SUB
      END IF
      COLOR char.weapcol
      LOCATE char.y, char.x - 1
      PRINT char.weapl
   ELSEIF char.dir = "r" THEN
      right char
      char.status = "s"
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x AND target(enemy).y = char.y THEN
            'right target(enemy)
            damage char, target(enemy)
         END IF
         IF target(enemy).x = char.x + 1 AND target(enemy).y = char.y THEN
            right target(enemy)
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y, char.x + 1) = 219 THEN
         char.status = "d"
         char.attackwait = 0
         char.specialattack = 0
         EXIT SUB
      END IF
      COLOR char.weapcol
      LOCATE char.y, char.x + 1
      PRINT char.weapr
   ELSEIF char.dir = "u" THEN
      jump char
      char.status = "s"
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x AND target(enemy).y = char.y THEN
            'jump target(enemy)
            damage char, target(enemy)
         END IF
         IF target(enemy).x = char.x AND target(enemy).y = char.y - 1 THEN
            jump target(enemy)
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y - 1, char.x) = 219 THEN
         char.status = "d"
         char.attackwait = 0
         char.specialattack = 0
         EXIT SUB
      END IF
      COLOR char.weapcol
      LOCATE char.y - 1, char.x
      PRINT char.weapu
   END IF
   char.attackwait = TIMER + .1
   IF char.specialattack >= 10 THEN
      char.oldstatus = "d"
      char.attackwait = 0
      endattack char
      char.specialattack = 0
   END IF
   END IF
END SUB

SUB getitem (item AS CHARACTER, char AS CHARACTER)
   ' Gives out an item and sets its effect upon the character.
   PLAY "mbmst300o2l64baba."
   COLOR 15
   IF item.role = "Potion      " THEN
      char.curhealth = char.curhealth + item.special
      IF char.curhealth > char.health THEN char.curhealth = char.health
      LOCATE 5, 11
      PRINT USING "##"; char.curhealth
   ELSEIF item.role = "Ether       " THEN
      char.curspecial = char.curspecial + item.special
      IF char.curspecial > char.special THEN char.curspecial = char.special
      LOCATE 5, 24
      PRINT USING "##"; char.curspecial
   ELSEIF item.role = "LifeFilter  " THEN
      char.health = char.health + item.special
   ELSEIF item.role = "SoulFilter  " THEN
      char.special = char.special + item.special
   ELSEIF item.role = "Vengeance   " THEN
      char.strength = 2
      char.weapcol = 112
      char.weapu = CHR$(25)
      char.weapl = CHR$(26)
      char.weapr = CHR$(27)
   ELSEIF item.role = "WingBoots   " THEN
      char.leap = 6
   ELSEIF item.role = "DaemonEdge  " THEN
      char.strength = 3
      char.weapcol = 7
      char.weapu = CHR$(25)
      char.weapl = CHR$(26)
      char.weapr = CHR$(27)
   END IF
   char.items = char.items + item.items
   message RTRIM$(item.role) + " was received.", item.col
   makecharacter item, "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
END SUB

SUB ghost.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
         char.dir = "l"
         attack char, target()
      ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
         char.dir = "r"
         attack char, target()
      ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
         char.dir = "u"
         attack char, target()
      ELSEIF target(1).x < char.x AND target(1).y < char.y THEN
         left char
         jump char
      ELSEIF target(1).x < char.x AND target(1).y > char.y THEN
         left char
         descend char
      ELSEIF target(1).x > char.x AND target(1).y < char.y THEN
         right char
         jump char
      ELSEIF target(1).x > char.x AND target(1).y > char.y THEN
         right char
         descend char
      ELSEIF target(1).x < char.x THEN
         left char
      ELSEIF target(1).x > char.x THEN
         right char
      ELSEIF target(1).y < char.y THEN
         jump char
      ELSEIF target(1).y > char.y THEN
         descend char
      END IF
   END IF
END SUB

SUB heart.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.specialattack > 0 THEN
            char.specialattack = char.specialattack - 1
         ELSEIF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x + 3 AND char.y = target(1).y AND char.curspecial > 0 THEN
            left char
            left char
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x - 3 AND char.y = target(1).y AND char.curspecial > 0 THEN
            right char
            right char
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).y < char.y THEN
            jump char
            char.status = "j"
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         IF char.y = char.foot - char.leap + 1 AND char.curspecial > 0 AND char.x + 10 > target(1).x AND char.x - 10 < target(1).x THEN
            IF char.specialattack < 10 THEN
               char.specialattack = char.specialattack + 1
               COLOR char.col
               LOCATE char.y, char.x
               PRINT char.char
               LOCATE char.y - 1, char.x
               IF char.specialattack MOD 2 = 0 THEN
                  PRINT CHR$(3)
               ELSEIF char.specialattack MOD 2 = 1 THEN
                  PRINT CHR$(179)
               END IF
               char.status = "j"
            ELSE
               char.curspecial = char.curspecial - 1
               char.status = "s"
               char.specialattack = 0
            END IF
         ELSE
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = char.attackwait - char.speed / 2
         descend char
         ram char, target(1)
         FOR count = char.foot - char.leap TO char.y - 1 STEP 1
            IF count = target(1).y AND char.x = target(1).x AND target(1).status <> "s" THEN
               jump target(1)
               damage char, target(1)
               PLAY char.weapwave
            END IF
            COLOR char.col
            LOCATE count, char.x
            IF (char.y + count) MOD 2 = 0 THEN
               PRINT CHR$(3)
            ELSEIF (char.y + count) MOD 2 = 1 THEN
               PRINT CHR$(179)
            END IF
         NEXT
         IF char.y = char.foot THEN
            FOR count = char.foot - char.leap - 1 TO char.foot - 1
               LOCATE count, char.x
               PRINT " "
            NEXT
         END IF
      END IF
   END IF
END SUB

SUB jump (char AS CHARACTER)
   ' Moves the character upward and decides whether or not to halt the jump.
   LOCATE char.y, char.x
   PRINT " "
   char.y = char.y - 1
   IF SCREEN(char.y, char.x) = 219 OR char.y < 10 THEN
      char.status = "d"
      char.y = char.y + 1
   END IF
   COLOR char.col
   LOCATE char.y, char.x
   PRINT char.char
   IF char.y <= char.foot - char.leap THEN char.status = "d"
END SUB

SUB knight.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x + 3 AND char.y = target(1).y AND char.curspecial > 0 THEN
            left char
            left char
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x - 3 AND char.y = target(1).y AND char.curspecial > 0 THEN
            right char
            right char
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF SCREEN(char.y, char.x - 1) = 219 AND char.x > target(1).x THEN
            jump char
            char.status = "j"
         ELSEIF SCREEN(char.y, char.x + 1) = 219 AND char.x < target(1).x THEN
            jump char
            char.status = "j"
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      END IF
   END IF
END SUB

SUB left (char AS CHARACTER)
   ' Moves character left.
   LOCATE char.y, char.x
   PRINT " "
   char.x = char.x - 1
   char.dir = "l"
   IF char.x < 2 OR SCREEN(char.y, char.x) = 219 THEN char.x = char.x + 1
   IF char.status <> "j" AND SCREEN(char.y + 1, char.x) <> 219 THEN char.status = "d"
   COLOR char.col
   LOCATE char.y, char.x
   PRINT char.char
END SUB

SUB load (char AS CHARACTER, scene%)
   filenum$ = file$
   OPEN "killin/" + filenum$ + ".kil" FOR INPUT AS #1
   INPUT #1, char.role, alig, char.health, char.curhealth, char.strength, char.special, char.curspecial, char.speed, char.x, char.y, chr, char.col, dir, char.leap, char.foot, char.weapcol, weapl, weapr, weapu, weapwave, scene%
   CLOSE #1
   char.align = CHR$(alig)
   char.char = CHR$(chr)
   char.dir = CHR$(dir)
   char.weapl = CHR$(weapl)
   char.weapr = CHR$(weapr)
   char.weapu = CHR$(weapu)
   char.weapwave = CHR$(weapwave)
END SUB

SUB mage.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).y < char.y AND target(1).x + 7 >= char.x AND target(1).x - 7 <= char.x THEN
            jump char
            char.status = "j"
         ELSEIF target(1).y = char.y AND (target(1).x + 5 <= char.x AND target(1).x + 10 >= char.x OR target(1).x - 10 <= char.x AND target(1).x - 5 >= char.x OR char.x = target(1).x AND char.y > target(1).y) AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.oldstatus = char.status
            char.attackwait = TIMER - 1
            char.status = "s"
            PLAY "mbmst300o2l64" + char.weapwave
            IF target(1).x < char.x THEN
               char.dir = "l"
               char.specialattack = char.x - 1
               IF char.specialattack < char.x - 20 OR char.specialattack < 2 OR SCREEN(char.y, char.specialattack) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.y, char.specialattack
               PRINT ""
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
                     left target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            ELSEIF target(1).x > char.x THEN
               char.dir = "r"
               char.specialattack = char.x + 1
               IF char.specialattack > char.x + 20 OR char.specialattack > 39 OR SCREEN(char.y, char.specialattack) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.y, char.specialattack
               PRINT ""
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
                     right target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            ELSEIF char.y < target(1).y THEN
               char.dir = "u"
               char.specialattack = char.y - 1
               IF char.specialattack < char.y - 20 OR char.specialattack < 10 OR SCREEN(char.specialattack, char.x) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.specialattack, char.x
               PRINT "^"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.x = target(enemy).x AND char.specialattack = target(enemy).y THEN
                     jump target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
            fireball char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = TIMER - 1
         fireball char, target()
      END IF
   END IF
END SUB

SUB main.control (char() AS CHARACTER, target() AS CHARACTER, bgindex AS INTEGER)
   IF TIMER > char(1).attackwait THEN
      char(1).attackwait = TIMER + char(1).speed
      IF char(1).status = " " THEN
      IF STRIG(1) = -1 THEN
         IF STICK(0) > dirright THEN
            char(1).dir = "r"
         ELSEIF STICK(0) < dirleft THEN
            char(1).dir = "l"
         ELSEIF STICK(1) < dirup THEN
            char(1).dir = "u"
         END IF
         attack char(1), target()
      ELSEIF STRIG(5) = -1 THEN
         char(1).status = "j"
         char(1).foot = char(1).y
         jump char(1)
      ELSEIF STICK(0) > dirright THEN
         IF char(1).x = 39 THEN
            bgindex = bgindex + 1
            background bgindex, char(1), target()
         END IF
         right char(1)
      ELSEIF STICK(0) < dirleft THEN
         IF char(1).x = 2 THEN
            bgindex = bgindex - 1
            background bgindex, char(1), target()
         END IF
         left char(1)
      END IF
   ELSEIF char(1).status = "x" THEN
      char(1).attackwait = 0
      endattack char(1)
   ELSEIF char(1).status = "j" THEN
      jump char(1)
      IF STRIG(1) = -1 THEN
         IF STICK(0) > dirright THEN
            char(1).dir = "r"
         ELSEIF STICK(0) < dirleft THEN
            char(1).dir = "l"
         ELSEIF STICK(1) < dirup THEN
            char(1).dir = "u"
         END IF
         attack char(1), target()
      ELSEIF STICK(0) < dirleft THEN
         IF char(1).x = 2 THEN
            bgindex = bgindex - 1
            background bgindex, char(1), target()
         END IF
         left char(1)
      ELSEIF STICK(0) > 70 THEN
         IF char(1).x = 39 THEN
            bgindex = bgindex + 1
            background bgindex, char(1), target()
         END IF
         right char(1)
      END IF
   ELSEIF char(1).status = "d" THEN
      descend char(1)
      IF STRIG(1) = -1 THEN
         IF STICK(0) > dirright THEN
            char(1).dir = "r"
         ELSEIF STICK(0) < dirleft THEN
            char(1).dir = "l"
         ELSEIF STICK(1) < dirup THEN
            char(1).dir = "u"
         END IF
         attack char(1), target()
      ELSEIF STICK(0) < dirleft THEN
         IF char(1).x = 2 THEN
            bgindex = bgindex - 1
            background bgindex, char(1), target()
         END IF
         left char(1)
      ELSEIF STICK(0) > 70 THEN
         IF char(1).x = 39 THEN
            bgindex = bgindex + 1
            background bgindex, char(1), target()
         END IF
         right char(1)
      END IF
   END IF
   END IF
   FOR enemy = 1 TO UBOUND(target)
      IF target(enemy).role = "Blob        " THEN blob.control target(enemy), char()
      IF target(enemy).role = "Spiker      " THEN spiker.control target(enemy), char()
      IF target(enemy).role = "Knight      " THEN knight.control target(enemy), char()
      IF target(enemy).role = "Ghost       " THEN ghost.control target(enemy), char()
      IF target(enemy).role = "Sprite      " THEN sprite.control target(enemy), char()
      IF target(enemy).role = "Aracane     " THEN aracane.control target(enemy), char()
      IF target(enemy).role = "Mage        " THEN mage.control target(enemy), char()
      IF target(enemy).role = "Scynscatha  " THEN scynscatha.control target(enemy), char()
      IF target(enemy).role = "Mole        " THEN mole.control target(enemy), char()
      IF target(enemy).role = "JackOfHearts" THEN heart.control target(enemy), char()
      IF target(enemy).role = "Scorpion    " THEN scorpion.control target(enemy), char()
      IF target(enemy).role = "Druid       " THEN druid.control target(enemy), char()
      IF target(enemy).role = "Phantom     " THEN phantom.control target(enemy), char()
      IF target(enemy).role = "watchman    " AND target(1).curhealth <= 0 AND char(1).status <> "s" THEN watchman.control target(), char(1), bgindex
      IF target(enemy).align = "i" THEN
         IF char(1).x = target(enemy).x AND char(1).y = target(enemy).y THEN
            getitem target(enemy), char(1)
         ELSEIF TIMER > target(enemy).attackwait THEN
            target(enemy).attackwait = TIMER + .1
            COLOR target(enemy).col
            LOCATE target(enemy).y, target(enemy).x
            PRINT target(enemy).char
            IF SCREEN(target(enemy).y + 1, target(enemy).x) <> 219 THEN descend target(enemy)
         END IF
      END IF
   NEXT
END SUB

SUB makecharacter (char AS CHARACTER, role AS STRING, align AS STRING, health AS INTEGER, strength AS INTEGER, special AS INTEGER, speed AS SINGLE, x AS INTEGER, y AS INTEGER, col AS INTEGER, chr AS STRING, dir AS STRING, leap AS INTEGER, weapcol AS INTEGER, weapl AS STRING, weapr AS STRING, weapu AS STRING, weapwave AS STRING)
   ' Makes any character.
   char.role = role
   char.align = align
   char.health = health
   char.curhealth = health
   char.strength = strength
   char.special = special
   char.curspecial = special
   char.speed = speed
   char.x = x
   char.y = y
   char.col = col
   char.char = chr
   char.dir = dir
   char.leap = leap
   char.foot = y
   char.weapcol = weapcol
   char.weapl = weapl
   char.weapr = weapr
   char.weapu = weapu
   char.weapwave = weapwave
   char.status = " "
   char.oldstatus = " "
END SUB

SUB makeenemy (char AS CHARACTER, role AS STRING, x AS INTEGER, y AS INTEGER)
   IF role = "Blob" THEN makecharacter char, "Blob", "e", 2, 1, 5, .25, x, y, 10, CHR$(220), "l", 3, 10, CHR$(250), CHR$(250), CHR$(250), "e"
   IF role = "Spiker" THEN makecharacter char, "Spiker", "e", 5, 2, 5, 0, x, y, 1, CHR$(127), "u", 6, 1, CHR$(196), CHR$(196), CHR$(179), "g"
   IF role = "Sprite" THEN makecharacter char, "Sprite", "e", 1, 1, 10, .05, x, y, 13, CHR$(157), "l", 5, 11, CHR$(176), CHR$(176), CHR$(176), "b"
   IF role = "Knight" THEN makecharacter char, "Knight", "e", 4, 2, 5, .35, x, y, 20, CHR$(1), "l", 1, 18, CHR$(26), CHR$(27), CHR$(25), "c"
   IF role = "Ghost" THEN makecharacter char, "Ghost", "e", 2, 2, 20, .2, x, y, 15, CHR$(148), "l", 7, 17, CHR$(15), CHR$(15), CHR$(15), "a"
   IF role = "Aracane" THEN makecharacter char, "Aracane", "e", 3, 2, 10, .3, x, y, 136, CHR$(15), "l", 6, 17, CHR$(176), CHR$(176), CHR$(176), "d"
   IF role = "Mage" THEN makecharacter char, "Mage", "e", 4, 1, 20, .325, x, y, 106, CHR$(1), "l", 3, 4, CHR$(196), CHR$(196), CHR$(179), "b"
   IF role = "Scynscatha" THEN makecharacter char, "Scynscatha", "l", 10, 2, 5, .2, x, y, 14, CHR$(1), "l", 5, 8, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "Mole" THEN makecharacter char, "Mole", "l", 15, 1, 10, .15, x, y, 6, CHR$(236), "u", 7, 15, CHR$(60), CHR$(62), CHR$(94), "d"
   IF role = "Scynscatha2" THEN makecharacter char, "Scynscatha", "l", 15, 2, 10, .2, x, y, 14, CHR$(1), "l", 5, 8, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "JackOfHearts" THEN makecharacter char, "JackOfHearts", "l", 15, 2, 20, .1, x, y, 5, CHR$(1), "l", 7, 7, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "Scynscatha3" THEN makecharacter char, "Scynscatha", "l", 20, 3, 15, .17, x, y, 14, CHR$(1), "l", 5, 8, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "Scorpion" THEN makecharacter char, "Scorpion", "l", 20, 3, 5, .3, x, y, 139, CHR$(147), "l", 3, 139, ">", "<", CHR$(244), "f"
   IF role = "Druid" THEN makecharacter char, "Druid", "l", 30, 2, 30, .2, x, y, 120, CHR$(1), "l", 6, 240, CHR$(27), CHR$(26), CHR$(28), "d"
   IF role = "Scynscatha4" THEN makecharacter char, "Scynscatha", "l", 40, 3, 20, .15, x, y, 14, CHR$(1), "l", 5, 8, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "Phantom" THEN makecharacter char, "Phantom", "l", 35, 2, 30, .25, x, y, 20, CHR$(32), "l", 4, 7, CHR$(26), CHR$(27), CHR$(25), "a"
   IF role = "Scynscatha5" THEN makecharacter char, "Scynscatha", "l", 60, 3, 25, .14, x, y, 14, CHR$(1), "l", 5, 8, CHR$(26), CHR$(27), CHR$(25), "b"
END SUB

SUB makeitem (item AS CHARACTER, role AS STRING, id AS SINGLE, x AS INTEGER, y AS INTEGER)
   IF role = "Potion" THEN
      makecharacter item, "Potion", "i", 1, 0, 10, 0, x, y, 7, CHR$(232), "", 0, 0, "", "", "", "b"
      item.items = id
   ELSEIF role = "Ether" THEN
      makecharacter item, "Ether", "i", 1, 0, 5, 0, x, y, 11, CHR$(232), "", 0, 0, "", "", "", "c"
      item.items = id
   ELSEIF role = "LifeFilter" THEN
      makecharacter item, "LifeFilter", "i", 1, 0, 5, 0, x, y, 5, CHR$(232), "", 0, 0, "", "", "", "d"
   ELSEIF role = "SoulFilter" THEN
      makecharacter item, "SoulFilter", "i", 1, 0, 5, 0, x, y, 1, CHR$(232), "", 0, 0, "", "", "", "e"
   ELSEIF role = "Vengeance" THEN
      makecharacter item, "Vengeance", "i", 1, 0, 5, 0, x, y, 112, CHR$(25), "", 0, 0, "", "", "", "g"
   ELSEIF role = "WingBoots" THEN
      makecharacter item, "WingBoots", "i", 1, 0, 5, 0, x, y, 43, CHR$(156), "", 0, 0, "", "", "", "g"
      item.items = id
   ELSEIF role = "DaemonEdge" THEN
      makecharacter item, "DaemonEdge", "i", 1, 0, 5, 0, x, y, 14, CHR$(25), "", 0, 0, "", "", "", "b"
   END IF
END SUB

SUB makeplayer (char AS CHARACTER, role AS STRING, x AS INTEGER, y AS INTEGER)
   IF role = "Seth" THEN makecharacter char, "Seth", "g", 7, 0, 0, .1, x, y, 7, CHR$(1), "r", 4, 7, CHR$(249), CHR$(249), CHR$(249), "f"
   IF role = "Fire" THEN makecharacter char, "Fire", "g", 10, 1, 10, .1, x, y, 4, CHR$(1), "r", 5, 8, CHR$(26), CHR$(27), CHR$(25), "g"
   IF role = "Wind" THEN makecharacter char, "Wind", "g", 10, 1, 10, .1, x, y, 1, CHR$(1), "r", 5, 8, CHR$(27), CHR$(26), CHR$(24), "a"
   IF role = "Water" THEN makecharacter char, "Water", "g", 10, 1, 10, .1, x, y, 3, CHR$(1), "r", 5, 7, CHR$(27), CHR$(26), CHR$(24), "e"
   IF role = "Earth" THEN makecharacter char, "Earth", "g", 10, 1, 10, .1, x, y, 8, CHR$(1), "r", 5, 20, CHR$(199), CHR$(182), CHR$(209), "c"
   IF role = "Light" THEN makecharacter char, "Light", "g", 10, 1, 10, .1, x, y, 15, CHR$(1), "r", 5, 7, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "Dark" THEN makecharacter char, "Dark", "g", 10, 1, 10, .1, x, y, 20, CHR$(1), "r", 5, 19, CHR$(26), CHR$(27), CHR$(25), "d"
   IF role = "Ice" THEN makecharacter char, "Ice", "g", 10, 1, 10, 0, .1, y, 11, CHR$(1), "r", 5, 7, CHR$(195), CHR$(180), CHR$(194), "g"
   IF role = "Magma" THEN makecharacter char, "Magma", "g", 10, 1, 10, .1, x, y, 42, CHR$(1), "r", 5, 21, CHR$(215), CHR$(215), CHR$(216), "e"
   IF role = "Crystal" THEN makecharacter char, "Crystal", "g", 10, 1, 10, .1, x, y, 57, CHR$(1), "r", 5, 7, CHR$(195), CHR$(180), CHR$(194), "b"
   IF role = "Lightning" THEN makecharacter char, "Lightning", "g", 10, 1, 10, .1, x, y, 14, CHR$(1), "r", 5, 8, CHR$(26), CHR$(27), CHR$(25), "g"
END SUB

SUB message (quote AS STRING, col AS INTEGER)
   COLOR col
   LOCATE 7, 2
   IF LEN(quote) > 38 THEN
      PRINT "error: string too long"
   ELSE
      PRINT quote; STRING$(38 - LEN(quote), " ")
   END IF
END SUB

SUB mole.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.y = char.foot THEN
            LOCATE char.y, char.x
            PRINT " "
            char.y = char.foot + 1
         END IF
         IF char.specialattack > 10 THEN
            char.specialattack = 0
            char.status = "j"
            char.dir = "u"
            char.y = char.y - 1
            PLAY "mbmst300o2l64" + char.weapwave
            ram char, target(1)
            COLOR char.col
            LOCATE char.y, char.x
            PRINT char.char
         ELSEIF target(1).x < char.x THEN
            char.x = char.x - 1
            char.specialattack = char.specialattack + 1
         ELSEIF target(1).x > char.x THEN
            char.x = char.x + 1
            char.specialattack = char.specialattack + 1
         ELSE
            char.specialattack = char.specialattack + 1
         END IF
      ELSEIF char.status = "j" THEN
         jump char
         ram char, target(1)
      ELSEIF char.status = "d" THEN
         descend char
         IF target(1).x + 5 > char.x AND target(1).x - 5 < char.x AND SCREEN(char.y + 1, char.x) = 219 THEN
            IF char.curspecial > 0 THEN
               char.curspecial = char.curspecial - 1
               char.status = "s"
               char.specialattack = 0
               FOR count = char.y TO 23
                  IF SCREEN(count, char.x) = 219 THEN
                     char.foot = count - 1
                     EXIT FOR
                  END IF
               NEXT
               PLAY "mbmst300o2l64" + char.weapwave
            END IF
         ELSE
            ram char, target(1)
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = 0
         quake char, target()
         IF char.specialattack = 0 THEN descend char
      END IF
   END IF
END SUB

SUB phantom.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF char.x < target(1).x AND target(1).x <= char.x + 7 AND target(1).y = char.y AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "r"
            char.status = "s"
            char.oldstatus = " "
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF char.x > target(1).x AND target(1).x >= char.x - 7 AND target(1).y = char.y AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "l"
            char.status = "s"
            char.oldstatus = " "
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF char.y > target(1).y AND target(1).x = char.x AND target(1).y >= char.y - 7 AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "u"
            char.status = "s"
            char.oldstatus = " "
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF target(1).y < char.y - 2 THEN
            jump char
            char.status = "j"
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF char.x < target(1).x AND target(1).x <= char.x + 7 AND target(1).y = char.y AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "r"
            char.status = "s"
            char.oldstatus = "j"
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF char.x > target(1).x AND target(1).x >= char.x - 7 AND target(1).y = char.y AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "l"
            char.status = "s"
            char.oldstatus = "j"
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF char.y > target(1).y AND target(1).x = char.x AND target(1).y >= char.y - 7 AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "u"
            char.status = "s"
            char.oldstatus = "j"
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF target(1).x < char.x - 1 THEN
            left char
         ELSEIF target(1).x > char.x + 1 THEN
            right char
         ELSEIF target(1).x = char.x THEN
            IF char.dir = "l" OR char.dir = "u" THEN left char
            IF char.dir = "r" THEN right char
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = 0
         flight char, target()
         IF char.specialattack = 0 THEN
            char.attackwait = TIMER + char.speed * 4
         ELSE
            char.attackwait = TIMER + char.speed
         END IF
      END IF
   END IF
END SUB

SUB quake (char AS CHARACTER, target() AS CHARACTER)
   'Special Attack used by the Earth Player and the Mole
   IF TIMER > char.attackwait THEN
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      FOR count = char.x - 3 TO char.x + 3
         IF count > 1 AND count < 40 THEN
            IF SCREEN(char.foot, count) <> 219 AND SCREEN(char.foot + 1, count) = 219 THEN
               LOCATE char.foot, count
               PRINT " "
            END IF
         END IF
      NEXT
      FOR count = char.x - 3 TO char.x + 3
         IF count > 1 AND count < 40 THEN
            IF SCREEN(char.foot, count) <> 219 AND SCREEN(char.foot + 1, count) = 219 AND count * TIMER MOD 2 = 1 THEN
               PLAY "mbmst700o0l64b"
               COLOR 6
               LOCATE char.foot, count
               PRINT ""
            END IF
         END IF
      NEXT
      FOR count = char.x - 3 TO char.x + 3
         IF count > 1 AND count < 40 THEN
            FOR enemy = 1 TO UBOUND(target)
               IF SCREEN(char.foot, count) <> 219 AND SCREEN(char.foot + 1, count) = 219 AND count * TIMER MOD 2 = 1 AND count = target(enemy).x AND char.foot = target(enemy).y THEN
                  IF target(enemy).x < char.x THEN left target(enemy)
                  IF target(enemy).x > char.x THEN right target(enemy)
                  damage char, target(enemy)
               END IF
            NEXT
         END IF
      NEXT
      char.specialattack = char.specialattack + 1
      IF char.specialattack > 10 THEN
         char.status = "d"
         char.specialattack = 0
         FOR count = char.x - 3 TO char.x + 3
            IF count > 1 AND count < 40 THEN
               IF SCREEN(char.foot, count) = 220 THEN
                  LOCATE char.foot, count
                  PRINT " "
               END IF
            END IF
         NEXT
      END IF
      char.attackwait = TIMER + .09
   END IF
END SUB

SUB ram (char AS CHARACTER, target AS CHARACTER)
   ' Used by enemies without weapons, checks for collision between character
   ' and enemy.
   IF char.x = target.x AND char.y = target.y AND target.status <> "s" AND target.oldstatus <> "s" THEN
      direction$ = target.dir
      IF char.dir = "l" THEN
         left target
      ELSEIF char.dir = "r" THEN
         right target
      ELSEIF char.dir = "u" THEN
         jump target
         target.status = "d"
      END IF
      target.dir = direction$
      damage char, target
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      PLAY "mbmst360o2l64" + char.weapwave
   END IF
END SUB

SUB right (char AS CHARACTER)
   LOCATE char.y, char.x
   PRINT " "
   char.x = char.x + 1
   char.dir = "r"
   IF char.x > 39 OR SCREEN(char.y, char.x) = 219 THEN char.x = char.x - 1
   IF char.status <> "j" AND SCREEN(char.y + 1, char.x) <> 219 THEN char.status = "d"
   COLOR char.col
   LOCATE char.y, char.x
   PRINT char.char
END SUB

SUB save (char AS CHARACTER, scene%)
   WHILE STRIG(0) = -1 AND STRIG(1) = -1 AND STRIG(4) = -1 AND STRIG(5) = -1: WEND
   message "Do you wish to save the game?", 15
   waiter
   IF yesno$(15) <> "y" THEN EXIT SUB
   filenum$ = "-1"
   DO UNTIL VAL(filenum$) >= 0 AND VAL(filenum$) <= 5
      message "Save game as which number (1-5) ?", 15
      filenum$ = INPUT$(1)
   LOOP
   IF filenum$ = "0" THEN
      message " (Save Aborted)", 7
      EXIT SUB
   END IF
   message " **** Saving in Progress ****", 7
   OPEN "killin/" + filenum$ + ".kil" FOR OUTPUT AS #1
   WRITE #1, char.role, ASC(char.align), char.health, char.curhealth, char.strength, char.special, char.curspecial, char.speed, ABS(char.x - 40) + 1, char.y, ASC(char.char), char.col, ASC(char.dir), char.leap, char.foot, char.weapcol, ASC(char.weapl), ASC(char.weapr), ASC(char.weapu), ASC(char.weapwave), scene%
   CLOSE #1
   message " ****   Game     Saved   ****", 15
   file$ = filenum$
   waiter
   message "", 0
END SUB

SUB scorpion.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y AND char.curhealth > 0 THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y AND char.curhealth > 0 THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 AND char.curhealth > 0 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).y = char.y AND target(1).x - 7 >= char.x OR target(1).y = char.y AND target(1).x + 7 <= char.x THEN
            char.specialattack = char.x
            char.status = "s"
         ELSEIF target(1).y < char.y AND target(1).x + 5 >= char.x AND target(1).x - 5 <= char.x THEN
            jump char
            char.status = "j"
         ELSEIF target(1).x < char.x THEN
            left char
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            ram char, target(1)
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y AND char.curhealth > 0 THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y AND char.curhealth > 0 THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 AND char.curhealth > 0 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            ram char, target(1)
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            ram char, target(1)
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = char.attackwait - char.speed * .75
         IF target(1).x < char.specialattack THEN
            LOCATE char.y, char.specialattack
            PRINT " "
            char.specialattack = char.specialattack - 1
         ELSEIF target(1).x > char.specialattack THEN
            LOCATE char.y, char.specialattack
            PRINT " "
            char.specialattack = char.specialattack + 1
         END IF
         LOCATE char.y, char.specialattack
         COLOR char.weapcol
         PRINT char.weapu
         LOCATE char.y, char.x
         COLOR char.col
         PRINT char.char
         IF char.y = target(1).y AND char.specialattack = target(1).x AND target(1).status <> "s" THEN
            PLAY char.weapwave
            jump target(1)
            damage char, target(1)
         ELSEIF char.specialattack = char.x THEN
            PLAY char.weapwave
            char.status = "j"
            jump char
            char.curspecial = char.curspecial - 1
            IF char.curspecial <= 0 THEN char.curhealth = 0
         END IF
      END IF
   END IF
END SUB

SUB scynscatha.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).y < char.y AND target(1).x + 3 >= char.x AND target(1).x - 3 <= char.x OR target(1).y = char.y AND target(1).x = char.x AND char.special >= 15 AND char.curspecial > 0 THEN
            jump char
            char.status = "j"
         ELSEIF target(1).y = char.y AND (target(1).x + 5 <= char.x AND target(1).x + 10 >= char.x OR target(1).x - 10 <= char.x AND target(1).x + 5 >= char.x) AND char.curspecial > 0 THEN
            IF char.curspecial > 0 THEN
               char.curspecial = char.curspecial - 1
               char.oldstatus = char.status
               char.status = "s"
               char.attackwait = char.attackwait - char.speed / 2
               PLAY "mbmst300o2l64" + char.weapwave
               COLOR char.col
               LOCATE char.y, char.x
               IF target(1).x < char.x THEN PRINT "<"
               IF target(1).x > char.x THEN PRINT ">"
               ram char, target(1)
            END IF
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.special >= 15 AND char.foot - char.leap = char.y AND char.curspecial > 1 AND char.x = target(1).x THEN
            IF char.curspecial > 1 THEN
               char.curspecial = char.curspecial - 2
               PLAY "mbmst300o2l64" + char.weapwave
               FOR count = char.y + 1 TO char.foot
                  IF target(1).x = char.x AND target(1).y = count AND target(1).status <> "s" THEN
                     descend target(1)
                     damage char, target(1)
                  END IF
                  IF SCREEN(count, char.x) <> 219 THEN
                     COLOR char.col
                     LOCATE count, char.x
                     IF count MOD 2 = 0 THEN PRINT "/"
                     IF count MOD 2 = 1 THEN PRINT "\"
                  END IF
               NEXT
            END IF
         ELSEIF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "d" THEN
         IF char.foot - char.leap = char.y AND (SCREEN(char.y + 1, char.x) = 92 OR SCREEN(char.y + 1, char.x) = 47) THEN
            char.attackwait = char.attackwait - char.speed / 2
            FOR count = char.y + 1 TO char.foot
               IF SCREEN(count, char.x) <> 219 THEN
                  LOCATE count, char.x
                  PRINT " "
               END IF
            NEXT
         END IF
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = char.attackwait - char.speed / 2
         char.specialattack = char.specialattack + 1
         IF target(1).x < char.x THEN
            left char
            COLOR char.col
            LOCATE char.y, char.x
            PRINT "<"
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            COLOR char.col
            LOCATE char.y, char.x
            PRINT ">"
            ram char, target(1)
         END IF
         IF char.specialattack > 10 THEN
            char.specialattack = 0
            char.status = char.oldstatus
         END IF
      END IF
   END IF
END SUB

SUB slowPRINT (quote AS STRING)
   COLOR 16
   PRINT quote
   length% = LEN(quote)
   column = POS(0) - 1
   row = CSRLIN - 1
   DIM col(length%) AS INTEGER
   FOR count = 1 TO length%
      col(count) = 16
   NEXT
   FOR count = 1 TO length% + 14
      FOR count2 = 1 TO count
         IF count2 > length% THEN EXIT FOR
         IF MID$(quote, count, 1) = " " THEN
            PRINT " ";
            EXIT FOR
         END IF
         IF col(count2) < 31 THEN col(count2) = col(count2) + 1
         COLOR col(count2)
         LOCATE row, count2 + column
         PRINT MID$(quote, count2, 1);
      NEXT
      stopfor .05
   NEXT
   PRINT
END SUB

SUB spiker.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF target(1).x - 1 <= char.x AND target(1).x + 1 >= char.x THEN
            jump char
            char.status = "j"
            ram char, target(1)
         END IF
      ELSEIF char.status = "j" THEN
         jump char
         ram char, target(1)
      ELSEIF char.status = "d" THEN
         descend char
         ram char, target(1)
      END IF
   END IF
END SUB

SUB sprite.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      x = char.x
      y = char.y
      IF char.status = "j" THEN
         jump char
         IF char.y = y THEN char.status = "d"
      ELSEIF char.status = "d" THEN
         descend char
         IF char.y = y THEN char.status = "j"
      END IF
      IF char.dir = "l" THEN
         left char
         IF char.x = x THEN char.dir = "r"
         ram char, target(1)
      ELSEIF char.dir = "r" THEN
         right char
         IF char.x = x THEN char.dir = "l"
         ram char, target(1)
      END IF
   END IF
END SUB

SUB statusbox (char AS CHARACTER)
END SUB

SUB stopfor (waitin AS DOUBLE)
   ' Stops the game for a given number of milliseconds.
   halt! = TIMER + waitin
   DO
   LOOP WHILE halt! > TIMER
END SUB

SUB waiter
   IF STRIG(0) = -1 OR STRIG(1) = -1 OR STRIG(4) = -1 OR STRIG(5) = -1 THEN
      WHILE STRIG(0) = -1 OR STRIG(1) = -1 OR STRIG(4) = -1 OR STRIG(5) = -1
      WEND
   END IF
   WHILE STRIG(0) <> -1 AND STRIG(1) <> -1 AND STRIG(4) <> -1 AND STRIG(5) <> -1
   WEND
   WHILE STRIG(0) = -1 OR STRIG(1) = -1 OR STRIG(4) = -1 OR STRIG(5) = -1
   WEND
   WHILE STRIG(0) = -1 OR STRIG(1) = -1 OR STRIG(4) = -1 OR STRIG(5) = -1
   WEND
END SUB

SUB watchman.control (enemy() AS CHARACTER, player AS CHARACTER, bg AS INTEGER)
   'This sub routine is called when a certain event takes place, such as an
   'item received or a main leader defeated.
   SELECT CASE bg
   CASE 65
      IF enemy(1).curspecial <= 0 THEN
         PLAY "mbmst300o2l64gf"
         message RTRIM$(enemy(1).role) + " was killed.", enemy(1).col
         FOR count = 10 TO 19
            LOCATE count, 39
            PRINT "  "
         NEXT
         makeitem enemy(1), "Vengeance", 0, enemy(1).x, enemy(1).y
         COLOR enemy(1).col
         LOCATE enemy(1).y, enemy(1).x
         PRINT enemy(1).char
         WHILE SCREEN(player.y + 1, player.x) <> 219
            descend player
            stopfor .1
         WEND
         message "This blade fell from that machine's", player.col
         waiter
         message "tail. It.... it is my father's,", player.col
         waiter
         message "still wet with his blood.", player.col
         waiter
         makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      END IF
   CASE 76
      PLAY "mbmst300o2l64gf"
      message RTRIM$(enemy(1).role) + " was killed.", enemy(1).col
      FOR count = 13 TO 19
         LOCATE count, 39
         PRINT "  "
      NEXT
      makeitem enemy(1), "LifeFilter", 0, enemy(1).x, enemy(1).y
      COLOR enemy(1).col
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
      makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 85
      PLAY "mbmst300o2l64gf"
      makeitem enemy(1), "Ether", .00001, enemy(1).x, enemy(1).y
      COLOR enemy(1).col
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
      makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 87
      DO
         IF player.x < 20 THEN right player
         IF player.x > 20 THEN left player
         descend player
         IF enemy(1).x < 30 THEN right enemy(1)
         IF enemy(1).x > 30 THEN left enemy(1)
         descend enemy(1)
         stopfor .1
      LOOP UNTIL player.x = 20 AND player.y = 19 AND enemy(1).x = 30 AND enemy(1).y = 19
      message "Could you be getting stronger?", enemy(1).col
      waiter
      message "I must seal your fate soon....", enemy(1).col
      FOR count = 25 TO 16 STEP -1
         COLOR count
         LOCATE enemy(1).y, enemy(1).x
         PRINT enemy(1).char
         stopfor .1
      NEXT
      FOR count = 19 TO 10 STEP -1
         LOCATE count, 39
         PRINT "  "
      NEXT
      makecharacter enemy(1), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 98
      PLAY "mbmst300o2l64gf"
      message RTRIM$(enemy(1).role) + " was killed.", enemy(1).col
      FOR count = 10 TO 19
         LOCATE count, 39
         PRINT "  "
      NEXT
      makeitem enemy(1), "SoulFilter", 0, enemy(1).x, enemy(1).y
      COLOR enemy(1).col
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
      makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 103
      makeenemy enemy(1), "Ghost", 34, 13
      COLOR enemy(1).col
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
   CASE 106
      makeenemy enemy(1), "Ghost", 34, 13
      COLOR enemy(1).col
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
   CASE 107
      construct 25, 18, 26, 20, 0
      PLAY "mbmst300o2l64c"
      makecharacter enemy(1), "null", "", 1, 0, 0, 0, 7, 13, 8, "\", "", 0, 0, "", "", "", ""
      COLOR enemy(1).col
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
      makeenemy enemy(1), "Knight", 34, 10
      makeenemy enemy(2), "Mage", 37, 10
      player.status = player.oldstatus
   CASE 109
      IF player.health - player.curhealth >= player.special - player.curspecial THEN
         makeitem enemy(1), "Potion", 0, 20, 14
      ELSE
         makeitem enemy(1), "Ether", 0, 20, 14
      END IF
   CASE 110
      DO
         IF player.x < 18 THEN right player
         IF player.x > 18 THEN left player
         descend player
         IF enemy(1).x < 22 THEN right enemy(1)
         IF enemy(1).x > 22 THEN left enemy(1)
         descend enemy(1)
         stopfor .1
      LOOP UNTIL player.x = 18 AND player.y = 20 AND enemy(1).x = 22 AND enemy(1).y = 20
      message "No! How could you win again?", enemy(1).col
      waiter
      message "I shall be back to finish you....", enemy(1).col
      FOR count = 25 TO 19 STEP -1
         COLOR count
         LOCATE enemy(1).y, enemy(1).x
         PRINT enemy(1).char
         stopfor .1
      NEXT
      FOR count = 19 TO 25
         COLOR count
         LOCATE enemy(1).y, enemy(1).x
         PRINT enemy(1).char
         stopfor .1
      NEXT
      COLOR enemy(1).col
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
      message "No... what is happening?", enemy(1).col
      waiter
      message "You are too weak to return to your", player.col
      waiter
      message "world. There is no escape now.", player.col
      COLOR player.weapcol
      LOCATE player.y, player.x + 1
      PRINT player.weapr
      waiter
      message "Then... we finish it here...", enemy(1).col
      WHILE player.x < enemy(1).x - 2
         right player
         COLOR player.weapcol
         LOCATE player.y, player.x + 1
         PRINT player.weapr
         stopfor .15
      WEND
      PLAY "mbmst300o2l64" + enemy(1).weapwave
      COLOR enemy(1).weapcol
      LOCATE enemy(1).y, enemy(1).x - 1
      PRINT enemy(1).weapl
      stopfor .25
      left player
      message "", 0
      FOR count = 1 TO 5
         COLOR player.weapcol
         LOCATE player.y - (count \ 2 + 1), player.x + 1 - count
         PRINT ""
         LOCATE player.y - (count \ 2 + 1), player.x + 1 + count
         PRINT "/"
         stopfor .25
         LOCATE player.y - (count \ 2 + 1), player.x + 1 - count
         PRINT " "
         LOCATE player.y - (count \ 2 + 1), player.x + 1 + count
         PRINT " "
         IF count MOD 2 = 0 THEN left player
      NEXT
      message "... no... my weapon....", player.col
      waiter
      message "Fate, it seems, is on my side.", enemy(1).col
      waiter
      WHILE enemy(1).x > player.x - 2
         left enemy(1)
         IF enemy(1).x <= player.x + 2 AND enemy(1).x <> player.x THEN
            LOCATE player.y, player.x
            PRINT " "
         ELSEIF player.x <> enemy(1).x THEN
            COLOR enemy(1).weapcol
            LOCATE enemy(1).y, enemy(1).x - 1
            PRINT enemy(1).weapl
         END IF
         stopfor .1
      WEND
      player.x = enemy(1).x + 3
      COLOR player.col
      LOCATE player.y, player.x
      PRINT player.char
      message "Wha- what?!", enemy(1).col
      COLOR enemy(1).weapcol
      LOCATE player.y, player.x + 1
      PRINT enemy(1).weapr
      waiter
      LOCATE player.y, player.x + 1
      PRINT " "
      WHILE player.x > enemy(1).x + 1
         left player
         IF player.x - 1 <> enemy(1).x THEN
            COLOR enemy(1).weapcol
            LOCATE player.y, player.x - 1
            PRINT enemy(1).weapl
         END IF
         stopfor .1
      WEND
      PLAY "mbmst300o2l64" + enemy(1).weapwave
      COLOR 4
      FOR count = 1 TO 2
         LOCATE enemy(1).y, enemy(1).x - count
         PRINT ""
         stopfor .1
         LOCATE enemy(1).y, enemy(1).x - count
         PRINT " "
      NEXT
      LOCATE enemy(1).y, enemy(1).x - 2
      PRINT "_"
      message "....", enemy(1).col
      waiter
      enemy(1).weapcol = 4
      left enemy(1)
      COLOR enemy(1).weapcol
      LOCATE player.y, player.x - 1
      PRINT enemy(1).weapl
      message "Felled by your own blade.", player.col
      waiter
      left enemy(1)
      message "How pathetic.", player.col
      waiter
      LOCATE player.y, player.x - 1
      PRINT " "
      message "How can this be?", enemy(1).col
      waiter
      message "I cannot be killed by a....", enemy(1).col
      COLOR 15
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
      waiter
      message "No, you are... You....", enemy(1).col
      COLOR 15
      FOR count = 20 TO 11 STEP -1
         LOCATE count, enemy(1).x
         PRINT ""
         stopfor .1
      NEXT
      message "", 0
      COLOR 15
      FOR count2 = 1 TO 5
      FOR count = 20 TO 11 STEP -1
         LOCATE count, enemy(1).x
         IF (count2 + count) MOD 2 = 0 THEN
            PRINT ""
         ELSE
            PRINT ""
         END IF
      NEXT
      stopfor .25
      NEXT
      FOR count = 20 TO 11 STEP -1
         LOCATE count, enemy(1).x
         PRINT ""
         stopfor .1
      NEXT
      FOR count = 20 TO 11 STEP -1
         LOCATE count, enemy(1).x
         PRINT " "
         stopfor .1
      NEXT
      stopfor 1
      makeitem enemy(1), "DaemonEdge", 0, 1, 1
      getitem enemy(1), player
      fadeeffect
      FOR col% = 17 TO 31
         COLOR col%
         FOR count = -14 TO 40
            FOR count2 = 10 TO 23
               IF count - 9 + count2 >= 1 AND count - 9 + count2 <= 40 THEN
                  LOCATE count2, count - 9 + count2
                  PRINT ""
               END IF
            NEXT
         NEXT
      NEXT
      message "", 0
      FOR count = 10 TO 23
         LOCATE count, 1
         PRINT STRING$(40, 32)
      NEXT
      makecharacter enemy(1), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      construct 1, 22, 6, 23, 2
      construct 6, 21, 13, 23, 2
      construct 9, 21, 16, 22, 2
      construct 12, 20, 20, 21, 2
      construct 20, 19, 23, 20, 2
      construct 23, 19, 25, 19, 2
      COLOR 8
      LOCATE 18, 25
      PRINT ""
      DIM elemental AS CHARACTER
      elemental = player
      elemental.char = CHR$(15)
      elemental.y = 17
      elemental.x = 21
      makeplayer player, "Seth", 23, 18
      COLOR player.col
      LOCATE player.y, player.x
      PRINT player.char
      FOR count = 16 TO 26
         COLOR count
         LOCATE elemental.y, elemental.x
         PRINT elemental.char
         stopfor .1
      NEXT
      COLOR elemental.col
      LOCATE elemental.y, elemental.x
      PRINT elemental.char
      message "So, did you get what you wanted?", elemental.col
      waiter
      message "... In a way, I suppose I did.", player.col
      waiter
      message ".... Where will you go from here?", elemental.col
      waiter
      message "I never planned that far. I guess I", player.col
      waiter
      message "never truly believed that I could do", player.col
      waiter
      message "it. What about you?", player.col
      waiter
      message "The daemons, my own race, are still a", elemental.col
      waiter
      message "threat. They must be stopped.", elemental.col
      waiter
      message "....", player.col
      waiter
      message "I suppose that I can only retreat and", elemental.col
      waiter
      message "plan another strategy with the others.", elemental.col
      waiter
      message "....", player.col
      waiter
      message "So this is farewell.", elemental.col
      waiter
      left elemental
      message "I thank you for your assistance.", elemental.col
      left elemental
      stopfor .65
      left elemental
      stopfor .65
      message "Wait.", player.col
      waiter
      message "Yes... what is it?", elemental.col
      waiter
      message "Rest, father.", player.col
      waiter
      message "Your death will not go unavenged.", player.col
      WHILE player.x <> elemental.x
         IF player.x > elemental.x THEN left player
         descend player
         IF elemental.y < player.y THEN descend elemental
         IF elemental.x < player.x THEN right elemental
         stopfor .15
      WEND
      player = elemental
      player.char = CHR$(1)
      COLOR player.col
      LOCATE player.y, player.x
      PRINT player.char
      bind player
      COLOR 7
      FOR count2 = 10 TO 23
      FOR count = 1 TO 40
         LOCATE count2, count
         PRINT CHR$(SCREEN(count2, count))
      NEXT
      NEXT
      LOCATE 10, 1
      slowPRINT "Created, Programmed, and Debugged by:"
      LOCATE 11, 1
      slowPRINT " Jaret `Rex Ranarum' Cantu"
      LOCATE 14, 1
      slowPRINT "Special Thanks to:"
      LOCATE 15, 1
      slowPRINT " Greg Perry - for teaching me Q-BASIC"
      waiter
      CLS 0
      save player, (bg + 1)
      message "Thank you for playing!", player.col
      COLOR 15
      PRINT " Check out http://come.to/realitysend"
      PRINT "  for more games and Killin' updates!"
      END
   END SELECT
END SUB

SUB water.control (char AS CHARACTER, target() AS CHARACTER)
   IF char.status = " " OR char.status = "j" OR char.status = "d" THEN
      IF STRIG(1) = -1 AND STRIG(5) = -1 THEN
         IF char.curspecial > 0 THEN
            IF char.status = " " THEN jump char
            char.curspecial = char.curspecial - 1
            char.status = "s"
            COLOR 15
            LOCATE 5, 24
            PRINT USING "##"; char.curspecial
            PLAY "mbmst300o2l64" + char.weapwave
            COLOR 1
            LOCATE char.y, char.x
            PRINT ""
            char.specialattack = char.y
         END IF
      END IF
   ELSEIF char.status = "s" THEN
      waterfall char, target()
   END IF
END SUB

SUB waterfall (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      IF SCREEN(char.y + 1, char.x) = 219 AND char.specialattack < char.y THEN
         LOCATE char.specialattack, char.x
         PRINT " "
         IF char.specialattack < char.y THEN char.specialattack = char.specialattack + 1
         FOR count = char.specialattack TO char.y STEP 1
            FOR enemy = 1 TO UBOUND(target)
               IF count = target(enemy).y AND char.x = target(enemy).x THEN
                  jump target(enemy)
                  damage char, target(enemy)
               END IF
            NEXT
            COLOR 1
            LOCATE count, char.x
            PRINT ""
         NEXT
         IF char.x - 2 > 0 THEN
            IF SCREEN(char.y, char.x - 2) <> 219 THEN
               LOCATE char.y, char.x - 2
               PRINT "\"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.x - 2 = target(enemy).x THEN
                     left target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
         END IF
         IF char.x - 1 > 0 THEN
            IF SCREEN(char.y, char.x - 1) <> 219 THEN
               LOCATE char.y, char.x - 1
               PRINT "\"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.x - 1 = target(enemy).x THEN
                     left target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
         END IF
         IF char.x + 1 < 41 THEN
            IF SCREEN(char.y, char.x + 1) <> 219 THEN
               LOCATE char.y, char.x + 1
               PRINT "/"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.x + 1 = target(enemy).x THEN
                     right target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
         END IF
         IF char.x + 2 < 41 THEN
            IF SCREEN(char.y, char.x + 2) <> 219 THEN
               LOCATE char.y, char.x + 2
               PRINT "/"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.x + 2 = target(enemy).x THEN
                     right target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
         END IF
      ELSEIF SCREEN(char.y + 1, char.x) = 219 AND char.specialattack = char.y THEN
         IF char.x - 2 > 0 THEN
            IF SCREEN(char.y, char.x - 2) <> 219 THEN
               LOCATE char.y, char.x - 2
               PRINT " "
            END IF
         END IF
         IF char.x - 1 > 0 THEN
            IF SCREEN(char.y, char.x - 1) <> 219 THEN
               LOCATE char.y, char.x - 1
               PRINT " "
            END IF
         END IF
         IF char.x + 1 < 41 THEN
            IF SCREEN(char.y, char.x + 1) <> 219 THEN
               LOCATE char.y, char.x + 1
               PRINT " "
            END IF
         END IF
         IF char.x + 2 < 41 THEN
            IF SCREEN(char.y, char.x + 2) <> 219 THEN
               LOCATE char.y, char.x + 2
               PRINT " "
            END IF
         END IF
         char.specialattack = 0
         LOCATE char.y, char.x
         COLOR char.col
         PRINT char.char
         char.status = " "
      ELSE
         char.y = char.y + 1
         FOR count = char.specialattack TO char.y STEP 1
            FOR enemy = 1 TO UBOUND(target)
               IF count = target(enemy).y AND char.x = target(enemy).x THEN
                  jump target(enemy)
                  damage char, target(enemy)
               END IF
            NEXT
            COLOR 1
            LOCATE count, char.x
            PRINT ""
         NEXT
      END IF
      char.attackwait = TIMER + .1
   END IF
END SUB

SUB wind.control (char AS CHARACTER, target() AS CHARACTER)
   IF char.status = " " OR char.status = "j" OR char.status = "d" THEN
      IF STRIG(1) = -1 AND STRIG(5) = -1 THEN
         IF STICK(0) > dirright THEN
            char.dir = "r"
         ELSEIF STICK(0) < dirleft THEN
            char.dir = "l"
         ELSEIF STICK(1) < dirup THEN
            char.dir = "u"
         END IF
         IF char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.status = "s"
            COLOR 15
            LOCATE 5, 24
            PRINT USING "##"; char.curspecial
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         END IF
      END IF
   ELSEIF char.status = "s" THEN
      flight char, target()
   END IF
END SUB

FUNCTION yesno$ (col%)
   yesno$ = "y"
   COLOR col%
   message CHR$(16) + " Yes                 No", 15
   WHILE STRIG(0) = 0 AND STRIG(1) = 0 AND STRIG(4) = 0 AND STRIG(5) = 0
      IF STICK(0) < dirleft THEN
         yesno$ = "y"
         LOCATE 7, 2
         PRINT CHR$(16)
         LOCATE 7, 20
         PRINT " "
      ELSEIF STICK(0) > 70 THEN
         yesno$ = "n"
         LOCATE 7, 2
         PRINT " "
         LOCATE 7, 20
         PRINT CHR$(16)
      END IF
   WEND
   message "", 0
END FUNCTION

