'*****************************************
'*      Reality's End Presents....       *
'*****************************************
'*          K  I  L  L  I  N  '          *
'*****************************************
'*Version Info                           *
'* lpha type 1.1                        *
'*Worked on:                             *
'* 11/23/99 - 3/14/01                    *
'*Legal Jib-Jab:                         *
'* Copyright (C) Jaret Cantu 1999-2001   *
'*E-Mail:                                *
'* mintman@realitysend.com               *
'*Web Site:                              *
'* http://www.realitysend.com            *
'*****************************************
'*  This is the lpha edition of Killin',*
'*my first fully developed game on       *
'*Q-BASIC.  I started it when my brother *
'*noted how I have never once made a     *
'*complete game on QB, and for once in my*
'*life, I didn't have a retort.  I then  *
'*immediately took work upon this game.  *
'*  The name comes from the first        *
'*conceived idea of the game, to kill as *
'*much as possible.  However, I developed*
'*the plot further than that.  This game *
'*became a fantasy adventure game quickly*
'*and soon the title became obsolete for *
'*describing this game; however, by then *
'*it was too late to change the name.    *
'*  Oh well.... Enjoy!                   *
'*****************************************
'********************** Press F5 to Play *
'*****************************************

COMMON SHARED file$
'Type used for the Player, Enemies, Items, and Watchmen
TYPE CHARACTER
   role AS STRING * 12
   align AS STRING * 1 ' "g" = good, "e" = evil, "l" = leader, "i" = item
   health AS INTEGER
   curhealth AS INTEGER
   special AS INTEGER
   curspecial AS INTEGER
   strength AS INTEGER
   speed AS SINGLE
   x AS INTEGER
   y AS INTEGER
   dir AS STRING * 1 ' "l" = left, "r" = right, "u" = up
   col AS INTEGER
   char AS STRING * 1
   leap AS INTEGER
   foot AS INTEGER
   weapcol AS INTEGER
   weapl AS STRING * 1
   weapr AS STRING * 1
   weapu AS STRING * 1
   weapwave AS STRING * 1 ' music of one note only when character attacks
   specialattack AS INTEGER
   attackwait AS SINGLE
   status AS STRING * 1 ' " " = no status, "j" = jumping, "x" = attacking, "d" = descending, "s" = special
   oldstatus AS STRING * 1 ' same as status
   items AS SINGLE ' This takes the postion of the "ones" into account
END TYPE
DECLARE SUB makecharacter (char AS CHARACTER, role AS STRING, align AS STRING, health AS INTEGER, strength AS INTEGER, special AS INTEGER, speed AS SINGLE, x AS INTEGER, y AS INTEGER, col AS INTEGER, chr AS STRING, dir AS STRING, leap AS INTEGER, weapcol AS INTEGER, weapl AS STRING, weapr AS STRING, weapu AS STRING, weapwave AS STRING)
DECLARE SUB makeplayer (char AS CHARACTER, role AS STRING, x AS INTEGER, y AS INTEGER)
DECLARE SUB makeenemy (char AS CHARACTER, role AS STRING, x AS INTEGER, y AS INTEGER)
DECLARE SUB makeitem (item AS CHARACTER, role AS STRING, id AS SINGLE, x AS INTEGER, y AS INTEGER)
DECLARE SUB attack (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB damage (char AS CHARACTER, target AS CHARACTER)
DECLARE SUB endattack (char AS CHARACTER)
DECLARE SUB jump (char AS CHARACTER)
DECLARE SUB descend (char AS CHARACTER)
DECLARE SUB left (char AS CHARACTER)
DECLARE SUB right (char AS CHARACTER)
DECLARE SUB ram (char AS CHARACTER, target AS CHARACTER)
DECLARE SUB flight (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB fireball (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB waterfall (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB quake (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB main.control (char() AS CHARACTER, target() AS CHARACTER, bgindex AS INTEGER)
DECLARE SUB blob.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB scynscatha.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB mole.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB heart.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB sprite.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB spiker.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB knight.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB ghost.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB scorpion.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB aracane.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB druid.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB phantom.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB mage.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB fire.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB wind.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB water.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB earth.control (char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB watchman.control (enemy() AS CHARACTER, player AS CHARACTER, bg AS INTEGER)
DECLARE SUB getitem (item AS CHARACTER, char AS CHARACTER)
DECLARE SUB waiter ()
DECLARE SUB stopfor (waitin AS DOUBLE)
DECLARE SUB bind (char AS CHARACTER)
DECLARE SUB message (quote AS STRING, col AS INTEGER)
DECLARE SUB slowPRINT (quote AS STRING)
DECLARE SUB construct (l AS INTEGER, t AS INTEGER, r AS INTEGER, b AS INTEGER, col AS INTEGER)
DECLARE SUB background (scene AS INTEGER, char AS CHARACTER, target() AS CHARACTER)
DECLARE SUB fadeeffect ()
DECLARE FUNCTION yesno$ (col%)
DECLARE SUB calibrate ()
DECLARE SUB controls ()
DECLARE SUB load (char AS CHARACTER, scene%)
DECLARE SUB save (char AS CHARACTER, scene%)
'declare major variables
DIM player(1 TO 1) AS CHARACTER '1 to 1 for purposes of enemies using attacks
DIM enemy(1 TO 2) AS CHARACTER
bgindex% = -4 '-4 is default: this is for debugging purposes only; do not use it to skip ahead in the level for your character will be too weak
makeplayer player(1), "Seth", 11, 10 ' 7 and 14 are the debugging value
DIM SHARED dirup AS INTEGER
DIM SHARED dirright AS INTEGER
DIM SHARED dirdown AS INTEGER
DIM SHARED dirleft AS INTEGER
OPEN "killin/joystick.kil" FOR INPUT AS #1
INPUT #1, dirup, dirright, dirdown, dirleft
CLOSE #1
'begin the game
SCREEN 13
PRINT
slowPRINT " Reality's End Presents"
PRINT
slowPRINT " K I L L I N '"
slowPRINT "    lpha Edition 1.1"
PRINT
slowPRINT "  Copyright (C) Reality's End 1999-2001"
WHILE STRIG(1) = 0 AND STRIG(0) = 0 AND STRIG(4) = 0 AND STRIG(5) = 0 AND INKEY$ = "": WEND
WHILE STRIG(1) = -1 AND STRIG(0) = -1 AND STRIG(4) = -1 AND STRIG(5) = -1 AND INKEY$ <> "": WEND
doitagain: 'returning from a function and requires the menu again
COLOR 15
PRINT
PRINT " 1) Start New Game"
PRINT " 2) Load Saved Game"
PRINT " 3) View Controls"
PRINT " 4) Calibrate Joystick"
PRINT " 5) Exit Killin'"
faultyinput: 'called if input is above 5
SELECT CASE INPUT$(1)
   CASE "1"
      GOTO startgame
   CASE "2"
      CLS 0
      load player(1), bgindex%
      IF bgindex% > 110 THEN
         PRINT "That data is already complete."
         PRINT "It can only be used in a sequel."
         waiter
         GOTO doitagain
      ELSEIF bgindex% > 54 THEN
         CHAIN "killin/killina2.bas"
      END IF
      GOTO startgame
   CASE "3"
      controls
      GOTO doitagain
   CASE "4"
      calibrate
      GOTO doitagain
   CASE "5"
      END
   CASE ELSE
      BEEP
      GOTO faultyinput
END SELECT

startgame: 'necessary components for game follow
background bgindex%, player(1), enemy()
COLOR player(1).col
LOCATE player(1).y, player(1).x
PRINT player(1).char
'begin the game
IF player(1).role = "Seth        " THEN
   DO
      main.control player(), enemy(), bgindex%
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0 OR player(1).role <> "Seth        "
END IF
IF player(1).role = "Water       " THEN
   DO
      water.control player(1), enemy()
      main.control player(), enemy(), bgindex%
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0
END IF
IF player(1).role = "Earth       " THEN
   DO
      earth.control player(1), enemy()
      main.control player(), enemy(), bgindex%
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0
END IF
IF player(1).role = "Wind        " THEN
   DO
      wind.control player(1), enemy()
      main.control player(), enemy(), bgindex%
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0
END IF
IF player(1).role = "Fire        " THEN
   DO
      fire.control player(1), enemy()
      main.control player(), enemy(), bgindex%
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0
END IF
IF player(1).role <> "Seth        " OR player(1).role <> "Fire        " OR player(1).role <> "Wind        " OR player(1).role <> "Earth       " OR player(1).role <> "Water       " THEN
   DO
      main.control player(), enemy(), bgindex%
      IF STRIG(1) AND STRIG(5) THEN
      IF player(1).role = "Blob        " THEN blob.control player(1), enemy()
      IF player(1).role = "Spiker      " THEN spiker.control player(1), enemy()
      IF player(1).role = "Knight      " THEN knight.control player(1), enemy()
      IF player(1).role = "Ghost       " THEN ghost.control player(1), enemy()
      IF player(1).role = "Sprite      " THEN sprite.control player(1), enemy()
      IF player(1).role = "Aracane     " THEN aracane.control player(1), enemy()
      IF player(1).role = "Mage        " THEN mage.control player(1), enemy()
      IF player(1).role = "Scynscatha  " THEN scynscatha.control player(1), enemy()
      IF player(1).role = "Mole        " THEN mole.control player(1), enemy()
      IF player(1).role = "JackOfHearts" THEN heart.control player(1), enemy()
      IF player(1).role = "Scorpion    " THEN scorpion.control player(1), enemy()
      IF player(1).role = "Druid       " THEN druid.control player(1), enemy()
      IF player(1).role = "Phantom     " THEN phantom.control player(1), enemy()
      END IF
   LOOP UNTIL INKEY$ = CHR$(27) OR player(1).health <= 0
END IF
fadeeffect
COLOR 15 'set "Press any key to continue" to readable color
END

SUB aracane.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF target(1).y < char.y THEN
            jump char
            IF SCREEN(char.y + 1, char.x) <> 219 OR SCREEN(char.y, char.x + 1) <> 219 OR SCREEN(char.y - 1, char.x) <> 219 OR SCREEN(char.y, char.x - 1) <> 219 THEN char.status = "j"
            ram char, target(1)
         ELSEIF target(1).y > char.y THEN
            descend char
            IF SCREEN(char.y + 1, char.x) <> 219 OR SCREEN(char.y, char.x + 1) <> 219 OR SCREEN(char.y - 1, char.x) <> 219 OR SCREEN(char.y, char.x - 1) <> 219 THEN char.status = "d"
            ram char, target(1)
         ELSEIF target(1).x < char.x THEN
            left char
            IF SCREEN(char.y + 1, char.x) = 219 OR SCREEN(char.y, char.x + 1) = 219 OR SCREEN(char.y - 1, char.x) = 219 OR SCREEN(char.y, char.x - 1) = 219 THEN char.status = "d"
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            IF SCREEN(char.y + 1, char.x) = 219 OR SCREEN(char.y, char.x + 1) = 219 OR SCREEN(char.y - 1, char.x) = 219 OR SCREEN(char.y, char.x - 1) = 219 THEN char.status = "d"
            ram char, target(1)
         END IF
      ELSEIF char.status = "j" THEN
         jump char
         IF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
         IF SCREEN(char.y + 1, char.x) = 219 OR SCREEN(char.y, char.x + 1) = 219 OR SCREEN(char.y - 1, char.x) = 219 OR SCREEN(char.y, char.x - 1) = 219 THEN char.status = " "
         ram char, target(1)
      ELSEIF char.status = "d" THEN
         descend char
         IF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
         IF SCREEN(char.y + 1, char.x) = 219 OR SCREEN(char.y, char.x + 1) = 219 OR SCREEN(char.y - 1, char.x) = 219 OR SCREEN(char.y, char.x - 1) = 219 THEN char.status = " "
         ram char, target(1)
      END IF
   END IF
END SUB

SUB attack (char AS CHARACTER, target() AS CHARACTER)
   ' This controls the standard melee attack for both players
   ' and leaders.
   char.oldstatus = char.status
   IF char.dir = "l" THEN
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x - 1 AND target(enemy).y = char.y AND target(enemy).status <> "s" THEN
            left target(enemy)
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y, char.x - 1) = 219 THEN EXIT SUB
      COLOR char.weapcol
      LOCATE char.y, char.x - 1
      PRINT char.weapl
   ELSEIF char.dir = "r" THEN
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x + 1 AND target(enemy).y = char.y AND target(enemy).status <> "s" THEN
            right target(enemy)
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y, char.x + 1) = 219 THEN EXIT SUB
      COLOR char.weapcol
      LOCATE char.y, char.x + 1
      PRINT char.weapr
   ELSEIF char.dir = "u" THEN
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x AND target(enemy).y = char.y - 1 AND target(enemy).status <> "s" THEN
            jump target(enemy)
            target(enemy).status = "d"
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y - 1, char.x) = 219 THEN EXIT SUB
      COLOR char.weapcol
      LOCATE char.y - 1, char.x
      PRINT char.weapu
   END IF
   PLAY "mbmst300o2l64" + char.weapwave
   char.attackwait = TIMER + .2
   char.status = "x"
END SUB

SUB background (scene AS INTEGER, char AS CHARACTER, target() AS CHARACTER)
   'This is called to print every new backdrop as well as enemies, items,
   'and special events.
   CLS 0
   char.x = ABS(char.x - 40) + 1 'this will put the character on the correct side of the screen
   COLOR 15
   'This creates the default box at the top of every scene.
   '               1         2         3         4
   '      1234567890123456789012345678901234567890
   PRINT "ͻ" '1
   PRINT "K I L L I N '                         " '2
   PRINT "Ķ" '3
   PRINT "                                      " '4
   PRINT " Health:     Special:                 " '5
   PRINT "Ķ" '6
   PRINT "                                      " '7
   PRINT "ͼ" '8
   LOCATE 4, 2
   PRINT char.role
   LOCATE 5, 11
   PRINT USING "##"; char.curhealth
   LOCATE 5, 24
   PRINT USING "##"; char.curspecial
   makecharacter target(1), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   makecharacter target(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   ' begin backgrounds
   SELECT CASE scene
   CASE -4
      construct 30, 12, 30, 23, 8
      construct 38, 12, 38, 20, 8
      construct 38, 23, 38, 23, 8
      construct 30, 22, 40, 22, 8
      construct 29, 10, 29, 11, 7
      construct 30, 11, 36, 11, 7
      construct 39, 10, 39, 11, 7
      construct 38, 11, 38, 11, 7
      COLOR 6
      FOR count = 1 TO 5
         LOCATE 18 - count, 32 + count
         PRINT ""
      NEXT
      FOR count = 1 TO 4
         LOCATE 17 + count, 30 + count
         PRINT ""
      NEXT
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      waiter
      message "What is that in the distance?", char.col
      waiter
      message "The armies are drawing nearer.", char.col
      waiter
      message "Accursed daemons,", char.col
      waiter
      message "do they seek our kingdom now?", char.col
      waiter
      message "Have the others resisted the attacks,", char.col
      waiter
      message "or are we the only left unconquered?", char.col
      waiter
      message "My father must know of this.", char.col
      waiter
   CASE -3
      construct 1, 22, 40, 23, 7
      construct 5, 10, 9, 13, 4
      construct 6, 14, 8, 14, 4
      construct 7, 15, 7, 15, 4
      construct 31, 10, 35, 13, 4
      construct 32, 14, 34, 14, 4
      construct 33, 15, 33, 15, 4
      construct 18, 10, 22, 13, 4
      construct 19, 14, 21, 14, 4
      construct 20, 15, 20, 15, 4
      construct 1, 10, 2, 21, 7
      construct 39, 10, 40, 17, 7
      construct 4, 18, 6, 18, 44
      LOCATE 19, 4
      PRINT " "
      char.x = 5
      DIM scyn AS CHARACTER
      makeenemy scyn, "Scynscatha", 22, 21
      COLOR scyn.col
      LOCATE scyn.y, scyn.x
      PRINT scyn.char
      makecharacter target(1), "King", "e", 15, 1, 5, .4, 19, 21, 115, CHR$(1), "r", 5, 8, CHR$(26), CHR$(27), CHR$(25), "d"
      scyn.weapcol = target(1).weapcol
      scyn.weapr = target(1).weapr
      scyn.weapl = target(1).weapl
      scyn.weapu = target(1).weapu
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      FOR count = 16 TO 23
         COLOR count
         LOCATE char.y, char.x
         PRINT char.char
         stopfor .1
      NEXT
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      message "(Father?)", char.col
      waiter
      message "Why have you brought your troops?", target(1).col
      waiter
      message "I thought we had a deal?", target(1).col
      waiter
      right scyn
      message "We are breaking it. We no longer have", scyn.col
      waiter
      message "need for this petty mock alliance.", scyn.col
      waiter
      message "(Is he... a daemon?)", char.col
      waiter
      message "I don't understand. We did all that", target(1).col
      waiter
      message "you asked of us. We never interfered.", target(1).col
      waiter
      message "Yes, but we feel you no longer pose a", scyn.col
      waiter
      message "threat since we have already defeated", scyn.col
      waiter
      message "your human allies.", scyn.col
      waiter
      message "(.... no.)", char.col
      waiter
      right target(1)
      message "You cannot do this!", target(1).col
      waiter
      left scyn
      message "And what will you do to stop us?", scyn.col
      waiter
      message "One puny mortal kingdom cannot stand", scyn.col
      waiter
      message "against the entire daemon race.", scyn.col
      waiter
      message "What have I done?", target(1).col
      waiter
      COLOR target(1).weapcol
      LOCATE target(1).y, target(1).x - 1
      PRINT target(1).weapl
      stopfor .2
      LOCATE target(1).y, target(1).x - 1
      COLOR target(1).col
      PRINT " "; target(1).char;
      COLOR target(1).weapcol
      PRINT target(1).weapr
      stopfor .2
      right target(1)
      stopfor .2
      right scyn
      right target(1)
      message "Do you think this will stop me?", scyn.col
      waiter
      FOR count = 1 TO 4
         left target(1)
         left scyn
         stopfor .35
         right scyn
         right target(1)
         stopfor .35
      NEXT
      message "", 0
      left target(1)
      COLOR scyn.weapcol
      LOCATE scyn.y, scyn.x + 1
      PRINT scyn.weapr
      stopfor .1
      left target(1)
      stopfor .25
      right target(1)
      stopfor .1
      LOCATE scyn.y, scyn.x + 1
      PRINT " "
      COLOR scyn.weapcol
      LOCATE scyn.y, scyn.x - 1
      PRINT scyn.weapl
      PLAY "mbmst300o2l64" + scyn.weapwave
      stopfor .1
      right target(1)
      message "...", target(1).col
      waiter
      scyn.weapcol = 4
      left target(1)
      COLOR scyn.weapcol
      LOCATE scyn.y, scyn.x - 1
      PRINT scyn.weapl
      message "Felled by your own blade.", scyn.col
      stopfor .2
      left target(1)
      waiter
      left target(1)
      message "How pathetic.", scyn.col
      waiter
      LOCATE scyn.y, scyn.x - 1
      PRINT " "
      message "Noooo!", char.col
      WHILE char.x < target(1).x - 1
         right char
         stopfor .1
      WEND
      message RTRIM$(char.role) + "! What are you doing here?", target(1).col
      waiter
      message "I came to tell you about the", char.col
      waiter
      message "appoaching daemon armies.", char.col
      waiter
      message "Who is he? Is he a daemon?", char.col
      waiter
      message RTRIM$(char.role) + "...", target(1).col
      waiter
      message "Why don't you tell him, " + RTRIM$(target(1).role) + "?", scyn.col
      waiter
      message "Tell him how you agreed so readily", scyn.col
      waiter
      message "to stand by as we destroyed your", scyn.col
      waiter
      message "defenseless neighboring kingdoms.", scyn.col
      waiter
      message "Tell him how you agreed to watch the", scyn.col
      waiter
      message "fall of your human friends in exchange", scyn.col
      waiter
      message "for your own safety.", scyn.col
      waiter
      message "... is this true?", char.col
      waiter
      message "I am sorry. I did it to protect you.", target(1).col
      waiter
      message "They are the enemy! Did you think that", char.col
      waiter
      message "they could be trusted?", char.col
      waiter
      stopfor .5
      message "Father??", char.col
      waiter
      message " Father!", char.col
      waiter
      message "", 0
      target(1).col = 4
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      LOCATE 7, 2
      slowPRINT RTRIM$(target(1).role) + " has died."
      LOCATE target(1).y, target(1).x
      PRINT " "
      waiter
      message "Ah, your agonizing mortal emotions", scyn.col
      waiter
      message "are so amusing to us. Tell me,", scyn.col
      waiter
      message "who are you?", scyn.col
      waiter
      message "I... I am the prince, " + RTRIM$(char.role) + ".", char.col
      waiter
      right scyn
      message "The prince! Guards! Take care of him.", scyn.col
      waiter
      makeenemy target(1), "Blob", 5, 21
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 7, 21
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
      FOR count = 25 TO 16 STEP -1
         IF count > 20 THEN message "Just keep him away from me.", scyn.col
         COLOR count
         LOCATE scyn.y, scyn.x
         PRINT scyn.char
         stopfor .15
      NEXT
      waiter
      right char
      message "What are these? Blobs?", char.col
      waiter
      message "I don't know how to fight. Maybe", char.col
      right target(1)
      right target(2)
      waiter
      message "I can get escape through the gate.", char.col
   CASE -2
      char.y = 21
      construct 1, 10, 2, 17, 7
      construct 1, 22, 2, 23, 7
      construct 3, 22, 6, 22, 6
      construct 7, 22, 40, 23, 2
      char.x = 2
      WHILE char.x < 4
         right char
         stopfor .1
      WEND
      makeenemy target(1), "Blob", 2, 21
      WHILE char.x < 7
         right char
         right target(1)
         stopfor .1
      WEND
      makeenemy target(2), "Blob", 2, 21
      WHILE char.x < 10
         right char
         right target(1)
         right target(2)
         stopfor .1
      WEND
      COLOR 8
      FOR count = 18 TO 21
         LOCATE count, 1
         PRINT ""
         PLAY "mbo0t100l64mlb"
         stopfor .2
      NEXT
      message "(Huh? He closed the gates, but why?)", char.col
      waiter
      message "", 0
   CASE -1
      char.y = 21
      construct 1, 22, 6, 23, 2
      construct 6, 21, 13, 23, 2
      construct 9, 21, 16, 22, 2
      construct 12, 20, 20, 21, 2
      construct 20, 19, 23, 20, 2
      construct 23, 19, 25, 19, 2
      WHILE char.x < 5
         IF SCREEN(char.y, char.x + 1) = 219 THEN jump char
         right char
         stopfor .1
      WEND
      makeenemy target(1), "Blob", 2, 21
      WHILE char.x < 10
         IF SCREEN(char.y, char.x + 1) = 219 THEN jump char
         right char
         IF SCREEN(target(1).y, target(1).x + 1) = 219 THEN jump target(1)
         right target(1)
         stopfor .1
      WEND
      makeenemy target(2), "Blob", 2, 21
      WHILE char.x <= 24
         IF SCREEN(char.y, char.x + 1) = 219 THEN jump char
         right char
         IF SCREEN(target(1).y, target(1).x + 1) = 219 THEN jump target(1)
         right target(1)
         IF SCREEN(target(2).y, target(2).x + 1) = 219 THEN jump target(2)
         right target(2)
         stopfor .1
      WEND
      stopfor .35
      left char
      message "(Is there no where I can go?", char.col
      waiter
      IF SCREEN(target(1).y, target(1).x + 1) = 219 THEN jump target(1)
      right target(1)
      IF SCREEN(target(2).y, target(2).x + 1) = 219 THEN jump target(2)
      right target(2)
      right char
      message "Sooner would I die than give", char.col
      waiter
      message "another victory to the daemons.)", char.col
      right char
      IF SCREEN(target(1).y, target(1).x + 1) = 219 THEN jump target(1)
      right target(1)
      IF SCREEN(target(2).y, target(2).x + 1) = 219 THEN jump target(2)
      right target(2)
      WHILE char.y < 22
         descend char
         stopfor .1
      WEND
      LOCATE char.y, char.x
      PRINT " "
      IF SCREEN(target(1).y, target(1).x + 1) = 219 THEN jump target(1)
      right target(1)
      IF SCREEN(target(2).y, target(2).x + 1) = 219 THEN jump target(2)
      right target(2)
      char.x = 20
      char.y = 17
      makeenemy scyn, "Scynscatha", 6, 20
      FOR count = 16 TO 25
         COLOR count
         LOCATE scyn.y, scyn.x
         PRINT scyn.char
         stopfor .15
      NEXT
      COLOR scyn.col
      LOCATE scyn.y, scyn.x
      PRINT scyn.char
      message "Did you take care of him?", scyn.col
      waiter
      stopfor .2
      left target(1)
      IF SCREEN(target(1).y + 1, target(1).x - 1) = 32 THEN descend target(1)
      left target(2)
      IF SCREEN(target(2).y + 1, target(2).x - 1) = 32 THEN descend target(2)
      message "What! You let him escape?", scyn.col
      waiter
      stopfor .2
      message "Hmm, so he fled from you? How odd.", scyn.col
      waiter
      message "Why would he run from the weakest of", scyn.col
      waiter
      message "of daemons. Perhaps he is not the", scyn.col
      waiter
      message "one we were told of....", scyn.col
      waiter
      message "", 0
      makecharacter target(1), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      makecharacter target(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      fadeeffect
      FOR count = 17 TO 23
         LOCATE count, 1
         PRINT STRING$(40, " ")
      NEXT
      stopfor .5
      message "Where am I?", char.col
      waiter
      message "Is this.... death?", char.col
      FOR count = 16 TO 19
         COLOR count
         LOCATE char.y, char.x
         PRINT char.char
         stopfor .25
      NEXT
      waiter
      message "I can't feel anything....", char.col
      FOR count = 20 TO 23
         COLOR count
         LOCATE char.y, char.x
         PRINT char.char
         stopfor .25
      NEXT
      waiter
      message "I see.... nothing....", char.col
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      waiter
      message "Am I to drift here for eternity?", char.col
      waiter
      DIM firec AS CHARACTER
      makeplayer firec, "Fire", char.x, char.y - 5
      firec.char = CHR$(15)
      DIM windc AS CHARACTER
      makeplayer windc, "Wind", char.x + 5, char.y
      windc.char = CHR$(15)
      DIM waterc AS CHARACTER
      makeplayer waterc, "Water", char.x, char.y + 5
      waterc.char = CHR$(15)
      DIM earthc AS CHARACTER
      makeplayer earthc, "Earth", char.x - 5, char.y
      earthc.char = CHR$(15)
      message "Who is that speaking?", firec.col
      waiter
      message "Who, who said that?", char.col
      FOR count = 16 TO 25
         COLOR count
         LOCATE firec.y, firec.x
         PRINT firec.char
         stopfor .15
      NEXT
      COLOR firec.col
      LOCATE firec.y, firec.x
      PRINT firec.char
      waiter
      message "It would appear that we have", windc.col
      waiter
      message "some lost soul as a visitor.", windc.col
      FOR count = 16 TO 25
         COLOR count
         LOCATE windc.y, windc.x
         PRINT windc.char
         stopfor .15
      NEXT
      COLOR windc.col
      LOCATE windc.y, windc.x
      PRINT windc.char
      waiter
      message "What.... are you?", char.col
      waiter
      message "We are beings of pure energy;", waterc.col
      waiter
      message "we have no shape, only essence.", waterc.col
      FOR count = 16 TO 25
         COLOR count
         LOCATE waterc.y, waterc.x
         PRINT waterc.char
         stopfor .15
      NEXT
      COLOR waterc.col
      LOCATE waterc.y, waterc.x
      PRINT waterc.char
      waiter
      message "So, what am I doing here?", char.col
      waiter
      message "We would like to ask you the same", earthc.col
      waiter
      message "question. How did you come here?", earthc.col
      FOR count = 16 TO 25
         COLOR count
         LOCATE earthc.y, earthc.x
         PRINT earthc.char
         stopfor .15
      NEXT
      COLOR earthc.col
      LOCATE earthc.y, earthc.x
      PRINT earthc.char
      waiter
      message "I.... fell off a cliff while fleeing", char.col
      waiter
      message "from some daemons.", char.col
      waiter
      message "Yes, we know well of the daemons.", firec.col
      waiter
      message "Scynscatha and his two generals have", firec.col
      waiter
      message "waged war on your realm.", firec.col
      waiter
      message "They have torn the fabric between your", windc.col
      waiter
      message "world and theirs for their invasion.", windc.col
      waiter
      message "So weak is it now that rifts are", waterc.col
      waiter
      message "appearing between the worlds.", waterc.col
      waiter
      message "You must have fallen through one.", earthc.col
      waiter
      message "Tell us, why were you being chased?", earthc.col
      waiter
      message "They had just taken over my kingdom", char.col
      waiter
      message "and.... murdered my father.", char.col
      waiter
      message "I have nothing now, except to", char.col
      waiter
      message "exact my revenge on the daemons.", char.col
      waiter
      message "Interesting.... we, too, harbor a", firec.col
      waiter
      message "hatred toward the daemons.", firec.col
      waiter
      message "We warred with them on your world,", windc.col
      waiter
      message "but we could not stop them.", windc.col
      waiter
      message "So drained was our energy that we", waterc.col
      waiter
      message "can no longer fight in your world.", waterc.col
      waiter
      message "But, why not?", char.col
      waiter
      message "Beings without form cannot live in", earthc.col
      waiter
      message "a world of substance for very long.", earthc.col
      waiter
      message "Just as a being of substance cannot", firec.col
      waiter
      message "live in formless world for long.", firec.col
      waiter
      message "Then I should be on my way.", char.col
      waiter
      message "Wait. What are you returning to", windc.col
      waiter
      message "your world for? To fight the daemons?", windc.col
      waiter
      message ".... what else is left for me to do?", char.col
      waiter
      message "Standing against the daemons is", waterc.col
      waiter
      message "certain suicide for a human alone.", waterc.col
      waiter
      message "Maybe so, but I am doing something", char.col
      waiter
      message "at least. You hide from them like", char.col
      waiter
      message "cowards. You will never win if you", char.col
      waiter
      message "do not fight.", char.col
      waiter
      message ".... even if we would dare to fight,", earthc.col
      waiter
      message "we lack forms of substance.", earthc.col
      waiter
      message "Yes, we do....", firec.col
      waiter
      message "but this human doesn't.", firec.col
      waiter
      message "Boy, are you willing to do", windc.col
      waiter
      message "anything necessary for your revenge?", windc.col
      waiter
      message "I have nothing but revenge left.", char.col
      waiter
      message "Excellent. One of us must bind to", waterc.col
      waiter
      message "your human form.", waterc.col
      waiter
      message "W-what?", char.col
      waiter
      message "One of us four will intertwine our", earthc.col
      waiter
      message "essence into your substance.", earthc.col
      waiter
      message "One will be able to travel your world", firec.col
      waiter
      message "and you will be given our power.", firec.col
      waiter
      message "Despite our weakened state, more", windc.col
      waiter
      message "than one of us would be too much", windc.col
      waiter
      message "for your form to withstand.", windc.col
      waiter
      message "Therefore, you may only take one", waterc.col
      waiter
      message "of us. Choose wisely.", waterc.col
      waiter
      message "Each of us represent a different", earthc.col
      waiter
      message "element and power. Which will it be?", earthc.col
      DO
         IF STICK(1) < dirup THEN
            WHILE SCREEN(char.y - 1, char.x) <> 15
               jump char
               stopfor .1
            WEND
            message "I am Kano, essence of Fire.", firec.col
            waiter
            message "I shall grant you the ability", firec.col
            waiter
            message "to strike down your foes from", firec.col
            waiter
            message "a distance. Do you wish of me?", firec.col
            waiter
            IF yesno$(char.col) = "y" THEN
               char.role = "Fire"
            ELSE
               WHILE char.y < 17
                  descend char
                  stopfor .1
               WEND
               message "", 0
            END IF
         ELSEIF STICK(1) > dirdown THEN
            WHILE SCREEN(char.y + 1, char.x) <> 15
               descend char
               stopfor .1
            WEND
            message "I am Laguz, essence of Water.", waterc.col
            waiter
            message "I shall give you the power to", waterc.col
            waiter
            message "create water falls, crushing", waterc.col
            waiter
            message "the fools below. Is it I you seek?", waterc.col
            waiter
            IF yesno$(char.col) = "y" THEN
               char.role = "Water"
            ELSE
               WHILE char.y > 17
                  jump char
                  stopfor .1
               WEND
               message "", 0
            END IF
         ELSEIF STICK(0) < dirleft THEN
            WHILE SCREEN(char.y, char.x - 1) <> 15
               left char
               stopfor .1
            WEND
            message "I am Berkana, essence of Earth.", earthc.col
            waiter
            message "To you I shall bestow the force", earthc.col
            waiter
            message "quake, disrupting the ground and", earthc.col
            waiter
            message "destroying the enemy. Will you accept?", earthc.col
            waiter
            IF yesno$(char.col) = "y" THEN
               char.role = "Earth"
            ELSE
               WHILE char.x < 20
                  right char
                  stopfor .1
               WEND
               message "", 0
            END IF
         ELSEIF STICK(0) > dirright THEN
            WHILE SCREEN(char.y, char.x + 1) <> 15
               right char
               stopfor .1
            WEND
            message "I am Hagalaz, essence of Wind.", windc.col
            waiter
            message "I shall give flight to you, to", windc.col
            waiter
            message "to carry you far and leave a ", windc.col
            waiter
            message "destructive swath. Do you beckon?", windc.col
            waiter
            IF yesno$(char.col) = "y" THEN
               char.role = "Wind"
            ELSE
               WHILE char.x > 20
                  left char
                  stopfor .1
               WEND
            END IF
            message "", 0
         END IF
      LOOP WHILE RTRIM$(char.role) = "Seth"
      FOR count = 25 TO 16 STEP -1
         IF char.role <> firec.role THEN
            COLOR count
            LOCATE firec.y, firec.x
            PRINT firec.char
            stopfor .05
         END IF
         IF char.role <> windc.role THEN
            COLOR count
            LOCATE windc.y, windc.x
            PRINT windc.char
            stopfor .05
         END IF
         IF char.role <> waterc.role THEN
            COLOR count
            LOCATE waterc.y, waterc.x
            PRINT waterc.char
            stopfor .05
         END IF
         IF char.role <> earthc.role THEN
            COLOR count
            LOCATE earthc.y, earthc.x
            PRINT earthc.char
            stopfor .05
         END IF
      NEXT
      makeplayer char, RTRIM$(char.role), char.x, char.y
      message "So you have made your choice.", char.col
      waiter
      message "Listen well, human. Once I bind", char.col
      waiter
      message "to you, you will receive my power.", char.col
      waiter
      message "Not only will you be strengthened,", char.col
      waiter
      message "but you will also be able to cast", char.col
      waiter
      message "the spell I grant you. Beware,", char.col
      waiter
      message "however, using the spell too much", char.col
      waiter
      message "will deplete your magic.", char.col
      waiter
      message "We shall travel to your world by", char.col
      waiter
      message "means of dimensional rift.", char.col
      waiter
      message "Where it will lead is some distance", char.col
      waiter
      message "from your castle, but we shall find", char.col
      waiter
      message "Scynscatha's generals along the", char.col
      waiter
      message "way. As of now, the daemon soldiers", char.col
      waiter
      message "are at the castle. We should only", char.col
      waiter
      message "encounter scouts until we draw nearer.", char.col
      waiter
      message "Go now! The portal opens!", char.col
      construct 40, 15, 40, 19, 11
      LOCATE 15, 38
      PRINT ""
      LOCATE 16, 39
      PRINT ""
      LOCATE 18, 39
      PRINT ""
      LOCATE 19, 38
      PRINT ""
      bind char
      WHILE char.x <> 20 OR char.y <> 17
         IF char.x < 20 THEN right char
         IF char.x > 20 THEN left char
         IF char.y < 17 THEN descend char
         IF char.y > 17 THEN jump char
         stopfor .1
      WEND
      construct 19, 16, 38, 16, 16
      construct 19, 17, 19, 17, 16
      construct 19, 18, 38, 18, 16
   CASE 0
      COLOR 2
      FOR count = 2 TO 11
         LOCATE count + 8, 1
         PRINT STRING$(count, "")
      NEXT count
      construct 1, 20, 40, 23, 2
      makeenemy target(1), "Blob", 20, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF char.x < 5 THEN
         char.x = 6
         char.y = 13
         FOR count = 16 TO 25
            COLOR count
            LOCATE char.y, char.x
            PRINT char.char
            stopfor .15
         NEXT
         COLOR char.col
         LOCATE char.y, char.x
         PRINT char.char
         save char, scene
      END IF
   CASE 1
      construct 1, 20, 40, 23, 2
      construct 20, 15, 28, 15, 8
      makeenemy target(1), "Blob", 24, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 20, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 2
      construct 1, 20, 20, 23, 2
      construct 21, 23, 30, 23, 2
      construct 31, 15, 40, 23, 2
      COLOR 8
      LOCATE 17, 23
      PRINT ""
      LOCATE 16, 26
      PRINT ""
      makeenemy target(1), "Blob", 35, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 17, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 3
      construct 1, 20, 40, 23, 2
      FOR count = 1 TO 20
         FOR count2 = 15 + count \ 5 TO 19
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      FOR count = 21 TO 40
         FOR count2 = 19 TO 19 - (count - 17) \ 5 STEP -1
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      COLOR 8
      LOCATE 15, 18
      PRINT "    "
      makeenemy target(1), "Blob", 18, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 23, 14
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 4
      construct 1, 15, 40, 23, 2
      construct 10, 11, 30, 11, 8
      construct 10, 13, 30, 13, 8
      makeenemy target(1), "Blob", 20, 10
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 20, 14
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 5
      construct 1, 15, 12, 23, 2
      construct 13, 20, 28, 23, 2
      construct 29, 15, 40, 23, 2
      construct 17, 11, 25, 11, 8
      makeenemy target(1), "Blob", 21, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 3, 1) <> "1" THEN
         makeitem target(2), "Potion", .1, 18, 10
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 6
      construct 1, 15, 3, 23, 2
      construct 4, 13, 6, 23, 2
      construct 7, 11, 10, 23, 2
      construct 11, 20, 40, 23, 2
      construct 15, 10, 15, 17, 8
      construct 20, 11, 20, 19, 8
      construct 25, 10, 25, 17, 8
      LOCATE 11, 11
      PRINT ""
      LOCATE 14, 14
      PRINT ""
      LOCATE 14, 19
      PRINT ""
      LOCATE 17, 11
      PRINT ""
      LOCATE 17, 16
      PRINT ""
      LOCATE 11, 21
      PRINT ""
      LOCATE 17, 21
      PRINT ""
      LOCATE 14, 24
      PRINT ""
      LOCATE 17, 26
      PRINT ""
      makeenemy target(1), "Spiker", 17, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 23, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 7
      construct 1, 20, 40, 23, 2
      FOR count = 1 TO 40
         FOR count2 = 20 TO 20 - (count - 1) \ 5 STEP -1
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      makeenemy target(1), "Sprite", 38, 11
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 35, 12
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 8
      construct 1, 13, 2, 23, 2
      construct 3, 20, 40, 23, 2
      construct 8, 13, 11, 13, 8
      construct 15, 13, 18, 13, 8
      construct 22, 13, 25, 13, 8
      construct 29, 13, 32, 13, 8
      LOCATE 15, 3
      PRINT ""
      makeenemy target(1), "Blob", 24, 12
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 4, 1) <> "1" THEN
         makeitem target(2), "Ether", .01, 31, 12
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 9
      construct 1, 20, 37, 23, 2
      construct 38, 12, 40, 23, 2
      construct 23, 16, 26, 16, 8
      construct 31, 14, 34, 14, 8
      makeenemy target(1), "Blob", 10, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
   CASE 10
      construct 1, 12, 2, 23, 2
      construct 3, 20, 38, 23, 2
      construct 39, 10, 40, 23, 2
      makeenemy target(1), "Scynscatha", 30, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      PLAY "mbmst300o2l16gfgfgfedgfgfgedec.."
      DO
         right char
         descend char
         stopfor .1
      LOOP WHILE char.foot < 19
      message "Human, I have returned to finish", target(1).col
      construct 1, 10, 2, 11, 2
      WHILE PLAY(0) > 5: WEND
      message "you off. Prepare to die!", target(1).col
      WHILE PLAY(0) > 0: WEND
      message "", 0
   CASE 11
      construct 1, 20, 40, 23, 2
      construct 28, 15, 38, 15, 8
      makeenemy target(1), "Blob", 35, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 30, 19
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
      saveit = 0
      DO WHILE char.x < 5
         saveit = 1
         right char
         stopfor .1
      LOOP
      construct 1, 10, 2, 19, 2
      IF saveit THEN save char, scene
   CASE 12
      construct 1, 20, 40, 23, 2
      construct 25, 17, 40, 19, 2
      construct 3, 12, 10, 12, 8
      makeenemy target(1), "Sprite", 28, 16
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 5, 1) <> "1" THEN
         makeitem target(2), "Potion", .001, 9, 11
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 13
      construct 1, 17, 15, 23, 2
      construct 16, 20, 25, 23, 2
      construct 26, 17, 40, 23, 2
      makeenemy target(1), "Spiker", 16, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 25, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 14
      construct 1, 17, 10, 23, 2
      construct 11, 11, 20, 12, 6
      construct 17, 10, 40, 11, 6
      construct 11, 19, 20, 23, 6
      construct 21, 21, 40, 23, 6
      LOCATE 13, 20
      PRINT ""
      LOCATE 12, 30
      PRINT ""
      makeenemy target(1), "Blob", 35, 20
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 11, 18
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 15
      construct 1, 21, 25, 23, 6
      construct 26, 14, 40, 23, 6
      construct 1, 10, 2, 11, 6
      construct 3, 10, 40, 10, 6
      construct 15, 17, 20, 17, 6
      construct 14, 15, 19, 15, 6
      construct 15, 13, 40, 13, 6
      LOCATE 14, 25
      PRINT ""
      LOCATE 11, 8
      PRINT ""
      makeenemy target(1), "Blob", 30, 12
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 15, 20
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 16
      construct 1, 10, 28, 10, 6
      construct 29, 10, 30, 18, 6
      construct 1, 13, 2, 23, 6
      construct 3, 13, 26, 14, 6
      construct 5, 17, 28, 18, 6
      construct 3, 21, 40, 23, 6
      construct 31, 10, 40, 14, 6
      makeenemy target(1), "Spiker", 27, 16
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 4, 20
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 17
      construct 1, 22, 40, 23, 6
      FOR count = 1 TO 20
         FOR count2 = 21 TO 21 - count \ 5 STEP -1
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      FOR count = 21 TO 40
         FOR count2 = 17 + (count - 17) \ 5 TO 21
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      FOR count = 1 TO 20
         FOR count2 = 14 - count \ 5 TO 10 STEP -1
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      FOR count = 21 TO 40
         FOR count2 = 10 + (count - 17) \ 5 TO 10 STEP -1
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      makeenemy target(1), "Spiker", 19, 17
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 22, 17
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 18
      construct 1, 10, 5, 14, 6
      construct 6, 10, 10, 12, 6
      construct 11, 10, 40, 10, 6
      construct 1, 21, 40, 23, 6
      construct 25, 14, 40, 18, 6
      LOCATE 17, 20
      PRINT ""
      makeenemy target(1), "Spiker", 20, 16
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 35, 13
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 19
      construct 1, 10, 40, 10, 6
      construct 1, 14, 15, 18, 6
      construct 1, 21, 29, 23, 6
      construct 30, 18, 40, 23, 6
      makeenemy target(1), "Blob", 28, 20
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 6, 1) <> "1" THEN
         makeitem target(2), "Ether", .0001, 9, 13
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 20
      construct 1, 18, 10, 23, 6
      construct 11, 23, 38, 23, 6
      construct 1, 10, 40, 10, 6
      construct 39, 12, 40, 23, 6
      FOR count = 10 TO 37 STEP 3
         LOCATE 21 - count \ 5, count
         PRINT ""
      NEXT
      makeenemy target(1), "Spiker", 38, 22
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 24, 22
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 21
      char.items = 0
      construct 1, 10, 40, 10, 6
      construct 1, 12, 2, 23, 6
      construct 3, 19, 38, 23, 6
      construct 39, 11, 40, 23, 6
      makeenemy target(1), "Mole", 30, 18
      PLAY "mbmst700o0l64b"
      DO
         right char
         descend char
         PLAY "bbbbbbbbbbbbbbbbbbbb"
      LOOP WHILE char.foot < 18
      message "What is that sound?", char.col
      construct 1, 11, 2, 11, 6
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      WHILE PLAY(0) > 0: WEND
   CASE 22
      construct 1, 19, 40, 23, 6
      construct 1, 10, 40, 10, 6
      construct 20, 15, 40, 23, 6
      LOCATE 11, 12
      PRINT ""
      makeenemy target(1), "Spiker", 19, 18
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 30, 14
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
      saveit = 0
      WHILE char.x < 5
         saveit = 1
         right char
      WEND
      construct 1, 11, 2, 18, 6
      IF saveit THEN save char, scene
   CASE 23
      construct 1, 10, 10, 10, 6
      construct 1, 15, 10, 23, 6
      LOCATE 11, 5
      PRINT ""
      construct 11, 19, 40, 23, 2
      FOR count = 11 TO 40
         FOR count2 = (count - 10) \ 8 + 15 TO 18
            LOCATE count2, count
            PRINT ""
         NEXT
      NEXT
      makeenemy target(1), "Spiker", 5, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 38, 17
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 24
      construct 1, 18, 40, 23, 2
      construct 3, 13, 38, 13, 8
      makeenemy target(1), "Sprite", 15, 17
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 25, 17
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 25
      construct 1, 18, 40, 23, 2
      FOR count = 1 TO 40
         FOR count2 = 17 - (count MOD 10 - 3) TO 17
            LOCATE count2, count
            PRINT ""
         NEXT
      NEXT
      construct 40, 11, 40, 17, 2
      makeenemy target(1), "Blob", 19, 10
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 29, 10
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 26
      construct 1, 11, 2, 23, 2
      construct 3, 20, 38, 23, 2
      construct 39, 11, 40, 23, 2
      construct 9, 14, 12, 14, 8
      construct 17, 14, 20, 14, 8
      construct 25, 14, 28, 14, 8
      construct 33, 14, 36, 14, 8
      LOCATE 15, 3
      PRINT ""
      makeenemy target(1), "Knight", 20, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Knight", 30, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 27
      construct 1, 11, 2, 23, 2
      construct 3, 20, 40, 23, 2
      COLOR 8
      FOR count = 1 TO 8
         LOCATE 10 + count, 2 + count
         PRINT ""
      NEXT
      makeenemy target(1), "Knight", 7, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 3, 1) <> "1" THEN
         makeitem target(2), "Potion", .1, 3, 19
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 28
      construct 1, 20, 10, 23, 2
      construct 11, 23, 29, 23, 2
      construct 30, 20, 40, 23, 2
      makeenemy target(1), "Knight", 15, 22
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Knight", 25, 22
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 29
      construct 1, 20, 40, 23, 2
      construct 23, 13, 40, 19, 2
      construct 20, 10, 20, 17, 8
      LOCATE 17, 21
      PRINT ""
      makeenemy target(1), "Spiker", 21, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Knight", 35, 12
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 30
      construct 1, 13, 15, 23, 2
      construct 16, 20, 40, 23, 2
      COLOR 8
      LOCATE 13, 16
      PRINT ""
      LOCATE 17, 16
      PRINT "          "
      makeenemy target(1), "Sprite", 35, 19
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 4, 1) <> "1" THEN
         makeitem target(2), "Ether", .01, 28, 16
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 31
      construct 1, 20, 35, 23, 2
      construct 36, 11, 40, 23, 2
      COLOR 8
      LOCATE 13, 14
      PRINT ""
      FOR count = 15 TO 27 STEP 3
         LOCATE count \ 5 + 10, count
         PRINT ""
      NEXT
      makecharacter target(1), "null", "", 1, 0, 0, 0, 14, 12, 8, "/", "", 0, 0, "", "", "", ""
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 32
      construct 1, 11, 2, 23, 2
      construct 3, 20, 38, 23, 2
      construct 39, 10, 40, 23, 2
      makeenemy target(1), "Scynscatha2", 30, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      PLAY "mbmst300o2l16gfgfgfedgfgfgedec.."
      DO
         right char
         descend char
         stopfor .1
      LOOP WHILE char.foot < 19
      message "So we meet again.", target(1).col
      construct 1, 10, 2, 11, 2
      WHILE PLAY(0) > 5: WEND
      message "This time I shall be victorious!", target(1).col
      WHILE PLAY(0) > 0: WEND
   CASE 33
      construct 1, 20, 40, 23, 2
      COLOR 8
      LOCATE 15, 30
      PRINT ""
      makeenemy target(1), "Sprite", 30, 14
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 24, 19
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
      saveit = 0
      DO WHILE char.x < 5
         saveit = 1
         right char
         stopfor .1
      LOOP
      construct 1, 10, 2, 19, 2
      IF saveit THEN save char, scene
   CASE 34
      construct 1, 20, 5, 22, 2
      construct 6, 18, 10, 22, 2
      construct 11, 16, 15, 22, 2
      construct 16, 16, 25, 16, 6
      LOCATE 15, 15
      PRINT "          "
      construct 26, 16, 30, 22, 2
      construct 31, 18, 35, 22, 2
      construct 36, 20, 40, 22, 2
      construct 1, 23, 40, 23, 1
      FOR count = 2 TO 40 STEP 4
         LOCATE 22, count
         PRINT ""
      NEXT
      makeenemy target(1), "Spiker", 15, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 26, 14
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 35
      construct 1, 20, 20, 23, 2
      construct 14, 16, 26, 22, 2
      construct 27, 16, 40, 16, 6
      LOCATE 15, 26
      PRINT ""
      construct 1, 23, 40, 23, 1
      FOR count = 2 TO 40 STEP 4
         LOCATE 22, count
         PRINT ""
      NEXT
      makeenemy target(1), "Knight", 12, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Knight", 29, 15
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 36
      construct 1, 16, 40, 16, 6
      construct 1, 23, 40, 23, 1
      FOR count = 2 TO 40 STEP 4
         LOCATE 22, count
         PRINT ""
      NEXT
      makeenemy target(1), "Sprite", 20, 15
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 30, 15
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 37
      construct 1, 16, 40, 16, 6
      construct 1, 23, 40, 23, 1
      FOR count = 2 TO 40 STEP 4
         LOCATE 22, count
         PRINT ""
      NEXT
      construct 10, 13, 12, 13, 8
      construct 28, 13, 30, 13, 8
      makeenemy target(1), "Sprite", 11, 12
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 5, 1) <> "1" THEN
         makeitem target(2), "Potion", .001, 29, 12
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 38
      construct 1, 16, 40, 16, 6
      construct 1, 23, 40, 23, 1
      FOR count = 2 TO 40 STEP 4
         LOCATE 22, count
         PRINT ""
      NEXT
      COLOR 8
      LOCATE 11, 10
      PRINT ""
      LOCATE 11, 31
      PRINT ""
      LOCATE 13, 10
      PRINT ""
      LOCATE 13, 31
      PRINT ""
      makeenemy target(1), "Sprite", 10, 12
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 31, 12
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 39
      construct 1, 16, 40, 16, 6
      construct 1, 23, 40, 23, 1
      FOR count = 2 TO 40 STEP 4
         LOCATE 22, count
         PRINT ""
      NEXT
      construct 17, 11, 17, 14, 8
      makeenemy target(1), "Knight", 32, 15
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Blob", 10, 15
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 40
      construct 1, 16, 40, 16, 6
      construct 1, 23, 40, 23, 1
      FOR count = 2 TO 40 STEP 4
         LOCATE 22, count
         PRINT ""
      NEXT
      construct 14, 13, 16, 13, 8
      construct 24, 13, 26, 13, 8
      LOCATE 12, 14
      PRINT " "
      LOCATE 12, 24
      PRINT " "
      makeenemy target(1), "Sprite", 15, 12
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 6, 1) <> "1" THEN
         makeitem target(2), "Ether", .0001, 25, 12
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 41
      construct 1, 16, 20, 16, 6
      LOCATE 15, 21
      PRINT ""
      construct 21, 16, 40, 22, 2
      construct 1, 23, 40, 23, 1
      FOR count = 2 TO 40 STEP 4
         LOCATE 22, count
         PRINT ""
      NEXT
      makeenemy target(1), "Spiker", 21, 14
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Knight", 30, 15
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 42
      construct 1, 16, 10, 23, 2
      construct 11, 20, 38, 23, 2
      construct 39, 11, 40, 23, 2
      construct 16, 14, 18, 14, 8
      construct 22, 14, 24, 14, 8
      construct 28, 14, 30, 14, 8
      construct 34, 14, 36, 14, 8
      makeenemy target(1), "Knight", 15, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 29, 13
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 43
      char.items = 0
      construct 1, 11, 2, 23, 2
      construct 3, 20, 38, 23, 2
      construct 39, 10, 40, 23, 2
      makeenemy target(1), "JackOfHearts", 30, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      PLAY "mbmst300o2l16ababgfdeababc.db..."
      DO
         right char
         descend char
         stopfor .1
      LOOP WHILE char.foot < 19
      message "Are you ready?", target(1).col
      construct 1, 10, 2, 11, 2
      WHILE PLAY(0) > 0: WEND
   CASE 44
      construct 1, 20, 40, 23, 2
      construct 20, 16, 28, 19, 2
      construct 16, 12, 18, 12, 7
      makeenemy target(1), "Knight", 15, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Spiker", 20, 15
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
      saveit = 0
      DO WHILE char.x < 5
         saveit = 1
         right char
         stopfor .1
      LOOP
      construct 1, 10, 2, 19, 2
      IF saveit THEN save char, scene
   CASE 45
      construct 1, 20, 40, 23, 2
      construct 5, 18, 10, 19, 2
      construct 20, 15, 23, 15, 7
      construct 28, 13, 40, 14, 7
      makeenemy target(1), "Sprite", 30, 12
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 20, 15
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 46
      construct 1, 20, 40, 23, 2
      construct 1, 13, 20, 14, 7
      construct 26, 17, 40, 19, 2
      makeenemy target(1), "Knight", 15, 12
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 15, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 47
      construct 1, 20, 40, 23, 2
      construct 1, 17, 17, 19, 2
      construct 22, 14, 24, 14, 7
      construct 29, 14, 31, 14, 7
      construct 36, 14, 38, 14, 7
      makeenemy target(1), "Spiker", 29, 13
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 35, 19
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 48
      construct 1, 20, 40, 23, 2
      construct 34, 14, 40, 19, 2
      construct 5, 14, 7, 14, 7
      construct 12, 14, 14, 14, 7
      construct 19, 14, 21, 14, 7
      construct 26, 14, 28, 14, 7
      makeenemy target(1), "Knight", 30, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 3, 1) <> "1" THEN
         makeitem target(2), "Potion", .1, 33, 19
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 49
      construct 1, 14, 5, 23, 2
      construct 6, 17, 7, 23, 2
      construct 8, 20, 10, 23, 2
      construct 11, 22, 40, 23, 2
      construct 14, 15, 18, 15, 7
      construct 23, 13, 40, 13, 7
      makeenemy target(1), "Blob", 30, 21
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 25, 12
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 50
      construct 1, 22, 40, 23, 2
      construct 1, 13, 15, 13, 7
      construct 22, 16, 28, 16, 7
      construct 33, 15, 34, 15, 7
      construct 37, 15, 38, 15, 7
      makeenemy target(1), "Knight", 13, 12
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 32, 21
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 51
      construct 1, 22, 40, 23, 2
      construct 30, 15, 36, 21, 2
      construct 37, 15, 40, 16, 2
      construct 39, 19, 40, 19, 2
      construct 5, 16, 11, 16, 7
      construct 17, 16, 23, 16, 7
      makeenemy target(1), "Spiker", 29, 21
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Ghost", 35, 14
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 52
      construct 1, 22, 20, 23, 2
      construct 1, 15, 9, 16, 2
      construct 1, 19, 9, 19, 2
      construct 8, 17, 9, 18, 2
      construct 21, 18, 40, 23, 2
      makeenemy target(1), "Sprite", 30, 17
      target(1).status = "j"
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      IF MID$(STR$(char.items), 4, 1) <> "1" THEN
         makeitem target(2), "Ether", .01, 7, 18
         COLOR target(2).col
         LOCATE target(2).y, target(2).x
         PRINT target(2).char
      END IF
   CASE 53
      COLOR 2
      FOR count = 1 TO 24
         FOR count2 = 18 - count \ 5 TO 23
            LOCATE count2, count
            PRINT ""
         NEXT count2
      NEXT count
      construct 31, 10, 31, 17, 8
      construct 30, 18, 32, 18, 8
      construct 30, 14, 30, 14, 8
      construct 32, 14, 32, 14, 8
      construct 25, 15, 25, 15, 2
      construct 37, 13, 37, 13, 2
      construct 25, 22, 37, 23, 2
      construct 38, 13, 40, 23, 2
      makeenemy target(1), "Knight", 38, 12
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makeenemy target(2), "Sprite", 27, 21
      target(2).status = "j"
      COLOR target(2).col
      LOCATE target(2).y, target(2).x
      PRINT target(2).char
   CASE 54
      construct 1, 13, 2, 23, 2
      construct 3, 20, 38, 23, 2
      construct 39, 10, 40, 23, 2
      makeenemy target(1), "Scynscatha3", 30, 19
      COLOR target(1).col
      LOCATE target(1).y, target(1).x
      PRINT target(1).char
      makecharacter target(2), "watchman", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      PLAY "mbmst300o2l16gfgfgfedgfgfgedec.."
      DO
         right char
         descend char
         stopfor .1
      LOOP WHILE char.foot < 19
      message "Foolish mortal,", target(1).col
      construct 1, 10, 2, 12, 2
      WHILE PLAY(0) > 5: WEND
      message "I have a new surprise for you!", target(1).col
      WHILE PLAY(0) > 0: WEND
   END SELECT
END SUB

SUB bind (char AS CHARACTER)
' This holds the special effect of binding and unbinding the character to and
' from the elemental.
   FOR flash% = 1 TO 25
      RANDOMIZE TIMER
      xaxis% = INT(RND * 3) - 1
      yaxis% = INT(RND * 3) - 1
      IF SCREEN(char.y + yaxis%, char.x + xaxis%) <> 219 AND NOT (xaxis% = 0 AND yaxis% = 0) THEN
         COLOR char.col
         LOCATE char.y + yaxis%, char.x + xaxis%
         IF SCREEN(char.y + yaxis%, char.x + xaxis%) <> 15 THEN
            PRINT CHR$(15)
         ELSE
            PRINT " "
         END IF
      END IF
      stopfor .05
      IF flash% MOD 3 = 0 THEN PLAY "mbmst700o2l64" + char.weapwave
   NEXT
   FOR count% = -1 TO 1
      FOR count2% = -1 TO 1
         IF SCREEN(char.y + count%, char.x + count2%) = 15 THEN
            LOCATE char.y + count%, char.x + count2%
            PRINT " "
         END IF
      NEXT
   NEXT
END SUB

SUB blob.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF target(1).y < char.y AND (target(1).x >= char.x - 3 AND target(1).x <= char.x + 3 OR target(1).y < char.y AND SCREEN(char.y, char.x - 1) = 219 OR SCREEN(char.y, char.x + 1) = 219) THEN
            jump char
            char.status = "j"
            ram char, target(1)
         ELSEIF target(1).x < char.x THEN
            left char
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            ram char, target(1)
         END IF
      ELSEIF char.status = "j" THEN
         jump char
         IF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
         ram char, target(1)
      ELSEIF char.status = "d" THEN
         descend char
         IF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
         ram char, target(1)
      END IF
   END IF
END SUB

SUB calibrate
   CLS 0
   WHILE STRIG(1) = -1 OR STRIG(5) = -1: WEND
   COLOR 15
   LOCATE 1, 1
   PRINT "Center joystick and press button (that"
   PRINT "means hold no directions)"
   WHILE STRIG(1) = 0 AND STRIG(5) = 0: WEND
   centery% = STICK(1)
   centerx% = STICK(0)
   WHILE STRIG(1) = -1 OR STRIG(5) = -1: WEND
   PRINT
   PRINT "Position your joystick toward the upper"
   PRINT "left cornor and press a button"
   WHILE STRIG(1) = 0 AND STRIG(5) = 0: WEND
   up% = STICK(1)
   jsleft% = STICK(0)
   WHILE STRIG(1) = -1 OR STRIG(5) = -1: WEND
   PRINT
   PRINT "Position your joystick toward the lower"
   PRINT "right cornor and press a button"
   WHILE STRIG(1) = 0 AND STRIG(5) = 0: WEND
   down% = STICK(1)
   jsright% = STICK(0)
   dirup = (up% + centery%) / 2
   dirdown = (centery% + down%) / 2
   dirleft = (jsleft% + centerx%) / 2
   dirright = (centerx% + jsright%) / 2
   WHILE STRIG(1) = -1 OR STRIG(5) = -1: WEND
   PRINT
   PRINT "Joystick calibrated. You may view your"
   PRINT "configurations by going to View Controls"
   PRINT "at the main menu."
   OPEN "killin/joystick.kil" FOR OUTPUT AS #1
   WRITE #1, dirup, dirright, dirdown, dirleft
   CLOSE #1
   LOCATE 23, 1
   PRINT "Press any key or button to continue"
   WHILE INKEY$ = "" AND STRIG(1) = 0 AND STRIG(5) = 0: WEND
   CLS 0
END SUB

SUB construct (l AS INTEGER, t AS INTEGER, r AS INTEGER, b AS INTEGER, col AS INTEGER)
   ' Creates blocks for the background.
   COLOR col
   FOR count = t TO b
      FOR count2 = l TO r
         LOCATE count, count2
         PRINT ""
      NEXT count2
   NEXT count
END SUB

SUB controls
   'Displays controls and shows when a button is being pressed
   CLS 0
   COLOR 15
   LOCATE 1, 1
   PRINT "[ ] Left", "Move character left"
   PRINT "[ ] Right", "Move character right"
   PRINT "[ ] Up", "Aim weapon up"
   PRINT "[ ] Button 1", "Attack"
   PRINT "[ ] Button 2", "Jump"
   PRINT "[ ] B1 + B2", "Special Attack"
   LOCATE 23, 2
   PRINT "Press Escape to exit test"
   COLOR 4
   WHILE INKEY$ <> CHR$(27)
      IF STICK(1) < dirup THEN
         LOCATE 3, 2
         PRINT "*"
      ELSEIF STICK(1) > dirup THEN
         LOCATE 3, 2
         PRINT " "
      END IF
      IF STICK(0) < dirleft THEN
         LOCATE 1, 2
         PRINT "*"
      ELSEIF STICK(0) > dirleft THEN
         LOCATE 1, 2
         PRINT " "
      END IF
      IF STICK(0) > dirright THEN
         LOCATE 2, 2
         PRINT "*"
      ELSEIF STICK(0) < dirright THEN
         LOCATE 2, 2
         PRINT " "
      END IF
      IF STRIG(1) = -1 THEN
         LOCATE 4, 2
         PRINT "*"
      ELSE
         LOCATE 4, 2
         PRINT " "
      END IF
      IF STRIG(5) = -1 THEN
         LOCATE 5, 2
         PRINT "*"
      ELSE
         LOCATE 5, 2
         PRINT " "
      END IF
      IF STRIG(1) = -1 AND STRIG(5) = -1 THEN
         LOCATE 6, 2
         PRINT "*"
      ELSE
         LOCATE 6, 2
         PRINT " "
      END IF
   WEND
   CLS 0
END SUB

SUB damage (char AS CHARACTER, target AS CHARACTER)
   ' This does damage for normal attacks and special attacks.
   target.curhealth = target.curhealth - char.strength
   COLOR 15
   IF target.align = "g" THEN
      LOCATE 5, 11
      PRINT USING "##"; target.curhealth
   END IF
   IF target.curhealth <= 0 THEN
      LOCATE target.y, target.x
      PRINT " "
      IF target.align = "e" THEN
         PLAY "mbmst300o2l64gf"
         message RTRIM$(target.role) + " was killed.", target.col
         makecharacter target, "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      ELSEIF target.align = "g" THEN
         LOCATE 5, 11
         PRINT " 0"
         message RTRIM$(target.role) + " was killed.", target.col
         makecharacter target, "", "", 0, 0, 0, 0, target.x, target.y, 0, "", "", 0, 0, "", "", "", ""
         fadeeffect
         END
      ELSEIF target.align = "i" THEN
         COLOR target.col
         LOCATE target.y, target.x
         PRINT target.char
      END IF
   END IF
END SUB

SUB descend (char AS CHARACTER)
   ' Move the character down and decide whether ground is beneath
   ' the character or not to return the status to normal.
   LOCATE char.y, char.x
   PRINT " "
   char.y = char.y + 1
   IF SCREEN(char.y, char.x) = 219 OR char.y >= 24 THEN
      char.status = " "
      char.y = char.y - 1
      char.foot = char.y
   END IF
   COLOR char.col
   LOCATE char.y, char.x
   PRINT char.char
END SUB

SUB druid.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x + 4 = char.x OR target(1).x - 4 = char.x AND char.curspecial > 0 THEN
            IF SCREEN(char.foot, char.x - 4) <> 219 AND SCREEN(char.foot, char.x + 4) <> 219 THEN
               char.status = "s"
               char.curspecial = char.curspecial - 1
               char.specialattack = char.foot
               IF target(1).x < char.x THEN LOCATE char.foot, char.x - 4
               IF target(1).x > char.x THEN LOCATE char.foot, char.x + 4
               COLOR char.col
               IF char.y MOD 2 = 1 THEN PRINT ""
               IF char.y MOD 2 = 0 THEN PRINT ""
            END IF
         ELSEIF target(1).y < char.y AND target(1).x + 3 >= char.x AND target(1).x - 3 <= char.x THEN
            jump char
            char.status = "j"
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "s" THEN
         IF char.x = target(1).x THEN
            IF char.foot MOD 2 = 1 THEN check = 195
            IF char.foot MOD 2 = 0 THEN check = 180
            grow = char.x - 4
            IF SCREEN(char.foot, char.x - 4) = check THEN grow = char.x - 4
            IF SCREEN(char.foot, char.x + 4) = check THEN grow = char.x + 4
            FOR count = char.specialattack TO char.foot STEP 1
               IF SCREEN(count, grow) <> 219 THEN
                  LOCATE count, grow
                  PRINT " "
               END IF
            NEXT
         ELSEIF char.foot - char.specialattack > 5 THEN
            char.status = ""
            grow = char.x - 4
            IF char.x < target(1).x THEN grow = char.x + 4
            IF char.x > target(1).x THEN grow = char.x - 4
            FOR count = char.specialattack TO char.foot STEP 1
               IF SCREEN(count, grow) <> 219 THEN
                  LOCATE count, grow
                  PRINT " "
               END IF
            NEXT
         ELSE
            PLAY "mbmst300o2l64" + char.weapwave
            grow = char.x - 4
            IF char.x < target(1).x THEN grow = char.x + 4
            IF char.x > target(1).x THEN grow = char.x - 4
            FOR count = char.specialattack TO char.foot STEP 1
               IF SCREEN(count, grow) <> 219 THEN
                  IF count = target(1).y AND grow = target(1).x AND target(1).status <> "s" THEN
                     jump target(1)
                     target(1).status = "j"
                     damage char, target(1)
                  END IF
                  LOCATE count, grow
                  COLOR char.col
                  IF count MOD 2 = 1 THEN PRINT ""
                  IF count MOD 2 = 0 THEN PRINT ""
               END IF
            NEXT
            char.specialattack = char.specialattack - 1
            char.attackwait = char.attackwait - (char.speed * .75)
         END IF
      END IF
   END IF
END SUB

SUB earth.control (char AS CHARACTER, target() AS CHARACTER)
   IF char.status = " " OR char.status = "j" OR char.status = "d" THEN
      IF STRIG(1) = -1 AND STRIG(5) = -1 THEN
         IF char.curspecial > 0 THEN
            IF char.status = " " THEN jump char
            char.curspecial = char.curspecial - 1
            char.status = "s"
            char.specialattack = 0
            COLOR 15
            LOCATE 5, 24
            PRINT USING "##"; char.curspecial
            FOR count = char.y TO 23
               IF SCREEN(count, char.x) = 219 THEN
                  char.foot = count - 1
                  EXIT FOR
               END IF
            NEXT
            PLAY "mbmst300o2l64" + char.weapwave
         END IF
      END IF
   ELSEIF char.status = "s" THEN
      quake char, target()
   END IF
END SUB

SUB endattack (char AS CHARACTER)
   ' This nulls out a current attack and erases the weapon in the background.
   IF TIMER > char.attackwait THEN
      char.status = char.oldstatus
      IF char.dir = "l" THEN
         LOCATE char.y, char.x - 1
      ELSEIF char.dir = "r" THEN
         LOCATE char.y, char.x + 1
      ELSEIF char.dir = "u" THEN
         LOCATE char.y - 1, char.x
      END IF
      PRINT " "
   END IF
END SUB

SUB fadeeffect
   'Fades the screen out to blackness.
   FOR col% = 31 TO 16 STEP -1
      COLOR col%
      FOR count = -14 TO 40
         FOR count2 = 10 TO 23
            IF count - 9 + count2 >= 1 AND count - 9 + count2 <= 40 THEN
               IF SCREEN(count2, count - 9 + count2) <> 32 THEN
                  LOCATE count2, count - 9 + count2
                  PRINT CHR$(SCREEN(count2, count - 9 + count2))
               END IF
            END IF
         NEXT
      NEXT
   NEXT
   EXIT SUB
   ' This next part fades in and out again, but seems useless.
   FOR col% = 17 TO 31
      COLOR col%
      FOR count = -14 TO 40
         FOR count2 = 10 TO 23
            IF count - 9 + count2 >= 1 AND count - 9 + count2 <= 40 THEN
               LOCATE count2, count - 9 + count2
               PRINT ""
            END IF
         NEXT
      NEXT
   NEXT
   FOR col% = 31 TO 17 STEP -1
      COLOR col%
      FOR count = -14 TO 40
         FOR count2 = 10 TO 23
            IF count - 9 + count2 >= 1 AND count - 9 + count2 <= 40 THEN
               LOCATE count2, count - 9 + count2
               PRINT ""
            END IF
         NEXT
      NEXT
   NEXT
   FOR count = -14 TO 40
      FOR count2 = 10 TO 23
         IF count - 9 + count2 >= 1 AND count - 9 + count2 <= 40 THEN
            LOCATE count2, count - 9 + count2
            PRINT " "
         END IF
      NEXT
   NEXT
END SUB

SUB fire.control (char AS CHARACTER, target() AS CHARACTER)
   IF char.status = " " OR char.status = "d" OR char.status = "j" THEN
      IF STRIG(1) = -1 AND STRIG(5) = -1 THEN
         IF STICK(0) > dirright THEN
            char.dir = "r"
         ELSEIF STICK(0) < dirleft THEN
            char.dir = "l"
         ELSEIF STICK(1) < dirup THEN
            char.dir = "u"
         END IF
         IF char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.oldstatus = char.status
            char.status = "s"
            COLOR 15
            LOCATE 5, 24
            PRINT USING "##"; char.curspecial
            PLAY "mbmst300o2l64" + char.weapwave
            IF char.dir = "l" THEN
               char.specialattack = char.x - 1
               IF char.specialattack < char.x - 20 OR char.specialattack < 2 OR SCREEN(char.y, char.specialattack) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.y, char.specialattack
               PRINT ""
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
                     left target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            ELSEIF char.dir = "r" THEN
               char.specialattack = char.x + 1
               IF char.specialattack > char.x + 20 OR char.specialattack > 39 OR SCREEN(char.y, char.specialattack) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.y, char.specialattack
               PRINT ""
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
                     right target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            ELSEIF char.dir = "u" THEN
               char.specialattack = char.y - 1
               IF char.specialattack < char.y - 20 OR char.specialattack < 10 OR SCREEN(char.specialattack, char.x) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.specialattack, char.x
               PRINT "^"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.x = target(enemy).x AND char.specialattack = target(enemy).y THEN
                     jump target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
            fireball char, target()
         END IF
      END IF
   ELSEIF char.status = "s" THEN
      fireball char, target()
   END IF
END SUB

SUB fireball (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      IF char.dir = "r" THEN
         FOR enemy = 1 TO UBOUND(target)
            IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
               right target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
         LOCATE char.y, char.specialattack
         PRINT " "
         char.specialattack = char.specialattack + 1
         IF char.specialattack > char.x + 10 OR char.specialattack < char.x OR char.specialattack > 39 OR SCREEN(char.y, char.specialattack) = 219 THEN
            char.status = char.oldstatus
            EXIT SUB
         END IF
         COLOR 4
         LOCATE char.y, char.specialattack
         PRINT ""
         FOR enemy = 1 TO UBOUND(target)
            IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
               'right target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
      ELSEIF char.dir = "l" THEN
         FOR enemy = 1 TO UBOUND(target)
            IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
               left target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
         LOCATE char.y, char.specialattack
         PRINT " "
         char.specialattack = char.specialattack - 1
         IF char.specialattack < char.x - 10 OR char.specialattack > char.x OR char.specialattack < 2 OR SCREEN(char.y, char.specialattack) = 219 THEN
            char.status = char.oldstatus
            EXIT SUB
         END IF
         COLOR 4
         LOCATE char.y, char.specialattack
         PRINT ""
         FOR enemy = 1 TO UBOUND(target)
            IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
               'left target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
      ELSEIF char.dir = "u" THEN
         FOR enemy = 1 TO UBOUND(target)
            IF char.x = target(enemy).x AND char.specialattack = target(enemy).y THEN
               jump target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
         LOCATE char.specialattack, char.x
         PRINT " "
         char.specialattack = char.specialattack - 1
         COLOR 4
         IF char.specialattack < char.y - 10 OR char.specialattack < 10 OR SCREEN(char.specialattack, char.x) = 219 THEN
            char.status = char.oldstatus
            EXIT SUB
         END IF
         LOCATE char.specialattack, char.x
         PRINT "^"
         FOR enemy = 1 TO UBOUND(target)
            IF char.x = target(enemy).x AND char.specialattack = target(enemy).y THEN
               'jump target(enemy)
               damage char, target(enemy)
            END IF
         NEXT
      END IF
      char.attackwait = TIMER + .1
   END IF
END SUB

SUB flight (char AS CHARACTER, target() AS CHARACTER)
   'This sub controls the Wind character Special attack, forcing him to move
   'every turn and mock-attack. This is useful to get to hard to reach
   'platforms and ledges.
   IF TIMER > char.attackwait THEN
   char.specialattack = char.specialattack + 1
   IF char.dir = "l" THEN
      left char
      char.status = "s"
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x AND target(enemy).y = char.y THEN
            'left target(enemy)
            damage char, target(enemy)
         END IF
         IF target(enemy).x = char.x - 1 AND target(enemy).y = char.y THEN
            left target(enemy)
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y, char.x - 1) = 219 THEN
         char.status = "d"
         char.attackwait = 0
         char.specialattack = 0
         EXIT SUB
      END IF
      COLOR char.weapcol
      LOCATE char.y, char.x - 1
      PRINT char.weapl
   ELSEIF char.dir = "r" THEN
      right char
      char.status = "s"
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x AND target(enemy).y = char.y THEN
            'right target(enemy)
            damage char, target(enemy)
         END IF
         IF target(enemy).x = char.x + 1 AND target(enemy).y = char.y THEN
            right target(enemy)
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y, char.x + 1) = 219 THEN
         char.status = "d"
         char.attackwait = 0
         char.specialattack = 0
         EXIT SUB
      END IF
      COLOR char.weapcol
      LOCATE char.y, char.x + 1
      PRINT char.weapr
   ELSEIF char.dir = "u" THEN
      jump char
      char.status = "s"
      FOR enemy = 1 TO UBOUND(target)
         IF target(enemy).x = char.x AND target(enemy).y = char.y THEN
            'jump target(enemy)
            damage char, target(enemy)
         END IF
         IF target(enemy).x = char.x AND target(enemy).y = char.y - 1 THEN
            jump target(enemy)
            damage char, target(enemy)
         END IF
      NEXT
      IF SCREEN(char.y - 1, char.x) = 219 THEN
         char.status = "d"
         char.attackwait = 0
         char.specialattack = 0
         EXIT SUB
      END IF
      COLOR char.weapcol
      LOCATE char.y - 1, char.x
      PRINT char.weapu
   END IF
   char.attackwait = TIMER + .1
   IF char.specialattack >= 10 THEN
      char.oldstatus = "d"
      char.attackwait = 0
      endattack char
      char.specialattack = 0
   END IF
   END IF
END SUB

SUB getitem (item AS CHARACTER, char AS CHARACTER)
   ' Gives out an item and sets its effect upon the character.
   PLAY "mbmst300o2l64baba."
   COLOR 15
   IF item.role = "Potion      " THEN
      char.curhealth = char.curhealth + item.special
      IF char.curhealth > char.health THEN char.curhealth = char.health
      LOCATE 5, 11
      PRINT USING "##"; char.curhealth
   ELSEIF item.role = "Ether       " THEN
      char.curspecial = char.curspecial + item.special
      IF char.curspecial > char.special THEN char.curspecial = char.special
      LOCATE 5, 24
      PRINT USING "##"; char.curspecial
   ELSEIF item.role = "LifeFilter  " THEN
      char.health = char.health + item.special
   ELSEIF item.role = "SoulFilter  " THEN
      char.special = char.special + item.special
   ELSEIF item.role = "Vengence    " THEN
      char.strength = 2
      char.weapcol = 112
      char.weapu = CHR$(25)
      char.weapl = CHR$(26)
      char.weapr = CHR$(27)
   ELSEIF item.role = "WingBoots   " THEN
      char.leap = 6
   ELSEIF item.role = "DaemonEdge  " THEN
      char.strength = 3
      char.weapcol = 7
      char.weapu = CHR$(25)
      char.weapl = CHR$(26)
      char.weapr = CHR$(27)
   END IF
   char.items = char.items + item.items
   message RTRIM$(item.role) + " was received.", item.col
   makecharacter item, "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
END SUB

SUB ghost.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
         char.dir = "l"
         attack char, target()
      ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
         char.dir = "r"
         attack char, target()
      ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
         char.dir = "u"
         attack char, target()
      ELSEIF target(1).x < char.x AND target(1).y < char.y THEN
         left char
         jump char
      ELSEIF target(1).x < char.x AND target(1).y > char.y THEN
         left char
         descend char
      ELSEIF target(1).x > char.x AND target(1).y < char.y THEN
         right char
         jump char
      ELSEIF target(1).x > char.x AND target(1).y > char.y THEN
         right char
         descend char
      ELSEIF target(1).x < char.x THEN
         left char
      ELSEIF target(1).x > char.x THEN
         right char
      ELSEIF target(1).y < char.y THEN
         jump char
      ELSEIF target(1).y > char.y THEN
         descend char
      END IF
   END IF
END SUB

SUB heart.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.specialattack > 0 THEN
            char.specialattack = char.specialattack - 1
         ELSEIF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x + 3 AND char.y = target(1).y AND char.curspecial > 0 THEN
            left char
            left char
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x - 3 AND char.y = target(1).y AND char.curspecial > 0 THEN
            right char
            right char
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).y < char.y THEN
            jump char
            char.status = "j"
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         IF char.y = char.foot - char.leap + 1 AND char.curspecial > 0 AND char.x + 10 > target(1).x AND char.x - 10 < target(1).x THEN
            IF char.specialattack < 10 THEN
               char.specialattack = char.specialattack + 1
               COLOR char.col
               LOCATE char.y, char.x
               PRINT char.char
               LOCATE char.y - 1, char.x
               IF char.specialattack MOD 2 = 0 THEN
                  PRINT CHR$(3)
               ELSEIF char.specialattack MOD 2 = 1 THEN
                  PRINT CHR$(179)
               END IF
               char.status = "j"
            ELSE
               char.curspecial = char.curspecial - 1
               char.status = "s"
               char.specialattack = 0
            END IF
         ELSE
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = char.attackwait - char.speed / 2
         descend char
         ram char, target(1)
         FOR count = char.foot - char.leap TO char.y - 1 STEP 1
            IF count = target(1).y AND char.x = target(1).x AND target(1).status <> "s" THEN
               jump target(1)
               damage char, target(1)
               PLAY char.weapwave
            END IF
            COLOR char.col
            LOCATE count, char.x
            IF (char.y + count) MOD 2 = 0 THEN
               PRINT CHR$(3)
            ELSEIF (char.y + count) MOD 2 = 1 THEN
               PRINT CHR$(179)
            END IF
         NEXT
         IF char.y = char.foot THEN
            FOR count = char.foot - char.leap - 1 TO char.foot - 1
               LOCATE count, char.x
               PRINT " "
            NEXT
         END IF
      END IF
   END IF
END SUB

SUB jump (char AS CHARACTER)
   ' Moves the character upward and decides whether or not to halt the jump.
   LOCATE char.y, char.x
   PRINT " "
   char.y = char.y - 1
   IF SCREEN(char.y, char.x) = 219 OR char.y < 10 THEN
      char.status = "d"
      char.y = char.y + 1
   END IF
   COLOR char.col
   LOCATE char.y, char.x
   PRINT char.char
   IF char.y <= char.foot - char.leap THEN char.status = "d"
END SUB

SUB knight.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x + 3 AND char.y = target(1).y AND char.curspecial > 0 THEN
            left char
            left char
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x - 3 AND char.y = target(1).y AND char.curspecial > 0 THEN
            right char
            right char
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF SCREEN(char.y, char.x - 1) = 219 AND char.x > target(1).x THEN
            jump char
            char.status = "j"
         ELSEIF SCREEN(char.y, char.x + 1) = 219 AND char.x < target(1).x THEN
            jump char
            char.status = "j"
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      END IF
   END IF
END SUB

SUB left (char AS CHARACTER)
   ' Moves character left.
   LOCATE char.y, char.x
   PRINT " "
   char.x = char.x - 1
   char.dir = "l"
   IF char.x < 2 OR SCREEN(char.y, char.x) = 219 THEN char.x = char.x + 1
   IF char.status <> "j" AND SCREEN(char.y + 1, char.x) <> 219 THEN char.status = "d"
   COLOR char.col
   LOCATE char.y, char.x
   PRINT char.char
END SUB

SUB load (char AS CHARACTER, scene%)
   filenum$ = "0"
   DO UNTIL VAL(filenum$) >= 1 AND VAL(filenum$) <= 5
      message "Load which game number (1-5) ?", 15
      filenum$ = INPUT$(1)
   LOOP
   message " ****  Loading Old File  ****", 7
   OPEN "killin/" + filenum$ + ".kil" FOR INPUT AS #1
   INPUT #1, char.role, alig, char.health, char.curhealth, char.strength, char.special, char.curspecial, char.speed, char.x, char.y, chr, char.col, dir, char.leap, char.foot, char.weapcol, weapl, weapr, weapu, weapwave, scene%
   CLOSE #1
   char.align = CHR$(alig)
   char.char = CHR$(chr)
   char.dir = CHR$(dir)
   char.weapl = CHR$(weapl)
   char.weapr = CHR$(weapr)
   char.weapu = CHR$(weapu)
   char.weapwave = CHR$(weapwave)
   message " ****   Game    Loaded   ****", 15
   file$ = filenum$
   waiter
END SUB

SUB mage.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).y < char.y AND target(1).x + 7 >= char.x AND target(1).x - 7 <= char.x THEN
            jump char
            char.status = "j"
         ELSEIF target(1).y = char.y AND (target(1).x + 5 <= char.x AND target(1).x + 10 >= char.x OR target(1).x - 10 <= char.x AND target(1).x - 5 >= char.x OR char.x = target(1).x AND char.y > target(1).y) AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.oldstatus = char.status
            char.attackwait = TIMER - 1
            char.status = "s"
            PLAY "mbmst300o2l64" + char.weapwave
            IF target(1).x < char.x THEN
               char.dir = "l"
               char.specialattack = char.x - 1
               IF char.specialattack < char.x - 20 OR char.specialattack < 2 OR SCREEN(char.y, char.specialattack) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.y, char.specialattack
               PRINT ""
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
                     left target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            ELSEIF target(1).x > char.x THEN
               char.dir = "r"
               char.specialattack = char.x + 1
               IF char.specialattack > char.x + 20 OR char.specialattack > 39 OR SCREEN(char.y, char.specialattack) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.y, char.specialattack
               PRINT ""
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.specialattack = target(enemy).x THEN
                     right target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            ELSEIF char.y < target(1).y THEN
               char.dir = "u"
               char.specialattack = char.y - 1
               IF char.specialattack < char.y - 20 OR char.specialattack < 10 OR SCREEN(char.specialattack, char.x) = 219 THEN
                  char.status = char.oldstatus
                  EXIT SUB
               END IF
               COLOR 4
               LOCATE char.specialattack, char.x
               PRINT "^"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.x = target(enemy).x AND char.specialattack = target(enemy).y THEN
                     jump target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
            fireball char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = TIMER - 1
         fireball char, target()
      END IF
   END IF
END SUB

SUB main.control (char() AS CHARACTER, target() AS CHARACTER, bgindex AS INTEGER)
   IF TIMER > char(1).attackwait THEN
      char(1).attackwait = TIMER + char(1).speed
      IF char(1).status = " " THEN
      IF STRIG(1) = -1 THEN
         IF STICK(0) > dirright THEN
            char(1).dir = "r"
         ELSEIF STICK(0) < dirleft THEN
            char(1).dir = "l"
         ELSEIF STICK(1) < dirup THEN
            char(1).dir = "u"
         END IF
         attack char(1), target()
      ELSEIF STRIG(5) = -1 THEN
         char(1).status = "j"
         char(1).foot = char(1).y
         jump char(1)
      ELSEIF STICK(0) > dirright THEN
         IF char(1).x = 39 THEN
            bgindex = bgindex + 1
            background bgindex, char(1), target()
         END IF
         right char(1)
      ELSEIF STICK(0) < dirleft THEN
         IF char(1).x = 2 THEN
            bgindex = bgindex - 1
            background bgindex, char(1), target()
         END IF
         left char(1)
      END IF
   ELSEIF char(1).status = "x" THEN
      char(1).attackwait = 0
      endattack char(1)
   ELSEIF char(1).status = "j" THEN
      jump char(1)
      IF STRIG(1) = -1 THEN
         IF STICK(0) > dirright THEN
            char(1).dir = "r"
         ELSEIF STICK(0) < dirleft THEN
            char(1).dir = "l"
         ELSEIF STICK(1) < dirup THEN
            char(1).dir = "u"
         END IF
         attack char(1), target()
      ELSEIF STICK(0) < dirleft THEN
         IF char(1).x = 2 THEN
            bgindex = bgindex - 1
            background bgindex, char(1), target()
         END IF
         left char(1)
      ELSEIF STICK(0) > 70 THEN
         IF char(1).x = 39 THEN
            bgindex = bgindex + 1
            background bgindex, char(1), target()
         END IF
         right char(1)
      END IF
   ELSEIF char(1).status = "d" THEN
      descend char(1)
      IF STRIG(1) = -1 THEN
         IF STICK(0) > dirright THEN
            char(1).dir = "r"
         ELSEIF STICK(0) < dirleft THEN
            char(1).dir = "l"
         ELSEIF STICK(1) < dirup THEN
            char(1).dir = "u"
         END IF
         attack char(1), target()
      ELSEIF STICK(0) < dirleft THEN
         IF char(1).x = 2 THEN
            bgindex = bgindex - 1
            background bgindex, char(1), target()
         END IF
         left char(1)
      ELSEIF STICK(0) > 70 THEN
         IF char(1).x = 39 THEN
            bgindex = bgindex + 1
            background bgindex, char(1), target()
         END IF
         right char(1)
      END IF
   END IF
   END IF
   FOR enemy = 1 TO UBOUND(target)
      IF target(enemy).role = "Blob        " THEN blob.control target(enemy), char()
      IF target(enemy).role = "Spiker      " THEN spiker.control target(enemy), char()
      IF target(enemy).role = "Knight      " THEN knight.control target(enemy), char()
      IF target(enemy).role = "Ghost       " THEN ghost.control target(enemy), char()
      IF target(enemy).role = "Sprite      " THEN sprite.control target(enemy), char()
      IF target(enemy).role = "Aracane     " THEN aracane.control target(enemy), char()
      IF target(enemy).role = "Mage        " THEN mage.control target(enemy), char()
      IF target(enemy).role = "Scynscatha  " THEN scynscatha.control target(enemy), char()
      IF target(enemy).role = "Mole        " THEN mole.control target(enemy), char()
      IF target(enemy).role = "JackOfHearts" THEN heart.control target(enemy), char()
      IF target(enemy).role = "Scorpion    " THEN scorpion.control target(enemy), char()
      IF target(enemy).role = "Druid       " THEN druid.control target(enemy), char()
      IF target(enemy).role = "Phantom     " THEN phantom.control target(enemy), char()
      IF target(enemy).role = "watchman    " AND target(1).curhealth <= 0 AND char(1).status <> "s" THEN watchman.control target(), char(1), bgindex
      IF target(enemy).align = "i" THEN
         IF char(1).x = target(enemy).x AND char(1).y = target(enemy).y THEN
            getitem target(enemy), char(1)
         ELSEIF TIMER > target(enemy).attackwait THEN
            target(enemy).attackwait = TIMER + .1
            COLOR target(enemy).col
            LOCATE target(enemy).y, target(enemy).x
            PRINT target(enemy).char
            IF SCREEN(target(enemy).y + 1, target(enemy).x) <> 219 THEN descend target(enemy)
         END IF
      END IF
   NEXT
END SUB

SUB makecharacter (char AS CHARACTER, role AS STRING, align AS STRING, health AS INTEGER, strength AS INTEGER, special AS INTEGER, speed AS SINGLE, x AS INTEGER, y AS INTEGER, col AS INTEGER, chr AS STRING, dir AS STRING, leap AS INTEGER, weapcol AS INTEGER, weapl AS STRING, weapr AS STRING, weapu AS STRING, weapwave AS STRING)
   ' Makes any character.
   char.role = role
   char.align = align
   char.health = health
   char.curhealth = health
   char.strength = strength
   char.special = special
   char.curspecial = special
   char.speed = speed
   char.x = x
   char.y = y
   char.col = col
   char.char = chr
   char.dir = dir
   char.leap = leap
   char.foot = y
   char.weapcol = weapcol
   char.weapl = weapl
   char.weapr = weapr
   char.weapu = weapu
   char.weapwave = weapwave
   char.status = " "
   char.oldstatus = " "
END SUB

SUB makeenemy (char AS CHARACTER, role AS STRING, x AS INTEGER, y AS INTEGER)
   IF role = "Blob" THEN makecharacter char, "Blob", "e", 2, 1, 5, .25, x, y, 10, CHR$(220), "l", 3, 10, CHR$(250), CHR$(250), CHR$(250), "e"
   IF role = "Spiker" THEN makecharacter char, "Spiker", "e", 5, 2, 5, 0, x, y, 1, CHR$(127), "u", 6, 1, CHR$(196), CHR$(196), CHR$(179), "g"
   IF role = "Sprite" THEN makecharacter char, "Sprite", "e", 1, 1, 10, .05, x, y, 13, CHR$(157), "l", 5, 11, CHR$(176), CHR$(176), CHR$(176), "b"
   IF role = "Knight" THEN makecharacter char, "Knight", "e", 4, 2, 5, .35, x, y, 20, CHR$(1), "l", 1, 18, CHR$(26), CHR$(27), CHR$(25), "c"
   IF role = "Ghost" THEN makecharacter char, "Ghost", "e", 2, 2, 20, .2, x, y, 15, CHR$(148), "l", 7, 17, CHR$(15), CHR$(15), CHR$(15), "a"
   IF role = "Aracane" THEN makecharacter char, "Aracane", "e", 3, 2, 10, .3, x, y, 136, CHR$(15), "l", 6, 17, CHR$(176), CHR$(176), CHR$(176), "d"
   IF role = "Mage" THEN makecharacter char, "Mage", "e", 4, 1, 20, .325, x, y, 106, CHR$(1), "l", 3, 4, CHR$(196), CHR$(196), CHR$(179), "b"
   IF role = "Scynscatha" THEN makecharacter char, "Scynscatha", "l", 10, 2, 5, .2, x, y, 14, CHR$(1), "l", 5, 8, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "Mole" THEN makecharacter char, "Mole", "l", 15, 1, 10, .15, x, y, 6, CHR$(236), "u", 7, 15, CHR$(60), CHR$(62), CHR$(94), "d"
   IF role = "Scynscatha2" THEN makecharacter char, "Scynscatha", "l", 15, 2, 10, .2, x, y, 14, CHR$(1), "l", 5, 8, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "JackOfHearts" THEN makecharacter char, "JackOfHearts", "l", 15, 2, 20, .1, x, y, 5, CHR$(1), "l", 7, 7, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "Scynscatha3" THEN makecharacter char, "Scynscatha", "l", 20, 3, 15, .17, x, y, 14, CHR$(1), "l", 5, 8, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "Scorpion" THEN makecharacter char, "Scorpion", "l", 20, 3, 5, .3, x, y, 139, CHR$(147), "l", 3, 139, ">", "<", CHR$(244), "f"
   IF role = "Druid" THEN makecharacter char, "Druid", "l", 30, 2, 30, .2, x, y, 120, CHR$(1), "l", 6, 240, CHR$(27), CHR$(26), CHR$(28), "d"
   IF role = "Scynscatha4" THEN makecharacter char, "Scynscatha", "l", 40, 3, 20, .15, x, y, 14, CHR$(1), "l", 5, 8, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "Phantom" THEN makecharacter char, "Phantom", "l", 35, 2, 30, .25, x, y, 20, CHR$(32), "l", 4, 7, CHR$(26), CHR$(27), CHR$(25), "a"
   IF role = "Scynscatha5" THEN makecharacter char, "Scynscatha", "l", 60, 3, 25, .14, x, y, 14, CHR$(1), "l", 5, 8, CHR$(26), CHR$(27), CHR$(25), "b"
END SUB

SUB makeitem (item AS CHARACTER, role AS STRING, id AS SINGLE, x AS INTEGER, y AS INTEGER)
   IF role = "Potion" THEN
      makecharacter item, "Potion", "i", 1, 0, 10, 0, x, y, 7, CHR$(232), "", 0, 0, "", "", "", "b"
      item.items = id
   ELSEIF role = "Ether" THEN
      makecharacter item, "Ether", "i", 1, 0, 5, 0, x, y, 11, CHR$(232), "", 0, 0, "", "", "", "c"
      item.items = id
   ELSEIF role = "LifeFilter" THEN
      makecharacter item, "LifeFilter", "i", 1, 0, 5, 0, x, y, 5, CHR$(232), "", 0, 0, "", "", "", "d"
   ELSEIF role = "SoulFilter" THEN
      makecharacter item, "SoulFilter", "i", 1, 0, 5, 0, x, y, 1, CHR$(232), "", 0, 0, "", "", "", "e"
   ELSEIF role = "Vengence" THEN
      makecharacter item, "Vengence  ", "i", 1, 0, 5, 0, x, y, 112, CHR$(25), "", 0, 0, "", "", "", "g"
   ELSEIF role = "WingBoots" THEN
      makecharacter item, "WingBoots ", "i", 1, 0, 5, 0, x, y, 43, CHR$(156), "", 0, 0, "", "", "", "g"
      item.items = id
   ELSEIF role = "DaemonEdge" THEN
      makecharacter item, "DaemonEdge", "i", 1, 0, 5, 0, x, y, 14, CHR$(25), "", 0, 0, "", "", "", "b"
   END IF
END SUB

SUB makeplayer (char AS CHARACTER, role AS STRING, x AS INTEGER, y AS INTEGER)
   IF role = "Seth" THEN makecharacter char, "Seth", "g", 7, 0, 0, .1, x, y, 7, CHR$(1), "r", 4, 7, CHR$(249), CHR$(249), CHR$(249), "f"
   IF role = "Fire" THEN makecharacter char, "Fire", "g", 10, 1, 10, .1, x, y, 4, CHR$(1), "r", 5, 8, CHR$(26), CHR$(27), CHR$(25), "g"
   IF role = "Wind" THEN makecharacter char, "Wind", "g", 10, 1, 10, .1, x, y, 1, CHR$(1), "r", 5, 8, CHR$(27), CHR$(26), CHR$(24), "a"
   IF role = "Water" THEN makecharacter char, "Water", "g", 10, 1, 10, .1, x, y, 3, CHR$(1), "r", 5, 7, CHR$(27), CHR$(26), CHR$(24), "e"
   IF role = "Earth" THEN makecharacter char, "Earth", "g", 10, 1, 10, .1, x, y, 8, CHR$(1), "r", 5, 20, CHR$(199), CHR$(182), CHR$(209), "c"
   IF role = "Light" THEN makecharacter char, "Light", "g", 10, 1, 10, .1, x, y, 15, CHR$(1), "r", 5, 7, CHR$(26), CHR$(27), CHR$(25), "b"
   IF role = "Dark" THEN makecharacter char, "Dark", "g", 10, 1, 10, .1, x, y, 20, CHR$(1), "r", 5, 19, CHR$(26), CHR$(27), CHR$(25), "d"
   IF role = "Ice" THEN makecharacter char, "Ice", "g", 10, 1, 10, 0, .1, y, 11, CHR$(1), "r", 5, 7, CHR$(195), CHR$(180), CHR$(194), "g"
   IF role = "Magma" THEN makecharacter char, "Magma", "g", 10, 1, 10, .1, x, y, 42, CHR$(1), "r", 5, 21, CHR$(215), CHR$(215), CHR$(216), "e"
   IF role = "Crystal" THEN makecharacter char, "Crystal", "g", 10, 1, 10, .1, x, y, 57, CHR$(1), "r", 5, 7, CHR$(195), CHR$(180), CHR$(194), "b"
   IF role = "Lightning" THEN makecharacter char, "Lightning", "g", 10, 1, 10, .1, x, y, 14, CHR$(1), "r", 5, 8, CHR$(26), CHR$(27), CHR$(25), "g"
END SUB

SUB message (quote AS STRING, col AS INTEGER)
   COLOR col
   LOCATE 7, 2
   IF LEN(quote) > 38 THEN
      PRINT "error: string too long"
   ELSE
      PRINT quote; STRING$(38 - LEN(quote), " ")
   END IF
END SUB

SUB mole.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.y = char.foot THEN
            LOCATE char.y, char.x
            PRINT " "
            char.y = char.foot + 1
         END IF
         IF char.specialattack > 10 THEN
            char.specialattack = 0
            char.status = "j"
            char.dir = "u"
            char.y = char.y - 1
            PLAY "mbmst300o2l64" + char.weapwave
            ram char, target(1)
            COLOR char.col
            LOCATE char.y, char.x
            PRINT char.char
         ELSEIF target(1).x < char.x THEN
            char.x = char.x - 1
            char.specialattack = char.specialattack + 1
         ELSEIF target(1).x > char.x THEN
            char.x = char.x + 1
            char.specialattack = char.specialattack + 1
         ELSE
            char.specialattack = char.specialattack + 1
         END IF
      ELSEIF char.status = "j" THEN
         jump char
         ram char, target(1)
      ELSEIF char.status = "d" THEN
         descend char
         IF target(1).x + 5 > char.x AND target(1).x - 5 < char.x AND SCREEN(char.y + 1, char.x) = 219 THEN
            IF char.curspecial > 0 THEN
               char.curspecial = char.curspecial - 1
               char.status = "s"
               char.specialattack = 0
               FOR count = char.y TO 23
                  IF SCREEN(count, char.x) = 219 THEN
                     char.foot = count - 1
                     EXIT FOR
                  END IF
               NEXT
               PLAY "mbmst300o2l64" + char.weapwave
            END IF
         ELSE
            ram char, target(1)
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = 0
         quake char, target()
         IF char.specialattack = 0 THEN descend char
      END IF
   END IF
END SUB

SUB phantom.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF char.x < target(1).x AND target(1).x <= char.x + 7 AND target(1).y = char.y AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "r"
            char.status = "s"
            char.oldstatus = " "
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF char.x > target(1).x AND target(1).x >= char.x - 7 AND target(1).y = char.y AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "l"
            char.status = "s"
            char.oldstatus = " "
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF char.y > target(1).y AND target(1).x = char.x AND target(1).y >= char.y - 7 AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "u"
            char.status = "s"
            char.oldstatus = " "
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF target(1).y < char.y - 2 THEN
            jump char
            char.status = "j"
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF char.x < target(1).x AND target(1).x <= char.x + 7 AND target(1).y = char.y AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "r"
            char.status = "s"
            char.oldstatus = "j"
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF char.x > target(1).x AND target(1).x >= char.x - 7 AND target(1).y = char.y AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "l"
            char.status = "s"
            char.oldstatus = "j"
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF char.y > target(1).y AND target(1).x = char.x AND target(1).y >= char.y - 7 AND char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.dir = "u"
            char.status = "s"
            char.oldstatus = "j"
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF target(1).x < char.x - 1 THEN
            left char
         ELSEIF target(1).x > char.x + 1 THEN
            right char
         ELSEIF target(1).x = char.x THEN
            IF char.dir = "l" OR char.dir = "u" THEN left char
            IF char.dir = "r" THEN right char
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = 0
         flight char, target()
         IF char.specialattack = 0 THEN
            char.attackwait = TIMER + char.speed * 4
         ELSE
            char.attackwait = TIMER + char.speed
         END IF
      END IF
   END IF
END SUB

SUB quake (char AS CHARACTER, target() AS CHARACTER)
   'Special Attack used by the Earth Player and the Mole
   IF TIMER > char.attackwait THEN
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      FOR count = char.x - 3 TO char.x + 3
         IF count > 1 AND count < 40 THEN
            IF SCREEN(char.foot, count) <> 219 AND SCREEN(char.foot + 1, count) = 219 THEN
               LOCATE char.foot, count
               PRINT " "
            END IF
         END IF
      NEXT
      FOR count = char.x - 3 TO char.x + 3
         IF count > 1 AND count < 40 THEN
            IF SCREEN(char.foot, count) <> 219 AND SCREEN(char.foot + 1, count) = 219 AND count * TIMER MOD 2 = 1 THEN
               PLAY "mbmst700o0l64b"
               COLOR 6
               LOCATE char.foot, count
               PRINT ""
            END IF
         END IF
      NEXT
      FOR count = char.x - 3 TO char.x + 3
         IF count > 1 AND count < 40 THEN
            FOR enemy = 1 TO UBOUND(target)
               IF SCREEN(char.foot, count) <> 219 AND SCREEN(char.foot + 1, count) = 219 AND count * TIMER MOD 2 = 1 AND count = target(enemy).x AND char.foot = target(enemy).y THEN
                  IF target(enemy).x < char.x THEN left target(enemy)
                  IF target(enemy).x > char.x THEN right target(enemy)
                  damage char, target(enemy)
               END IF
            NEXT
         END IF
      NEXT
      char.specialattack = char.specialattack + 1
      IF char.specialattack > 10 THEN
         char.status = "d"
         char.specialattack = 0
         FOR count = char.x - 3 TO char.x + 3
            IF count > 1 AND count < 40 THEN
               IF SCREEN(char.foot, count) = 220 THEN
                  LOCATE char.foot, count
                  PRINT " "
               END IF
            END IF
         NEXT
      END IF
      char.attackwait = TIMER + .09
   END IF
END SUB

SUB ram (char AS CHARACTER, target AS CHARACTER)
   ' Used by enemies without weapons, checks for collision between character
   ' and enemy.
   IF char.x = target.x AND char.y = target.y AND target.status <> "s" AND target.oldstatus <> "s" THEN
      direction$ = target.dir
      IF char.dir = "l" THEN
         left target
      ELSEIF char.dir = "r" THEN
         right target
      ELSEIF char.dir = "u" THEN
         jump target
         target.status = "d"
      END IF
      target.dir = direction$
      damage char, target
      COLOR char.col
      LOCATE char.y, char.x
      PRINT char.char
      PLAY "mbmst360o2l64" + char.weapwave
   END IF
END SUB

SUB right (char AS CHARACTER)
   LOCATE char.y, char.x
   PRINT " "
   char.x = char.x + 1
   char.dir = "r"
   IF char.x > 39 OR SCREEN(char.y, char.x) = 219 THEN char.x = char.x - 1
   IF char.status <> "j" AND SCREEN(char.y + 1, char.x) <> 219 THEN char.status = "d"
   COLOR char.col
   LOCATE char.y, char.x
   PRINT char.char
END SUB

SUB save (char AS CHARACTER, scene%)
   WHILE STRIG(0) = -1 AND STRIG(1) = -1 AND STRIG(4) = -1 AND STRIG(5) = -1: WEND
   message "Do you wish to save the game?", 15
   waiter
   IF yesno$(15) <> "y" THEN EXIT SUB
   filenum$ = "-1"
   DO UNTIL VAL(filenum$) >= 0 AND VAL(filenum$) <= 5
      message "Save game as which number (1-5) ?", 15
      filenum$ = INPUT$(1)
   LOOP
   IF filenum$ = "0" THEN
      message " (Save Aborted)", 7
      EXIT SUB
   END IF
   message " **** Saving in Progress ****", 7
   OPEN "killin/" + filenum$ + ".kil" FOR OUTPUT AS #1
   WRITE #1, char.role, ASC(char.align), char.health, char.curhealth, char.strength, char.special, char.curspecial, char.speed, ABS(char.x - 40) + 1, char.y, ASC(char.char), char.col, ASC(char.dir), char.leap, char.foot, char.weapcol, ASC(char.weapl), ASC(char.weapr), ASC(char.weapu), ASC(char.weapwave), scene%
   CLOSE #1
   message " ****   Game     Saved   ****", 15
   file$ = filenum$
   waiter
   message "", 0
END SUB

SUB scorpion.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y AND char.curhealth > 0 THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y AND char.curhealth > 0 THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 AND char.curhealth > 0 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).y = char.y AND target(1).x - 7 >= char.x OR target(1).y = char.y AND target(1).x + 7 <= char.x THEN
            char.specialattack = char.x
            char.status = "s"
         ELSEIF target(1).y < char.y AND target(1).x + 5 >= char.x AND target(1).x - 5 <= char.x THEN
            jump char
            char.status = "j"
         ELSEIF target(1).x < char.x THEN
            left char
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            ram char, target(1)
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.x = target(1).x + 1 AND char.y = target(1).y AND char.curhealth > 0 THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y AND char.curhealth > 0 THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 AND char.curhealth > 0 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            ram char, target(1)
         END IF
      ELSEIF char.status = "d" THEN
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            ram char, target(1)
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = char.attackwait - char.speed * .75
         IF target(1).x < char.specialattack THEN
            LOCATE char.y, char.specialattack
            PRINT " "
            char.specialattack = char.specialattack - 1
         ELSEIF target(1).x > char.specialattack THEN
            LOCATE char.y, char.specialattack
            PRINT " "
            char.specialattack = char.specialattack + 1
         END IF
         LOCATE char.y, char.specialattack
         COLOR char.weapcol
         PRINT char.weapu
         LOCATE char.y, char.x
         COLOR char.col
         PRINT char.char
         IF char.y = target(1).y AND char.specialattack = target(1).x AND target(1).status <> "s" THEN
            PLAY char.weapwave
            jump target(1)
            damage char, target(1)
         ELSEIF char.specialattack = char.x THEN
            PLAY char.weapwave
            char.status = "j"
            jump char
            char.curspecial = char.curspecial - 1
            IF char.curspecial <= 0 THEN char.curhealth = 0
         END IF
      END IF
   END IF
END SUB

SUB scynscatha.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).y < char.y AND target(1).x + 3 >= char.x AND target(1).x - 3 <= char.x OR target(1).y = char.y AND target(1).x = char.x AND char.special >= 15 AND char.curspecial > 0 THEN
            jump char
            char.status = "j"
         ELSEIF target(1).y = char.y AND (target(1).x + 5 <= char.x AND target(1).x + 10 >= char.x OR target(1).x - 10 <= char.x AND target(1).x + 5 >= char.x) AND char.curspecial > 0 THEN
            IF char.curspecial > 0 THEN
               char.curspecial = char.curspecial - 1
               char.oldstatus = char.status
               char.status = "s"
               char.attackwait = char.attackwait - char.speed / 2
               PLAY "mbmst300o2l64" + char.weapwave
               COLOR char.col
               LOCATE char.y, char.x
               IF target(1).x < char.x THEN PRINT "<"
               IF target(1).x > char.x THEN PRINT ">"
               ram char, target(1)
            END IF
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "x" THEN
         char.attackwait = 0
         endattack char
      ELSEIF char.status = "j" THEN
         jump char
         IF char.special >= 15 AND char.foot - char.leap = char.y AND char.curspecial > 1 AND char.x = target(1).x THEN
            IF char.curspecial > 1 THEN
               char.curspecial = char.curspecial - 2
               PLAY "mbmst300o2l64" + char.weapwave
               FOR count = char.y + 1 TO char.foot
                  IF target(1).x = char.x AND target(1).y = count AND target(1).status <> "s" THEN
                     descend target(1)
                     damage char, target(1)
                  END IF
                  IF SCREEN(count, char.x) <> 219 THEN
                     COLOR char.col
                     LOCATE count, char.x
                     IF count MOD 2 = 0 THEN PRINT "/"
                     IF count MOD 2 = 1 THEN PRINT "\"
                  END IF
               NEXT
            END IF
         ELSEIF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "d" THEN
         IF char.foot - char.leap = char.y AND (SCREEN(char.y + 1, char.x) = 92 OR SCREEN(char.y + 1, char.x) = 47) THEN
            char.attackwait = char.attackwait - char.speed / 2
            FOR count = char.y + 1 TO char.foot
               IF SCREEN(count, char.x) <> 219 THEN
                  LOCATE count, char.x
                  PRINT " "
               END IF
            NEXT
         END IF
         descend char
         IF char.x = target(1).x + 1 AND char.y = target(1).y THEN
            char.dir = "l"
            attack char, target()
         ELSEIF char.x = target(1).x - 1 AND char.y = target(1).y THEN
            char.dir = "r"
            attack char, target()
         ELSEIF char.x = target(1).x AND char.y = target(1).y + 1 THEN
            char.dir = "u"
            attack char, target()
         ELSEIF target(1).x < char.x THEN
            left char
         ELSEIF target(1).x > char.x THEN
            right char
         END IF
      ELSEIF char.status = "s" THEN
         char.attackwait = char.attackwait - char.speed / 2
         char.specialattack = char.specialattack + 1
         IF target(1).x < char.x THEN
            left char
            COLOR char.col
            LOCATE char.y, char.x
            PRINT "<"
            ram char, target(1)
         ELSEIF target(1).x > char.x THEN
            right char
            COLOR char.col
            LOCATE char.y, char.x
            PRINT ">"
            ram char, target(1)
         END IF
         IF char.specialattack > 10 THEN
            char.specialattack = 0
            char.status = char.oldstatus
         END IF
      END IF
   END IF
END SUB

SUB slowPRINT (quote AS STRING)
   COLOR 16
   column = POS(0) - 1
   row = CSRLIN
   PRINT quote
   length% = LEN(quote)
   DIM col(length%) AS INTEGER
   FOR count = 1 TO length%
      col(count) = 16
   NEXT
   FOR count = 1 TO length% + 14
      FOR count2 = 1 TO count
         IF count2 > length% THEN EXIT FOR
         IF MID$(quote, count, 1) = " " THEN
            PRINT " ";
            EXIT FOR
         END IF
         IF col(count2) < 31 THEN col(count2) = col(count2) + 1
         COLOR col(count2)
         LOCATE row, count2 + column
         PRINT MID$(quote, count2, 1);
      NEXT
      stopfor .05
   NEXT
   PRINT
END SUB

SUB spiker.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      IF char.status = " " THEN
         IF target(1).x - 1 <= char.x AND target(1).x + 1 >= char.x THEN
            jump char
            char.status = "j"
            ram char, target(1)
         END IF
      ELSEIF char.status = "j" THEN
         jump char
         ram char, target(1)
      ELSEIF char.status = "d" THEN
         descend char
         ram char, target(1)
      END IF
   END IF
END SUB

SUB sprite.control (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      char.attackwait = TIMER + char.speed
      x = char.x
      y = char.y
      IF char.status = "j" THEN
         jump char
         IF char.y = y THEN char.status = "d"
      ELSEIF char.status = "d" THEN
         descend char
         IF char.y = y THEN char.status = "j"
      END IF
      IF char.dir = "l" THEN
         left char
         IF char.x = x THEN char.dir = "r"
         ram char, target(1)
      ELSEIF char.dir = "r" THEN
         right char
         IF char.x = x THEN char.dir = "l"
         ram char, target(1)
      END IF
   END IF
END SUB

SUB statusbox (char AS CHARACTER)
END SUB

SUB stopfor (waitin AS DOUBLE)
   ' Stops the game for a given number of milliseconds.
   halt! = TIMER + waitin
   DO
   LOOP WHILE halt! > TIMER
END SUB

SUB waiter
   IF STRIG(0) = -1 OR STRIG(1) = -1 OR STRIG(4) = -1 OR STRIG(5) = -1 THEN
      WHILE STRIG(0) = -1 OR STRIG(1) = -1 OR STRIG(4) = -1 OR STRIG(5) = -1
      WEND
   END IF
   WHILE STRIG(0) <> -1 AND STRIG(1) <> -1 AND STRIG(4) <> -1 AND STRIG(5) <> -1
   WEND
   WHILE STRIG(0) = -1 OR STRIG(1) = -1 OR STRIG(4) = -1 OR STRIG(5) = -1
   WEND
   WHILE STRIG(0) = -1 OR STRIG(1) = -1 OR STRIG(4) = -1 OR STRIG(5) = -1
   WEND
END SUB

SUB watchman.control (enemy() AS CHARACTER, player AS CHARACTER, bg AS INTEGER)
   'This sub routine is called when a certain event takes place, such as an
   'item received or a main leader defeated.
   SELECT CASE bg
   CASE 10
      DO
         IF player.x < 20 THEN right player
         IF player.x > 20 THEN left player
         descend player
         IF enemy(1).x < 30 THEN right enemy(1)
         IF enemy(1).x > 30 THEN left enemy(1)
         descend enemy(1)
         stopfor .1
      LOOP UNTIL player.x = 20 AND player.y = 19 AND enemy(1).x = 30 AND enemy(1).y = 19
      message "No human could have defeated me.", enemy(1).col
      waiter
      message "I have some help.", player.col
      waiter
      message "So, they have come out of hiding?", enemy(1).col
      waiter
      message "We shall meet again, human....", enemy(1).col
      FOR count = 25 TO 16 STEP -1
         COLOR count
         LOCATE enemy(1).y, enemy(1).x
         PRINT enemy(1).char
         stopfor .1
      NEXT
      FOR count = 19 TO 10 STEP -1
         LOCATE count, 39
         PRINT "  "
      NEXT
      DIM seth AS CHARACTER
      makeplayer seth, "Seth", player.x, player.y
      bind player
      player.x = player.x - 1
      player.y = player.y - 1
      player.char = CHR$(15)
      COLOR seth.col
      LOCATE seth.y, seth.x
      PRINT seth.char
      COLOR player.col
      LOCATE player.y, player.x
      PRINT player.char
      message "Where is he going?", seth.col
      waiter
      message "He has been wounded. He is", player.col
      waiter
      message "returning to his world to recover.", player.col
      waiter
      message "Then.... he is almost invincible.", seth.col
      waiter
      message "How can we hope to defeat him?", seth.col
      waiter
      message "He cannot run forever. Eventually,", player.col
      waiter
      message "he will have to fight you....", player.col
      waiter
      message ".... and then?", seth.col
      waiter
      message "Only the Fates know....", player.col
      player.y = seth.y
      player.x = seth.x
      player.char = seth.char
      bind player
      COLOR player.col
      LOCATE player.y, player.x
      PRINT player.char
      makecharacter enemy(1), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 21
      PLAY "mbmst300o2l64gf"
      message RTRIM$(enemy(1).role) + " was killed.", enemy(1).col
      FOR count = 11 TO 18
         LOCATE count, 39
         PRINT "  "
      NEXT
      makeitem enemy(1), "LifeFilter", 0, enemy(1).x, enemy(1).y
      COLOR enemy(1).col
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
      makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 31
      PLAY "mbmst300o2l64c"
      makecharacter enemy(1), "null", "", 1, 0, 0, 0, 14, 12, 8, "\", "", 0, 0, "", "", "", ""
      COLOR enemy(1).col
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
      player.status = player.oldstatus
      construct 30, 15, 34, 15, 8
   CASE 32
      DO
         IF player.x < 20 THEN right player
         IF player.x > 20 THEN left player
         descend player
         IF enemy(1).x < 30 THEN right enemy(1)
         IF enemy(1).x > 30 THEN left enemy(1)
         descend enemy(1)
         stopfor .1
      LOOP UNTIL player.x = 20 AND player.y = 19 AND enemy(1).x = 30 AND enemy(1).y = 19
      message "You win again.", enemy(1).col
      waiter
      message "Next time....", enemy(1).col
      FOR count = 25 TO 16 STEP -1
         COLOR count
         LOCATE enemy(1).y, enemy(1).x
         PRINT enemy(1).char
         stopfor .1
      NEXT
      FOR count = 19 TO 10 STEP -1
         LOCATE count, 39
         PRINT "  "
      NEXT
      makecharacter enemy(1), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 43
      DO
         IF player.x < 20 THEN right player
         IF player.x > 20 THEN left player
         IF player.x = enemy(1).x THEN left player
         descend player
         IF enemy(1).x > player.x THEN right enemy(1)
         IF enemy(1).x < player.x THEN left enemy(1)
         descend enemy(1)
         stopfor .1
      LOOP UNTIL player.y = 19 AND enemy(1).y = enemy(1).foot
      LOCATE enemy(1).y, enemy(1).x
      COLOR 4
      PRINT enemy(1).char
      message "Could it be....", enemy(1).col
      waiter
      PLAY "mbmst300o2l64gf"
      message "Jack of Hearts was killed.", enemy(1).col
      FOR count = 19 TO 10 STEP -1
         LOCATE count, 39
         PRINT "  "
      NEXT
      makeitem enemy(1), "SoulFilter", 0, enemy(1).x, enemy(1).y
      COLOR enemy(1).col
      LOCATE enemy(1).y, enemy(1).x
      PRINT enemy(1).char
      makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
   CASE 54
      DO
         IF player.x < 20 THEN right player
         IF player.x > 20 THEN left player
         descend player
         IF enemy(1).x < 30 THEN right enemy(1)
         IF enemy(1).x > 30 THEN left enemy(1)
         descend enemy(1)
         stopfor .1
      LOOP UNTIL player.x = 20 AND player.y = 19 AND enemy(1).x = 30 AND enemy(1).y = 19
      message "Another defeat?", enemy(1).col
      waiter
      message "No! I'm just biding my time....", enemy(1).col
      FOR count = 25 TO 16 STEP -1
         COLOR count
         LOCATE enemy(1).y, enemy(1).x
         PRINT enemy(1).char
         stopfor .1
      NEXT
      FOR count = 19 TO 10 STEP -1
         LOCATE count, 39
         PRINT "  "
      NEXT
      makecharacter enemy(1), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      makecharacter enemy(2), "", "", 0, 0, 0, 0, -1, -1, 0, "", "", 0, 0, "", "", "", ""
      bg = bg + 1
      player.x = 2
      save player, bg
      CLS 0
      LOCATE 1, 1
      slowPRINT "Killin' "
      stopfor 1
      slowPRINT " Act II"
      waiter
      CHAIN "killin\killina2.bas"
   END SELECT
END SUB

SUB water.control (char AS CHARACTER, target() AS CHARACTER)
   IF char.status = " " OR char.status = "j" OR char.status = "d" THEN
      IF STRIG(1) = -1 AND STRIG(5) = -1 THEN
         IF char.curspecial > 0 THEN
            IF char.status = " " THEN jump char
            char.curspecial = char.curspecial - 1
            char.status = "s"
            COLOR 15
            LOCATE 5, 24
            PRINT USING "##"; char.curspecial
            PLAY "mbmst300o2l64" + char.weapwave
            COLOR 1
            LOCATE char.y, char.x
            PRINT ""
            char.specialattack = char.y
         END IF
      END IF
   ELSEIF char.status = "s" THEN
      waterfall char, target()
   END IF
END SUB

SUB waterfall (char AS CHARACTER, target() AS CHARACTER)
   IF TIMER > char.attackwait THEN
      IF SCREEN(char.y + 1, char.x) = 219 AND char.specialattack < char.y THEN
         LOCATE char.specialattack, char.x
         PRINT " "
         IF char.specialattack < char.y THEN char.specialattack = char.specialattack + 1
         FOR count = char.specialattack TO char.y STEP 1
            FOR enemy = 1 TO UBOUND(target)
               IF count = target(enemy).y AND char.x = target(enemy).x THEN
                  jump target(enemy)
                  damage char, target(enemy)
               END IF
            NEXT
            COLOR 1
            LOCATE count, char.x
            PRINT ""
         NEXT
         IF char.x - 2 > 0 THEN
            IF SCREEN(char.y, char.x - 2) <> 219 THEN
               LOCATE char.y, char.x - 2
               PRINT "\"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.x - 2 = target(enemy).x THEN
                     left target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
         END IF
         IF char.x - 1 > 0 THEN
            IF SCREEN(char.y, char.x - 1) <> 219 THEN
               LOCATE char.y, char.x - 1
               PRINT "\"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.x - 1 = target(enemy).x THEN
                     left target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
         END IF
         IF char.x + 1 < 41 THEN
            IF SCREEN(char.y, char.x + 1) <> 219 THEN
               LOCATE char.y, char.x + 1
               PRINT "/"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.x + 1 = target(enemy).x THEN
                     right target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
         END IF
         IF char.x + 2 < 41 THEN
            IF SCREEN(char.y, char.x + 2) <> 219 THEN
               LOCATE char.y, char.x + 2
               PRINT "/"
               FOR enemy = 1 TO UBOUND(target)
                  IF char.y = target(enemy).y AND char.x + 2 = target(enemy).x THEN
                     right target(enemy)
                     damage char, target(enemy)
                  END IF
               NEXT
            END IF
         END IF
      ELSEIF SCREEN(char.y + 1, char.x) = 219 AND char.specialattack = char.y THEN
         IF char.x - 2 > 0 THEN
            IF SCREEN(char.y, char.x - 2) <> 219 THEN
               LOCATE char.y, char.x - 2
               PRINT " "
            END IF
         END IF
         IF char.x - 1 > 0 THEN
            IF SCREEN(char.y, char.x - 1) <> 219 THEN
               LOCATE char.y, char.x - 1
               PRINT " "
            END IF
         END IF
         IF char.x + 1 < 41 THEN
            IF SCREEN(char.y, char.x + 1) <> 219 THEN
               LOCATE char.y, char.x + 1
               PRINT " "
            END IF
         END IF
         IF char.x + 2 < 41 THEN
            IF SCREEN(char.y, char.x + 2) <> 219 THEN
               LOCATE char.y, char.x + 2
               PRINT " "
            END IF
         END IF
         char.specialattack = 0
         LOCATE char.y, char.x
         COLOR char.col
         PRINT char.char
         char.status = " "
      ELSE
         char.y = char.y + 1
         FOR count = char.specialattack TO char.y STEP 1
            FOR enemy = 1 TO UBOUND(target)
               IF count = target(enemy).y AND char.x = target(enemy).x THEN
                  jump target(enemy)
                  damage char, target(enemy)
               END IF
            NEXT
            COLOR 1
            LOCATE count, char.x
            PRINT ""
         NEXT
      END IF
      char.attackwait = TIMER + .1
   END IF
END SUB

SUB wind.control (char AS CHARACTER, target() AS CHARACTER)
   IF char.status = " " OR char.status = "j" OR char.status = "d" THEN
      IF STRIG(1) = -1 AND STRIG(5) = -1 THEN
         IF STICK(0) > dirright THEN
            char.dir = "r"
         ELSEIF STICK(0) < dirleft THEN
            char.dir = "l"
         ELSEIF STICK(1) < dirup THEN
            char.dir = "u"
         END IF
         IF char.curspecial > 0 THEN
            char.curspecial = char.curspecial - 1
            char.status = "s"
            COLOR 15
            LOCATE 5, 24
            PRINT USING "##"; char.curspecial
            PLAY "mbmst300o2l64" + char.weapwave
            flight char, target()
         END IF
      END IF
   ELSEIF char.status = "s" THEN
      flight char, target()
   END IF
END SUB

FUNCTION yesno$ (col%)
   yesno$ = "y"
   COLOR col%
   message CHR$(16) + " Yes                 No", 15
   WHILE STRIG(0) = 0 AND STRIG(1) = 0 AND STRIG(4) = 0 AND STRIG(5) = 0
      IF STICK(0) < dirleft THEN
         yesno$ = "y"
         LOCATE 7, 2
         PRINT CHR$(16)
         LOCATE 7, 20
         PRINT " "
      ELSEIF STICK(0) > 70 THEN
         yesno$ = "n"
         LOCATE 7, 2
         PRINT " "
         LOCATE 7, 20
         PRINT CHR$(16)
      END IF
   WEND
   message "", 0
END FUNCTION

